#ifndef __NETSTRUCTDEF_H__
#define __NETSTRUCTDEF_H__

#include <string>
#include <vector>
#include <queue>
#include <map>

#define MAX_HOST_LEN				128
#define MAX_SERVER_NAME_LEN			32
#define MAX_USER_NAME_LEN			32
#define MAX_PASSWORD_LEN			32

#define MAX_FILENAME_LEN			255

#define MAX_LEN                     128
#define MAX_LEN_PRO                 512

#define ASSERT_HANDLE(x)  do{ if(x == INVALID_HANDLE_VALUE) return FALSE; }while(0)

#define ROOTNAME "root"
#define ADMINNAME "admin"

/***************************̨******************************/
#define PTZ_STOP			0	/*	ֹ̨ͣ*/

#define TILT_UP				1	/* ̨Speedٶת */
#define TILT_DOWN			2	/* ̨Speedٶת */
#define PAN_LEFT			3	/* ̨Speedٶת */
#define PAN_RIGHT			4	/* ̨Speedٶת */


#define PT_LEFT_UP			5	/* ̨Speedٶ */
#define PT_LEFT_DOWN		6	/* ̨Speedٶ */
#define PT_RIGHT_UP			7	/* ̨Speedٶ */
#define PT_RIGHT_DOWN		8	/* ̨Speedٶ */

#define PTZ_ZOOM_IN			9 	/* ٶSpeed(ʱ) */
#define PTZ_ZOOM_OUT		10	/* ٶSpeedС(ʱС) */
#define FOCUS_NEAR			11	/* ٶSpeedǰ */
#define FOCUS_FAR			12	/* ٶSpeed */
#define IRIS_OPEN			13	/* ȦٶSpeed */
#define IRIS_CLOSE			14	/* ȦٶSpeedС */


#define GOTO_PRESET 		15	/* תԤõ */ 

#define CLE_PRESET			16	/* Ԥõ */

#define SET_PRESET			17	/* Ԥõ */

#define PAN_AUTO			18	/* ̨SpeedٶѲ */
#define PAN_AUTO_STOP		19	/* Ѳֹͣ */

#define PTZ_SET_PATTER		20				//ûɨ
#define PTZ_SAVE_PATTER		21				//滨ɨ
#define PTZ_RUN_PATTER		22				//лɨ
#define PTZ_SET_AREASCAN_START  23			//ɨ
#define PTZ_SET_AREASCAN_END	24			//ɨյ
#define PTZ_RUN_AREASCAN	25				//ɨ
#define PTZ_RUN_AUTOCRUISE	26				//ԶѲ·N
#define PTZ_KEEP_WATCH_ON	27				//λ
#define PTZ_KEEP_WATCH_OFF  28				//رλ
#define PTZ_OPEN_LOW_LIGHT  29				// low  lux  
#define PTZ_OPEN_COMMON_LIGHT	30			// common  lux  
#define PTZ_CAMERA_RESET	31				//
#define PTZ_SET_ZOOM_SPEED  32				//ñ佹ٶ
#define PTZ_SET_FOCUS_SPEED		33			//þ۽ٶ
#define PTZ_AUTO_FOCUS_ON	34				//Զ۽
#define PTZ_AUTO_FOCUS_OFF  35				//رԶ۽
#define PTZ_AUTO_IRIS_ON	36				//ԶȦ
#define PTZ_AUTO_IRIS_OFF	37				//رԶȦ
#define PTZ_BACKLIGHT_ON	38				//򿪱ⲹ
#define PTZ_BACKLIGHT_OFF	39				//رձⲹ
#define PTZ_SET_SHUTTER_SPEED	40			//ÿʱ
#define PTZ_CAMERA_WDR_ON	41				//򿪿̬
#define	PTZ_CAMERA_WDR_OFF	42				//رտ̬
#define	PTZ_CAMERA_DZOOM_ON 43				//ֱ䱶
#define	PTZ_CAMERA_DZOOM_OFF	44			//رֱ䱶
#define	PTZ_CAMERA_IMGE_MIRROR_ON	45		//
#define	PTZ_CAMERA_IMGE_MIRROR_OFF	46		//رվ
#define PTZ_CAMERA_IMGE_FLIP_ON		47		//ת
#define	PTZ_CAMERA_IMGE_FLIP_OFF	48		//رշת
#define	PTZ_CAMERA_IMGE_FREEZE_ON	49		//涳
#define	PTZ_CAMERA_IMGE_FREEZE_OFF	50		//رջ涳

#define PTZ_CAMERA_WHITE_BALANCE_AUTO	51	//Զƽ
#define PTZ_CAMERA_WHITE_BALANCE_MANUAL 52	//ֶƽ
#define PTZ_CAMERA_IMAGE_RED_VALUE	53		//ֶɫֵ
#define PTZ_CAMERA_IMAGE_BLUE_BALUE 54		//ֶɫֵ

#define PTZ_CAMERA_COLOR_TO_BLACK_BW	55	//ڰ
#define PTZ_CAMERA_COLOR_TO_BLACK_AUTO	56	//Զ
#define PTZ_CAMERA_COLOR_TO_BLACK_COLOR	57	//ɫ
#define PTZ_KEEP_WATCH_CONF		58			//ȴʱ
#define PTZ_CAMERA_AGC			59
#define PTZ_CAMERA_LAGER		100
/******************************************************************/

enum PROTOCOL
{
	PROTOCOL_RTSP_UDP   = 0,	//ƵЭ
	PROTOCOL_RTSP_TCP   = 1,
	PROTOCOL_UDP		= 2,
};

typedef struct _STREAM_INFO
{
	unsigned short	videoCoder;		//Ƶ뷽ʽ
	unsigned short	audioCoder;		//Ƶ뷽ʽ
	unsigned short	frameRate;		//֡
	unsigned short	bitRate;		//
	unsigned short	nWidth;			//Ƶ
	unsigned short	nHeight;		//Ƶ
	unsigned short	frameType;		//H264֡ 涨
	unsigned short  isKeyFrame;		//ǷΪؼ֡
	unsigned short	type;			//ͣ0 Ƶ 1 Ƶ  2ͷϢ
	unsigned short	res;			
	long			nStamp;			// ʱϢλ
}STREAM_INFO;

//ݻص
typedef struct
{ 
	long nWidth;	 // λΪأƵΪ0
	long nHeight;	// ߣλΪأƵΪ0
	long nStamp;	 // ʱϢλ
	long nType;		//ͣ±
	long nFrameRate;// ʱͼ֡
}FRAME_INFO; 

//ص

//豸Ϣص
typedef void(CALLBACK *MessageCallBack)(HANDLE handle, long msgType,  void*lpStruct, void *lpContext);

//Ƶݻص
typedef void ( CALLBACK* AVDataCallBack )( HANDLE handle, char* pBuf, long nSize, STREAM_INFO* pBufInfo, void *lpContext  );


//Ƶʾص
typedef void ( CALLBACK* DrawCallback )( HANDLE hHandle, HDC hDC, void *lpContext );

//ص
typedef void ( CALLBACK * DecodeCallBack ) ( HANDLE hHandle, char * py, char*pu, char*pv,int ystride,int uvstride, FRAME_INFO * pFrameInfo, void* lpContext  );

typedef struct _CHANNEL_CLIENTINFO
{	
	char host[MAX_HOST_LEN];
	DWORD port;							
	unsigned long channel;              //ͨ,
	char username[MAX_USER_NAME_LEN];   //û
	char password[MAX_PASSWORD_LEN];    //

	HWND  hVideoWnd;					//Ƶھ

	BYTE  protocol;						//Э  PROTOCOL
	BYTE  notPlay;						//Ϊ0ʱ, ʾģ,ΪȡƵĲ
	BYTE  tryRGBfirst;					//Ƶʾʱ,ȳʹRGB,ĬʹYUV
	BYTE  model;						//豸ͺ,  0 IPC 1 DVR-NVR 2.XVR
	BYTE  tryOverlay;					//Ƿʹoverlay,ʱЧ
	BYTE  res;
	short webport;						//WEB ˿,Ĭ80
					
	COLORREF nColorKey;					//color key
	                                     
	void *lpContext;					//صԶ
	MessageCallBack		msgFun;			//Ϣص

}CHANNEL_CLIENTINFO;


///////////////////////////////////////////////////////////////////////////////
// ط

#define CMD_NVR_QUERYRECFILE			0x63 + 0x10000  // ͻ֪ͨ¼ѯ¼ļ
#define CMD_NVR_DOWNLOADRECFILE			0x64 + 0x10000  // ͻ֪ͨ¼¼ļ
#define	CMD_NVR_QUERY_STOP				0x57 + 0x10000	// ֹ֪ͨͣѯ
#define CMD_NVR_REMOTEFILE				0x66 + 0x10000  // ¼¼ļͻ
#define CMD_NVR_REMOTEFILEEND			0x67 + 0x10000  // ¼¼ļͻˣ֪ͨ
#define CMD_NVR_QUERY_DEVICE            0x68 + 0x10000  // ѯ豸Զ̲ѯ豸ʱȲѯԶ豸Ȼѡ豸ڽвѯļ
#define CMD_NVR_DEVICE_DATA             0x69 + 0x10000  // ѯ豸
#define CMD_NVR_QUERY_DEVICE_STOP       0x6A + 0x10000  // 豸ѯ

#define CMD_NVR_BASE				0x10000			//nvr׼ֵ

#define CMD_QUERYRECFILE_STATUS			(CMD_NVR_BASE + 0x62)	//ͻ֪ͨ¼ѯ¼ļ״̬
#define CMD_QUERYRECFILE			(CMD_NVR_BASE + 0x63)	//ͻ֪ͨ¼ѯ¼ļ
#define CMD_DOWNLOADRECFILE			(CMD_NVR_BASE + 0x64)	//ͻ֪ͨ¼¼ļ
#define	CMD_QUERY_STOP				(CMD_NVR_BASE + 0x57)	//ֹ֪ͨͣѯ
#define CMD_REMOTEFILESTATUS				(CMD_NVR_BASE + 0x6B)	//¼¼ļͻ״̬
#define CMD_REMOTEFILEENDSTATUS			(CMD_NVR_BASE + 0x6C)	//¼¼ļͻˣ֪ͨ״̬
#define CMD_REMOTEFILE				(CMD_NVR_BASE + 0x66)	//¼¼ļͻ
#define CMD_REMOTEFILEEND			(CMD_NVR_BASE + 0x67)	//¼¼ļͻˣ֪ͨ
#define CMD_NVR_DOWNLOADRECFILE_COMPLETE	(CMD_NVR_BASE + 0x90) //ؽ
//#define CMD_REMOTEFILE				0x66			//¼¼ļͻ
//#define CMD_REMOTEFILEEND			0x67			//¼¼ļͻˣ֪ͨ
#define CMD_QUERY_DEVICE            0x68			//ѯ豸Զ̲ѯ豸ʱȲѯԶ豸Ȼѡ豸ڽвѯļ
#define CMD_DEVICE_DATA             0x69			//ѯ豸
#define CMD_QUERY_DEVICE_STOP       0x6A			//豸ѯ

#define CMD_PLAYRECFILE_HEADER_REQ			0x165		//ļͷ
#define CMD_PLAYRECFILE_SEEK_REQ			0x265		//ط¼λת
#define CMD_PLAYRECFILE_PLAY_REQ			0x365		//طż
#define CMD_PLAYRECFILE_PAUSE_REQ			0x465		//ط¼ͣ
#define CMD_PLAYRECFILE_STOP_REQ			0x565		//ط¼ֹͣ
#define CMD_PLAYRECFILE_STEP_REQ	        0x665		//֡ظ
#define CMD_PLAYRECFILE_HEADER_RES			0x1165		//ظļͷ
#define CMD_PLAYRECFILE_SEEK_RES			0x1265		//ط¼λת
#define CMD_PLAYRECFILE_PLAY_RES			0x1365		//طż
#define CMD_PLAYRECFILE_PAUSE_RES			0x1465		//ط¼ͣ
#define CMD_PLAYRECFILE_STOP_RES			0x1565		//ط¼ֹͣ

#define CMD_PLAYRECFILE_DATA				0x300		//Ƶ
#define CMD_PLAYERCFILE_KEEPALIVE			0xeeee		// 

struct STRING
	{
		enum
		{
			
			IDS_ABOUT = 0,                    
			IDS_SOFTWARENAME,               
			IDS_VERSION,                  
			IDS_COPYRIGHT,  
			IDS_APP_TITLE,
			//maindlg
			IDS_NVRMAIN_WND,
			IDS_NVRMAIN_CH,
			IDS_NVRMAIN_PLAY,
			IDS_NVRMAIN_REC,
			IDS_NVRMAIN_CAPTRUE,
			IDS_NVRMAIN_PLAYALL,
			IDS_NVRMAIN_STOPALL,
			IDS_NVRMAIN_FULLSCREEN,
			IDS_NVRMAIN_SCREENTYPE,
			IDS_NVRMAIN_ONESCREEN,
			IDS_NVRMAIN_FOURSCREEN,
			IDS_NVRMAIN_SIXSCREEN,
			IDS_NVRMAIN_EIGHTSCREEN,
			IDS_NVRMAIN_NINESCREEN,
			IDS_NVRMAIN_SIXTEENSCREEN,
			IDS_NVRMAIN_TWENTYFIVESCREEN,
			IDS_NVRMAIN_THIRTYSIXSCREEN,
			IDS_NVRMAIN_LIVEVIDEO,
			IDS_NVRMAIN_CONFIGSET,
			IDS_NVRMAIN_LOCALSET,
			IDS_NVRMAIN_LOGOUT,
			//leftconfigset
			IDS_CONFIGSET_SYSTEM,
			IDS_CONFIGSET_COMMON,
			IDS_CONFIGSET_NET,
			IDS_CONFIGSET_USER,
			IDS_CONFIGSET_EMAIL,
			IDS_CONFIGSET_CHANNEL,
			IDS_CONFIGSET_CHSETUP,
			IDS_CONFIGSET_ENCODE,
			IDS_CONFIGSET_RECORD,
			IDS_CONFIGSET_RECSETUP,
			IDS_CONFIGSET_MAINTAIN,
			IDS_CONFIGSET_DISK,
			IDS_CONFIGSET_DEVICEMANAGE,
			IDS_CONFIGSET_DEFAULT,
			IDS_CONFIGSET_LOG,
			IDS_CONFIGSET_VERSION,
			//common
			IDS_COMBOX_TIMEZONE,
			IDS_COMMON_SERVER,
			IDS_COMMON_SNTP_SERVER,
			IDS_COMMON_TIMEZONE,
			IDS_COMMON_SYSTEMTIME,
			IDS_COMMON_DEFAULTLANGUAGE,
			IDS_COMMON_RECODEMODE,
			IDS_COMMON_DEVICEID,
			IDS_COMMON_DEVICENAME,
			IDS_COMMON_VIDEOSTANDARD,
			IDS_COMMON_RESOLUTION,
			IDS_COMMON_STANDBYTIME,
			IDS_COMMON_MINUTE,
			IDS_COMBOX_DEFAULTLANGUAGE,
			IDS_COMBOX_RECORDMODE,
			IDS_COMBOX_VIDEOSTANDARD,
			IDS_COMBOX_RESOLUTION,
			
			
			//net
			IDS_NET_NETCARD,
			IDS_NET_IP,
			IDS_NET_MASK,
			IDS_NET_GATEWAY,
			IDS_NET_TCPPORT,
			IDS_NET_RTSPPORT,
			IDS_NET_HTTPPORT,
			IDS_NET_DNS1,
			IDS_NET_DNS2,
			IDS_NET_BROADCAST,
			IDS_NET_MAC,
			IDS_NET_INVALID_IP,
			IDS_NET_INAVLID_GATEWAY,
			IDS_NET_INVALID_DNSIP,
			IDS_NET_INVALID_BROADCAST,
			IDS_NET_INVALID_NETMASK,
			IDS_NET_REPEATPORT,
			IDS_NET_VALID_EXTHTTP,
			IDS_NET_VALID_HTTP,
			IDS_NET_VALID_RTSP,
			IDS_NET_VALID_TCP,
			IDS_NET_NOT_MATCH0,
			IDS_NET_NOT_MATCH1,
			IDS_NET_NOT_SEGMENT,
			IDS_NET_IPMODIFY,
			IDS_NET_MODIFY_PORT,
			IDS_NET_IPANDPORTCHANGE,
			IDS_COMBOX_NETCARD,

			//user
			IDS_USER_EXISTUSER,
			IDS_USER_OPERATE,
			IDS_USER_USER,
			IDS_USER_OLDPASSWORD,
			IDS_USER_PASSWORD,
			IDS_USER_CONFIRM,
			IDS_USER_NOT_MATCH_PWD,
			IDS_USER_DELETE_FAIL,
			IDS_USER_ADD_FAIL,
			IDS_CAMERA_MODIFY_FAIL,
			IDS_USER_AUTHEN_FAIL,
			IDS_USER_ENTER_USER,
			IDS_USER_ENTER_PWD,
			IDS_USER_REENTER_PWD,
			IDS_USER_AUTHEN_PSW,
			IDS_USER_NO_USER,
			IDS_USER_ADD_LIMIT,
			IDS_USER_ADMIN_NO_MODIFY,
			IDS_USER_NOT_LEVEL,
			
			IDS_COMBOX_OPERATE,

			IDS_CHECK_RECORD_BACKUP, 
			IDS_CHECK_COMMON_SET,
			IDS_CHECK_NET_SET,
			IDS_CHECK_PTZ_SET,
			IDS_CHECK_RESTORE_DEFAULT,
			IDS_CHECK_ADDMODIFY_USER,
			IDS_CHECK_FONRT_SET,                          
			IDS_CHECK_PTZ,                   
			IDS_CHECK_SHOW_SET,              
			IDS_CHECK_DISK_FORMAT,   
			IDS_CHECK_UPGRATE,               
			IDS_CHECK_PREVIEW_SET,           
			IDS_CHECK_MANUL_MAINTAIL,        
			IDS_CHECK_DEVICEMANAGE,   
			//chsetup
			IDS_CHSETUP_CHANNEL,
			IDS_CHSETUP_VENDERTYPE,
			IDS_CHSETUP_PREVIEWSTREAM,
			IDS_CHSETUP_PROTOCOL,
			IDS_CHSETUP_USERNAME,
			IDS_CHSETUP_PASSWORD,
			IDS_CHSETUP_IP,
			IDS_CHSETUP_PORT,
			IDS_CHSETUP_ENABLE,
			IDS_CHSETUP_SEARCH_FAIL,
			IDS_COMBOX_ALLCHANNEL,
			IDS_COMBOX_ALLCHANNELFOUR,
			IDS_COMBOX_ALLCHANNELEIGHT,
			IDS_COMBOX_ALLCHANNELNINE,
			IDS_COMBOX_ALLCHANNELTWENTYFIVE,
			IDS_COMBOX_ALLCHANNELTWENTYFIVE1,
			IDS_COMBOX_ALLCHANNELTHIRTYSIX,
			IDS_COMBOX_VENDERTYPE,
			IDS_COMBOX_PREVIEWSTREAM,
			IDS_COMBOX_PROTOCOL,
			IDS_LIST_NO,
			IDS_LIST_DEVICETYPE,
			IDS_LIST_CHANNELNO,
			//encode
			IDS_ENCODE_MAINSTREAM,
			IDS_ENCODE_SUBSTREAM,
			IDS_ENCODE_CHANENEL,
			IDS_ENCODE_ENCODEMODE,
			IDS_ENCODE_RESOLUTION,
			IDS_ENCODE_FRAMERATE,
			IDS_ENCODE_STREAMVALUE,
			IDS_ENCODE_BITRATE_RANGE,
			IDC_IDS_COMBOX_CHANNELTHIRTYSIX,
			IDC_IDS_COMBOX_CHANNELTWENTYFIVE1,
			IDC_IDS_COMBOX_CHANNELTWENTYFIVE,
			IDS_COMBOX_CHANNEL,
			IDS_COMBOX_CHANNELFOUT,
			IDS_COMBOX_CHANNELEIGHT,
			IDS_COMBOX_CHANNELNINE,
			IDS_COMBOX_FRAMERATE,
			//recsetup
			IDS_RECSETUP_CHANNEL,
			IDS_RECSETUP_ENABLERECORD,
			IDS_RECSETUP_WEEK,
			IDS_RECSETUP_ALLDAY,
			IDS_RECSETUP_SCHEDULE1,
			IDS_RECSETUP_SCHEDULE2,
			IDS_RECSETUP_SCHEDULE3,
			IDS_RECSETUP_SCHEDULE4,
			IDS_COMBOX_WEEK,
			IDS_RECSETUP_SETTIME,
			IDS_RECSETUP_INVALIDSCHEDULE,
			//disk
			IDS_DISK_USING,
			IDS_DISK_NORMAL,
			IDS_DISK_UNMONUT,
			IDS_DISK_USB,
			IDS_DISK_SATA,
			IDS_DISK_CONFIRM_FORMAT,
			IDS_DISK_FORMAT_FAIL,
			IDS_LIST_STATE,
			IDS_LIST_TOTALCAPACITY,
			IDS_LIST_RESIDUALCAPACITY,
			//version
			IDS_VERSION_SERIALNO,
			IDS_VERSION_MODELNO,
			IDS_VERSION_VERSION,
			IDS_VERSION_DATE,
			//default
			IDS_DEFAULT_SELETALL,
			IDS_DEFAULT_GENERALSETTING,
			IDS_DEFAULT_USERMANEGE,
			IDS_DEFAULT_CHANNELCONFIG,
			IDS_DEFAULT_RECORDSETUP,
			IDS_DEFAULT_REBOOT_TIP,

			//disk manage
			IDS_DEVICEMANAGE_UPGRADEPATH,
			IDS_DEVICEMANEGE_REBOOT,
			IDS_DEVICEMANAGE_UPGRADE,

			//log
			IDS_LOG_TYPE,
			IDS_LOG_STARTTIME,
			IDS_LOG_ENDTIME,
			IDS_LIST_TIME,
			IDS_LIST_EVENT,
			IDS_LIST_OPERATOR,
			IDS_COMBOX_TYPE,
			IDS_LOG_QUERY,
			IDS_LOG_CLEAR,
			IDS_LOG_QUERY_FAIL,
			IDS_LOG_CLEAR_FAIL,
			IDS_LOG_REBOOT,

			//localset
			IDS_LOCALSET_STORAGE,
			IDS_LOCALSET_RECORDPATH,
			IDS_LOCALSET_CUTDOWNDOWNLOAD,
			IDS_LOCALSET_SNAPSHOTPATH,
		//	IDS_LOCALSET_VIDEOBUFFER,
			IDS_LOCALSET_VIDEONUM,
			IDS_LOCALSET_BROWSE,

			//login
			IDS_LOGIN_USERNAME,
			IDS_LOGIN_PSW,
			IDS_LOGIN_LANGUAGE,
			IDS_LOGIN_RM,
			IDS_LGOIN_ALLCHANNEL,
			IDS_LOGIN_LOGIN,
			IDS_LOGIN_RESET,
			IDS_LOGIN_LOG_FAIL,
			IDS_LOGIN_CONNECT_FAIL,
			IDS_LOGIN_VIOD_USER,


			IDS_NVR_SAVE,
			IDS_NVR_SERACH,
			IDS_NVR_FORMAT,
			
			IDS_COMM_GET_FAIL,
			IDS_COMM_OK,
			IDS_COMM_CALCEL,
			IDS_COMM_WARNING,
			IDS_COMM_SAVE_FAIL,
			IDS_COMM_SAVE_SUCCESS,

			IDS_MAINTENANCE_RESTORE_FAIL,

			IDS_STREAM_CHANGE,
			IDS_CODE_STREAM_01,
			IDS_CODE_STREAM_02,
			IDS_NVR_EXIT_MAX,
			IDS_NVR_MD_SETAREA,
			IDS_NVR_MD_SAVEQUIT,

			IDS_UPGRATE_UPLOAD_FAIL,
			IDS_UPGRATE_UPLOAD_SUCESS,
			IDS_UPGRATE_INVALID_FILENAME,

			//motion
			IDS_MOTION_MOTION,
			IDS_MOTION_CHECK_SWITCHLINKAGE,
			IDS_MOTION_SENSITIVITY,
			IDS_MOTION_CHECK_BUZZERON,
			IDS_MOTION_BUZZERTION,
			IDS_MOTION_CHECK_RECODRCHANNEL,
			IDS_MOTION_RECORDTIME,
			IDS_MOTION_COMB_SENSITIVITY,
			IDS_MOTION_SEC,
			IDS_DEFAULT_ALARM_INPUT,
			IDS_NET_DHCP,
			IDS_UPGRADE_BUFFER,

			IDS_DEFAULT_NET,
			IDS_TIME_MANUALLY,
			IDS_TIME_COMPUTER,

			//playback
			IDS_PLAYBACK_CONNECT_FAIL,
			IDS_PLAYBACK_SEARCH_FAIL,
			IDS_PLAYBACK_WINDOW,
			IDS_PLAYBACK_ALARMTYPE,
			IDS_PLAYBACK_FILE_TYPE,
			IDS_PLAYBACK_CHANNEL_SELECT,
			IDS_PLAYBACK_SEARCH,
			IDS_PLAYBACK_TODAY,
			IDS_PLAYBACK_LASTYEAR,
			IDS_PLAYBACK_LASTMONTH,
			IDS_PLAYBACK_NEXTYEAR,
			IDS_PLAYBACK_NEXTMONTH,
			IDS_PLAYBACK_STR_YEAR,
			IDS_PLAYBACK_STR_MONTH,
			IDS_PLAYBACK_STR_DAY,
			IDS_PLAYBACK_STR_SUN,
			IDS_PLAYBACK_STR_MON,
			IDS_PLAYBACK_STR_TUE,
			IDS_PLAYBACK_STR_WED,
			IDS_PLAYBACK_STR_THU,
			IDS_PLAYBACK_STR_FRI,
			IDS_PLAYBACK_STR_SAT,

			IDS_SHOT_FAILED_CREATE_PATH_FAILED,
			IDS_SHOT_PICTURE_FAILED,
			IDS_SHOT_PICTURE_SUCCESS_AND_PICTURE_SAVE_THE_PATH,
			IDS_CUT_FAILED,
			IDS_BACKPLAY_BACKPLAY,
			IDS_BAKCPALY_STR_QUERYING,

			IDS_STR_LOACL_QUERY,
			IDS_STR_REMOTE_QUERY,
			IDS_STR_STEP,
			IDS_STR_PAUSE,
			IDS_STR_REC_CUT,
			IDS_STR_STOP,

			IDS_PLAYBACK_RECONNECT_SEARCH,

			//LOG
			//IDS_LOG_QUERYING,
			IDS_LOG_NOLOG,
			/*IDS_LOG_VERSION,
			IDS_LOG_STATE,
			IDS_LOG_DEFAULTPRAMA,
			IDS_LOG_UPGRATE,
			IDS_LOG_USER,
			IDS_LOG_LOG,
			IDS_LOG_SYSTEM,
			IDS_LOG_NET,
			IDS_LOG_PTZ_CONFIG,
			IDS_LOG_PTZ_CTRL,
			IDS_LOG_CRUISE_CONFIG,
			IDS_LOG_PREVIEW_CONFIG,
			IDS_LOG_VO_BINGING,
			IDS_LOG_CREATE_PB,
			IDS_LOG_DESTROY_PB,
			IDS_LOG_CONTROL_PB,
			IDS_LOG_CHANNEL_CONFIG,
			IDS_LOG_ENCODER_CONFIG,
			IDS_LOG_RECORD_CONFIG,
			IDS_LOG_RECORD_QUERY,
			IDS_LOG_MONITOR_CONFIG,
			IDS_LOG_WARIN_CONFIG,
			IDS_LOG_HIDE_CONFIG,
			IDS_LOG_CONFIG_LOST,
			IDS_LOG_OSD_CONFIG,
			IDS_LOG_COMMON_CONFIG,
			IDS_LOG_OVERLAY_CONFIG,
			IDS_LOG_DISK,
			IDS_LOG_SYS_TIME,
			IDS_LOG_SERIAL_CONFIG,
			IDS_LOG_PIC_ATTR_CONFIG,
			IDS_LOG_TV_CONFIG,
			IDS_LOG_CALLBACK,
			IDS_LOG_DEL_LIST,
			IDS_LOG_MANUAL_RECORDER,
			IDS_LOG_MANUAL_WAIN_IN,
			IDS_LOG_MANUAL_WAIN_OUT,
			IDS_LOG_RECORDE_BACKUP,
			IDS_LOG_SHUTDOWN_SYS,
			IDS_LOG_AUDIO_CONFIG,
			IDS_LOG_PLATFORM_CONFIG,
			IDS_LOG_CHANGE_REMOTE_IP,
			IDS_LOG_DDNS_CONFIG,
			IDS_LOG_CAPABILITY,
			IDS_LOG_NETLINK_CONFIG,
			IDS_LOG_UPNP_CONFIG,
			IDS_LOG_SCREEN_CONFIG,
			IDS_LOG_CRUISE_OPRATE,
			IDS_LOG_PRESET_SET,
			IDS_LOG_PRESET_TOUR,
			IDS_LOG_BUTTON,*/

			// NEW LOG DEF
			IDS_USER_CLEAR_ALLLOG,          //м¼
			IDS_SYSTEM_LOG_OPEN_DEVICE,     //
			IDS_SYSTEM_LOG_CLOSE_DEVICE,    //ػ
			IDS_SYSTEM_LOG_RESTART_DEVICE,  //
			IDS_SYSTEM_LOG_SYSTEM_UPDATE,   //ϵͳ
			IDS_SYSTEM_LOG_RESTORE,         //ָ

			IDS_USER_LOG_USERLOGIN,       //û¼
			IDS_USER_LOG_USERLOGOUT,      //ûע
			IDS_USER_LOG_ADDUSER,         //û
			IDS_USER_LOG_DELETEUSER,      //ɾû
			IDS_USER_LOG_MODIFYUSERINFO,  //޸ûϢ
			IDS_USER_LOG_ADDUSERGROUP,    //û
			IDS_USER_LOG_DELETEUSERGROUP, //ɾû
			IDS_USER_LOG_MODIFYUSERGROUP, //޸ûϢ

			IDS_CONFIG_LOG_COMMCFG,       //ͨ
			IDS_CONFIG_LOG_RESCOM,    //ͨûָĬ
			IDS_CONFIG_LOG_ENCODE,     //
			IDS_CONFIG_LOG_RESENCODE, //ûָĬ
			IDS_CONFIG_LOG_RECORDVIDEO,   //¼
			IDS_CONFIG_LOG_RESRECORD, //¼ûָĬ
			IDS_CONFIG_LOG_NET,        //
			IDS_CONFIG_LOG_RESNET,//ûָĬ
			IDS_CONFIG_LOG_ALARM,     //汨
			IDS_CONFIG_LOG_RESALARM, //Ĭ
			IDS_CONFIG_LOG_MOTIONDET,   //ƶ
			IDS_CONFIG_LOG_RESMOTIONDET, //ƶָĬ
			IDS_CONFIG_LOG_CRUISE,       //Ѳ
			IDS_CONFIG_LOG_RESCRUISE,    //ѲûָĬ
			IDS_CONFIG_LOG_OUTPUTMODE,   //ģʽ
			IDS_CONFIG_LOG_RESOUTPUTMODE,//ģʽָĬ
			IDS_CONFIG_LOG_CHANNEL,      //ͨ
			IDS_CONFIG_LOG_RESCHANNEL,   //ͨûָĬ
			IDS_CONFIG_LOG_IMAGECOL,     //ͼɫ
			IDS_CONFIG_LOG_RESIMAGECOL,  //ͼɫָĬ
			IDS_CONFIG_LOG_PREVIEW,      //Ԥ
			IDS_CONFIG_LOG_RESPREVIEW,   //ԤûָĬ
			IDS_CONFIG_LOG_RESUSERCFG,   //ûûָĬ
			IDS_CONFIG_LOG_SEN,          //洫
			IDS_CONFIG_LOG_RESSEN,       //ûָĬ
			IDS_CONFIG_LOG_DDNS,        //DDNS
			IDS_CONFIG_LOG_SMTP,        //SMTP
			IDS_CONFIG_LOG_CLOUD,       //ƶ
			IDS_CONFIG_LOG_UPNP,        //UPNP
			IDS_CONFIG_LOG_SERIAL,      //ڲָĬ

			IDS_FILE_LOG_UP,       //ļϴ
			IDS_FILE_LOG_DOWN,     //ļ
			IDS_FILE_LOG_DISKFORMAT,//ʽӲ<N>
			IDS_FILE_LOG_DISKREAD,  //޸Ӳ<N>Ϊɶд
			IDS_FILE_LOG_DISKWRITE, //޸Ӳ<N>Ϊֻ
			IDS_FILE_LOG_VIDEOBACKUP, //¼񱸷

			IDS_STATE_LOG_NTP,        //NTPͬ
			IDS_STATE_LOG_OPENDEFEND, //Զά
			IDS_STATE_LOG_CLOSEDEFEND, //رԶά
			IDS_STATE_LOG_OPENVIDERECA, //¼<Զ>
			IDS_STATE_LOG_CLOSEVIDEORECA, //ر¼<Զ>
			IDS_STATE_LOG_OPENVIDEORECM, //¼<ֶ>
			IDS_STATE_LOG_CLOSEVIDEORECM, //ر¼<ֶ>
			IDS_STATE_LOG_OPENVIDEORECO, //ȫ¼
			IDS_STATE_LOG_CLOSEVIDEORECO, //رȫ¼
			IDS_STATE_LOG_OPENDHCP,    //DHCP
			IDS_STATE_LOG_MCFGNET,     //ֶ
			IDS_STATE_LOG_OMOVEDEC, //ƶ
			IDS_STATE_LOG_CMOVEDEC, //رƶ
			IDS_STATE_LOG_OBUZZER,  //
			IDS_STATE_LOG_CBUZZER, //ȡ
			IDS_STATE_LOG_OLINKAGEREC, //¼ͨ
			IDS_STATE_LOG_CLINKAGEREC, //ȡ¼ͨ
			IDS_STATE_LOG_OSENALARM, //澯
			IDS_STATE_LOG_CSENALARM, //رմ澯
			IDS_STATE_LOG_ORUISE, //ͨѲ
			IDS_STATE_LOG_CRUISE, //رͨѲ
			IDS_STATE_LOG_ADDCRUISE, //Ѳ
			IDS_STATE_LOG_DELCRUISE, //ɾѲ
			IDS_STATE_LOG_OSCAN, //Զɨ
			IDS_STATE_LOG_CSCAN, //رԶɨ
			IDS_STATE_LOG_ODDNS, //DDNS
			IDS_STATE_LOG_OUPNP, //UPNP
			IDS_STATE_LOG_CUPNP, //رUPNP
			IDS_STATE_LOG_OP2P, //P2P
			IDS_STATE_LOG_CP2P, //رP2P
			IDS_STATE_LOG_OSMTP, //SMTP
			IDS_STATE_LOG_CSMTP, //رSMTP
            IDS_STATE_LOG_OSOUND, //
			IDS_STATE_LOG_CSOUND, //

			IDS_STATE_LOG_NODISK, //Ӳ
			IDS_STATE_LOG_DISKFMTFAIL, //Ӳ<N>ʽʧ
			IDS_STATE_LOG_DISKFMFOK, //Ӳ<N>ʽɹ
			IDS_STATE_LOG_DISKEXC, //Ӳ쳣
			IDS_STATE_LOG_DISKSPACE, //Ӳ̿ռ䲻
			IDS_STATE_LOG_GETENCODEFAIL, //ȡʧ
			IDS_STATE_LOG_SAVEENCODEFAIL, //ʧ
			IDS_STATE_LOG_ENCODEEXC, //쳣
			IDS_STATE_LOG_DELALLLOG, //ɾȫ־
			IDS_STATE_LOG_RECERDEXC, //¼ļ쳣
			IDS_STATE_LOG_DISCONNECT, //ӶϿ
			IDS_STATE_LOG_CONNECTOK, //
			IDS_STATE_LOG_IPCLASH, //IPַͻ
			IDS_STATE_LOG_MACCLASH, //MACַͻ
			IDS_STATE_LOG_DDNSFAIL, //DDNSʧ
			IDS_STATE_LOG_DDNSOK, //DDNSӳɹ
			IDS_STATE_LOG_NTPUPDATEFAIL, //NTPʧ
			IDS_STATE_LOG_NTPUPDATEOK, //NTP³ɹ
			IDS_STATE_LOG_UPNPFAIL, //UPNPӳʧ
			IDS_STATE_LOG_UPNPOK, //UPNPӳɹ
			IDS_STATE_LOG_EMAILSENDFAIL, //ʼʧ
			IDS_STATE_LOG_EMAILSENDOK, //ʼͳɹ
			IDS_STATE_LOG_P2PCONNECTFAIL, //P2Pʧ
			IDS_STATE_LOG_P2PCONNECTOK, //P2P
			IDS_STATE_LOG_FILEUPFAIL, //ļϴʧ
			IDS_STATE_LOG_FILEUPOK, //ļϴɹ
			IDS_STATE_LOG_FILEDOWNFAIL, //ļʧ
			IDS_STATE_LOG_FILEDOWNOK, //ļسɹ
			IDS_STATE_LOG_SENALARM, //澯
			IDS_STATE_LOG_VIDEOLOST, //Ƶʧ
			IDS_STATE_LOG_FILEBACKUPFAIL, //ļʧ
			IDS_STATE_LOG_UNFINDDEV, //δԶ豸
			IDS_STATE_LOG_NOPTZ, //̨豸

			// connet prompt
			IDS_PROMPT_CONN_IDLE,
			IDS_PROMPT_CONNECTED,
			IDS_PROMPT_CONNECTING,
			IDS_PROMPT_RECONNECT,
			IDS_PROMPT_CONNECT_FAILED,
			IDS_PROMPT_UNAUTHORIZED,
			
			//Email Setup
			IDS_EMAIL_SMTP_TITLE,
			IDS_EMAIL_SMTP_SERVER,
			IDS_EMAIL_PORT,
			IDS_EMAIL_ANONYMITY,
			IDS_EMAIL_USER,
			IDS_EMAIL_PASSWD,
			IDS_EMAIL_RECEIVER,
			IDS_EMAIL_SENDER,
			IDS_EMAIL_THEME,
			IDS_EMAIL_FILE,
			IDS_EMAIL_ENCRYTION_TYPE,
			IDS_EMAIL_INTERVAL,
			IDS_EMAIL_SEC,
			IDS_EMAIL_HEALTH_ENABLE,
			IDS_EMAIL_HEALTH_INTERVAL,
			IDS_EMAIL_MIN,
			IDS_EMAIL_EN,

			//DDNS 
			IDS_DDNS_TITLE,
			IDS_DDNS_ENABLE,
			IDS_DDNS_TYPE,
			IDS_DDNS_RF_TIME,
			IDS_DDNS_USER_TYPE,
			IDS_DDNS_DO_NAME,
			IDS_DDNS_USER_NAME,
			IDS_DDNS_USER_PASSWD,
			IDS_DDNS_TYPE_TEXT1,
			IDS_DDNS_USER_TYPE_NONE,
			IDS_DDNS_TIP,


			// Down Load
			STR_FILE_NAME,
			STR_CHANNEL,
			STR_TYPE,
			STR_START_TIME,
			STR_END_TIME,
			STR_FILE_SIZE,
			STR_FILE_PATH,
			STR_PROCESS,
			STR_DELETETASK,
			STR_DELETE_ALL_TASK,
			STR_DELETE_FILE,
			STR_DELETE_ALL_FILE,

			STR_DOWNLOAD_FILE_LIST,
			STR_DOWNLOAD_LIST,
			STR_DOWNLOADED_LIST,
			STR_DOWNLOAD_FILE_FAILED,
			STR_CONNECT_RECORD_SERVER_FAILED,
			STR_PROMPT,
			STR_ERROR_MAX_DOWNLOADTASK,
			STR_WHETHERTOOPERATOR,
			STR_REMOTE_DOWNLOAD,
			STR_DOWNLOAD_NARMAL_FILE,
			STR_DOWNLOAD_ALARM_FILE,
			

			//p2p
			STR_NET_P2PENABLE,
			STR_ERROR_EXIST_TASK,
			STR_ERROR_MANYFILES_CANNOT_DELETED,
			STR_ERROR_CANNOTDELETE_FILE,

			STR_OUTPUT_BOOT_TIP,    //ϵͳʾ

			STR_STARTBIGSTOP,
			STR_LOGMAXDAY,

			IDS_STR_ADD_DEVICE,
			IDS_STR_DELETE_DEVICE,
			IDS_STR_EDIT_DEVICE,
			IDS_STR_STATE_DEVICE,
			IDS_STR_MANUAL_ADD,
			IDS_STR_DISPLAYSELE,
			IDS_STR_COM_STR,
			IDS_STR_DEVICE_NAME,
			IDS_STR_MANU,
			IDS_STR_ADDED_DEVICE,
			IDS_STR_BTN_RETURN,
			IDS_STR_BTN_P2PCFG,

			IDS_STMP_DEFAULT,
			IDS_MOTION_DEFAULT,
			IDS_DDNS_DEFAULT,
			IDS_OUT_DEFAULT,

			IDS_RECSETUP_SCHEDULE5,
			IDS_RECSETUP_SCHEDULE6,
			IDS_RECSETUP_COPY_ALL,
			IDS_RECSETUP_SCHEDULE_SETUP,
			IDS_RECSETUP_CLEAR,
			IDS_RECSETUP_COMMON,
			IDS_RECSETUP_MD,
			IDS_COMMON_STANDBY_TIME_ERROR,
			IDS_REC_MAX,
			IDS_REC_DEFAULT,
			IDS_DISK_NOT_FORMAT_USB,
			IDS_PTZ_PRESET,
			IDS_PTZ_CRUISE,
			IDS_PTZ_ENABLE_CRUISE,
			IDS_PTZ_AUTO_SCAN,
			IDS_PTZ_PRESET_NAME,
			IDS_PTZ_PRESET_SETUP,
			IDS_PTZ_PRESET_CALL,
			IDS_PTZ_PRESET_SETUP_YES_OR_NO,
			IDS_PTZ_PRESET_SETUP_YES,
			IDS_PTZ_PRESET_SETUP_NO,
			IDS_PTZ_SPEED,
			IDS_PTZ_PRESET_STOP_TIME,
			IDS_PTZ_PRESET_NO,
			IDS_PTZ_ZOOM,
			IDS_PTZ_FACUS,
			IDS_PTZ_IRIS,
			IDS_PTZ_OK,
			IDS_NVR_MD_SETCURCHANNEL,
			IDS_NVR_MD_SETALLCHANNEL,
			IDS_NVR_NOREC,
			IDS_AUTOMAINTAIN_REBOOT,
			IDS_AUTOMAINTAIN_AT,
			IDS_AUTOMAINTAIN_COMBOX_WEEK,
			IDS_MODIFY_IP,
			IDS_MODIFY_IP_IS_EXIST,
			IDS_NET_INVALID_MAC,
			IDS_COMMON_REC_DAY,
			IDS_EMAIL_TEST,
			IDS_P2P_ONLINE,
			IDS_P2P_OFFLINE,
			IDS_FTP_SETUP,
			IDS_FTP_SERVER,
			IDS_FTP_UPLOADFILE,
			IDS_FTP_PORT,
			IDS_COMMON_NTP_PORT,
			IDC_COMMON_NTP_INTERVAL,
			IDS_ENCODE_STREAMTYPE,
			IDS_COMMOM_FTP_TEST,
			IDS_FTP_COMBOX_WEEK,
			IDS_COMMOM_FTP_TEST_SUCCESS,
			IDS_COMMOM_FTP_TEST_FAILD,
			IDS_USER_NO_ROOT,
			IDS_UPNP_SETUP,
			IDS_UPNP_INSIDEIP,
			IDS_UPNP_OUTSIDEIP,
			IDS_UPNP_PORTMAP,
			IDS_UPNP_SERVERNAME,
			IDS_UPNP_INSIDEPORT,
			IDS_UPNP_OUTSIDEPORT,
			IDS_UPNP_PORTINFO,
			IDS_UPNP_CONNECTING,
			IDS_UPNP_CONTENTED,
			IDS_UPNP_PORT,
			IDS_LOAD_TEXT,
			IDS_LOAD_TEXT2,
			IDS_LOAD_TEXT1,
			IDS_UPNP_INVALID_SERVERNAME,
			IDS_UPNP_INVALID_PORT,
			IDS_AUTOMAINTAIN_COMBOX_TYPE,
			IDS_COMMON_HOUR,
			IDS_USER_GROUP,
			IDS_USER_MODIFY,
			IDS_USER_REMARK,
			IDS_USER_GROUP1,
			IDS_USER_AUTHO,
			IDS_USER_PLAYBACK,
			IDS_USER_ACCOUNT,
			IDS_USER_SYSSETTING,
			IDS_USER_DISCONNETUSER,
			IDS_USER_DEFAULT,
			IDS_USER_PTZCONTROL,
			IDS_USER_SYSINFO,
			IDS_USER_MANUALCONTROL,
			IDS_USER_FILEBACK,
			IDS_USER_STROAGEMANAGE,
			IDS_USER_EVENTSETTING,
			IDS_USER_CAMERA,
			IDS_USER_CLEARLOG,
			IDS_USER_SHUTDOWN,
			IDS_USER_MODIFYPASSWD,
			IDS_GETTIMEERROR,
			IDS_EXIST_GROUP,
			IDC_EXCEPTION,
			IDC_DISK_EXCEPTION,
			IDC_NET_EXCEPTION,
			IDC_EXCEPTION_TYPE,
			IDC_SCREEN_DISPLAY,
			IDC_SEND_EMAIL,
			IDC_COMBO_DISK,
			IDC_COMBO_NET,
			IDS_GROUP_ADD_LIMIT,
			IDC_SELECT_USER,
			IDC_SELECT_GROUP,
			IDC_NOTDEL_GROUP,
			IDS_DEFAULT_DISCOLOR,
			IDS_DEFAULT_POLL,
			IDS_DEFAULT_TOUR,
			IDS_DEFAULT_IMAGE,
			IDS_GROUP_NOTMODIFY,
			IDS_DATE_SETTING,
			IDS_CH_NAME,
			IDS_UPNP_ADDLIMIT,
			IDS_PASSWROD_ERROR,
			IDS_PTZ_CRUISE_LINE,
			IDS_PTZ_DISENABLE_CRUISE,
			IDS_UPLOADFILE_ERROR,
			IDS_COMMON_DATE_FORMAT,
			IDC_COMMON_DATE_SEP,
			IDC_COMMON_TIME_FORMAT,
			IDC_COMMON_COMBO_DATE_FORMAT,
			IDC_COMMON_COMBO_TIME_FORMAT,
			IDS_USER_NOTMODIFY,
			IDS_USER_NOTDEL,
			IDS_USER_NOUSERACCOUNT,
			IDS_USER_ENTER_GROUP,
			IDS_CONFIG_LOG_CLOUD_OFF,
			IDS_CONFIG_LOG_EVENT_ON,
			IDS_CONFIG_LOG_EVENT_OFF,
			IDS_CONFIG_LOG_POLL_ON,
			IDS_CONFIG_LOG_POLL_OFF,
			IDS_CONFIG_LOG_PPPOE_ON,
			IDS_CONFIG_LOG_PPPOE_OFF,
			IDS_CONFIG_LOG_FTP_ON,
			IDS_CONFIG_LOG_FTP_OFF,
			IDS_CONFIG_LOG_OVERLAY,
			IDS_CLOUD_STORAGE,
			IDS_COMMOM_OSD_SETUP,
			IDS_SAVE_VOL_SETUP,
			IDS_SAVE_P2P_SETUP,
			IDS_SAVE_POLL_SETUP,
			IDS_LIST_USEDCAPACITY,
			IDS_CLOUD_START,
			IDS_CLOUD_BIND,
			IDS_CLOUD_UPLOAD,
			IDS_CLOUD_URL,
			IDS_CLOUD_CODE,
			IDS_CLOUD_REMOVEBIND,
			IDS_COMMOM_CLOUD_TEST_SUCCESS,
			IDS_COMMOM_CLOUD_TEST_FAILD,
			IDS_CLOUD_UPLOAD_TIPS,
			IDS_CONFIG_VIDEO_LOST,
			IDS_CONFIG_ALARM_OUTPUT,
			IDS_CRUISE_PRESET,
			IDS_NVRMAIN_SIXTYFOUR,
			IDS_COMBOX_ALLCHANNELSIXTYFOUR,
		};
	};


typedef enum E_RECORDTYPE
{
    hs_record_unknown = 0,
    hs_record_video,
    hs_record_audio,
    hs_record_alarm,
    hs_record_environment,
    hs_record_io,
    hs_record_picture,
    hs_record_doc,
    hs_record_pdf
}s_recordType;

typedef enum E_RECORDMODE
{
    hs_record_mode_unknown =0,
    hs_record_mode_normal,
    hs_record_mode_alarm,
    hs_record_mode_all
}e_recordMode;

typedef enum E_SEARCHMODE
{
    hs_search_unknown =0,
    hs_search_device,
    hs_search_platform,
    hs_search_local
}e_searchMode;

typedef enum S_VENDER_TYPE
{
    vender_unknown = 0,
    vender_huwei,
    vender_hikon,
    vender_dahua,
    vender_panasonic,
    vender_jingyang,
    vender_cnb,
    vender_cnbdome,
    vender_cnbonvif,
    vender_zhongyu,
    vender_nfdl,
    vender_bosch,
    vender_beseen,
    vender_longse,
    vender_onvif,
    vender_longsenvr1,
    vender_simulate,
}s_vender_type;

typedef enum S_DEVICE_TYPE
{
    device_unknown = 0,
    device_database = 50,
    device_dvr = 101,
    device_nvr = 102,
    device_rpu = 103,
    device_environment=104,
    device_alarmhost=105,
    device_idvr = 106,
    device_xvr = 107,
    device_p2p_ipc = 108,
    device_p2p_nvr = 110,
    device_ip_camera = 201,
    device_ip_dome = 202,
    device_ip_hemisphere = 203,
    device_camera = 204,
    device_dome = 205,
    device_hemisphere = 206,
    device_ipc_fisheye = 208,
    device_input = 301,
    device_output = 302,
    device_inAndOut = 303,
    device_temperature = 401,
    device_humidity = 402,
    device_windspeed = 403,
    device_webservices = 901,
    device_stream_server = 902,
    device_cms = 903,
    device_cmc = 904,
    device_vac = 905,
    device_ans = 906,
    device_gas=907,//sipgw
    device_gac=908,//sipgw
    device_anc = 909
}s_device_type;

typedef struct S_RECORDINFO
{
    char Guid[48];
    //unsigned int RecordType;
    s_recordType RecordType;

    //RecordMode,such as nomal,alarm
    e_recordMode RecordMode;

    // format: YYYYMMDDHHmmSS(14 char)
    unsigned int StartTime;

    // format: YYYYMMDDHHmmSS(14 char)
    unsigned int StopTime;

    // record size.
    unsigned int RecordSize;

    // record neme.
    char RecordName[256];

}s_recordInfo;

typedef struct S_PICTUREINFO 
{
    char Guid[48];
    char PictureUrl[1024];
    char *PictureBuffer;
    int PictureSize;

    S_PICTUREINFO()
    {
         memset(this,0,sizeof(S_PICTUREINFO));
    }

}s_pictureInfo;

typedef struct  S_RECORDELEMENTPARAM
{
    char            ChannelGuid[48];
    s_recordInfo    RecordInfo;
    s_pictureInfo   PictureInfo;
    int             Index;

    S_RECORDELEMENTPARAM()
    {
        memset(this,0,sizeof(S_RECORDELEMENTPARAM));
    }

}s_recordElementParam;

typedef struct S_RECORDPARAM
{
    char ChannelGuid[48];

    //sush as platform,device,local
    e_searchMode SearchMode;

    //search result of the filelist size.
    unsigned int ElementSize;

    //record list
    s_recordElementParam* pRecordList;

    void        *hWnd;

    S_RECORDPARAM()
    {
        hWnd = nullptr;
        pRecordList = nullptr;
    }

}s_recordParam;     // ¼ļ

typedef enum S_DATATYPE
{
    data_unknown = 0,
    data_filename,
    data_video_mp4,
    data_video_h264,
    data_video_yuv,
    data_video_priv,
    data_audio_g711,
    data_audio_g722,
    data_audio_g726,
    data_audio_pcm,
    data_alarm_env,
    data_video_mp4_es,
    data_video_h264_es,
    data_video_h264_ps,
    data_video_mp4_ps,
    data_video_h264_ps_pg,
}s_data_type;

typedef struct S_STREAM_HEADER
{
    unsigned short  ulFlag;            //  00 01

    unsigned char   ucState;           //  ״̬
    unsigned char   ucRes[1];          //  
    unsigned int   bMediaType:2;      //  0:Ƶ   1:Ƶ   2:ͷϢ   3:ͼƬ
    unsigned int   bFrameType:5;      //  ֡
    unsigned int   bSize:22;          //  ֡
    unsigned int   bSubStream:2;      //  
    unsigned int   bRes:1;            //  

    unsigned char   usCH;              //  ͨ 0 1 2 3
    unsigned char   usVideoEncodeType;      //  Ƶ 
    unsigned char   usAudioEncodeType;      //  Ƶ 
    unsigned char   usRes[1];          //   ֽڶ

    unsigned int   ucSerialNum;       //  ֡
    unsigned int   ulTimeStamp;       //  ʱ

    unsigned short  usWidth;           //  
    unsigned short  usHeight;          //  ߶
    unsigned short  ucFrameRate;       //  ֡
    unsigned short  ucBitRate;         //  

    unsigned int   ulTimeStampExt;	//ʱ벿
}s_stream_header;

typedef struct S_DATA_PARAM
{
    // vender type, such as hikon,dahua, etc.
    s_vender_type   VenderType;

    // Data type, such as mp4 video,264 video, G.731 audio, YUV420, etc.
    s_data_type     DataType;

    s_stream_header DataHeader;
    unsigned int    DataParam[8];
    unsigned char*  DataBuffer[4];
    int             DataSize[4];
}s_data_param;

// ¼ص
typedef void (CALLBACK *fSearchRecordCallback)(s_recordParam* recordlist, void* userdata);

typedef void (CALLBACK *fPlaybackCallback)(s_data_param *data,void *parent);

typedef void (__stdcall *dataCallback)(int mediatype, int pyloadtype, unsigned short seqnum, unsigned int timestamp, unsigned char *databuf, int datalen, void *userdata);

enum MODEL
{
    model_ipc       = 0,
    model_dvr_nvr   = 1,
    model_xvr       = 2,
};

typedef struct S_CONNECTPARAM
{
    char chost[MAX_HOST_LEN];
    int iRtspPort;
    int iHttpPort;
    char username[MAX_USER_NAME_LEN];   //û
    char password[MAX_PASSWORD_LEN];    //
    BYTE  protocol;						//Э  PROTOCOL

    MODEL  e_model;						//豸ͺ,  0 IPC 1 DVR-NVR 2.XVR

}s_connectParam;

#define MAX_WEEK_NUM 9
typedef struct ftp_sched_time_s{
    //ʱһ
    char type1;			//Ԥ
    char start_hour1; 	//ʼʱ
    char start_min1;
    char stop_hour1;  	//ʱ
    char stop_min1;

    //ʱζ
    char type2;			//Ԥ
    char start_hour2; 	//ʼʱ
    char start_min2;
    char stop_hour2;	//ʱ
    char stop_min2;
}s_schedTime;

typedef struct S_FTPSCHED {
    char channel;
    char enable;
    char is_allWeek;            //Ƿȫ¼
    s_schedTime schedTime[MAX_WEEK_NUM];
    S_FTPSCHED()
    {
        memset(this,0,sizeof(s_ftpSched));
    }
}s_ftpSched;

//-----------------------------------------------------------------------------

////////////豸////////////////////
typedef struct S_DEVICE_NET_PARAM
{
    s_vender_type VenderType;
    s_device_type DeviceType;
    char Mac[24];
    char NetmaskAddr[16];
    char GatewayAddr[16];
    char DisplayName[64];
    char DeviceAddress[1024];
    int  DevicePort;
    int  RtspPort;
    char ucDnsAddr1[16];
    char ucDnsAddr2[16];
    int  ChannelCount;
    char Dhcp;
    int nIndex;
    char BroadcastAddr[16];
    int PlaybackPort;
    int res;
    unsigned int   ucPlatformType;                       /*ƽ̨: */
    unsigned char   ucDevType[32];                        /*豸: */
    unsigned char   ucSoftwareVersion[64];                /*汾*/
    unsigned char   ucFirmwareVersion[64];                /*̼汾*/
}s_device_net_param;

typedef struct S_SEARCHPARAM
{
    unsigned int iStartTime;
    unsigned int iEndTime;
    unsigned int iChannelid;
    e_recordMode recordmode;
    S_SEARCHPARAM()
    {
        iStartTime = 0;
        iEndTime = 0;
        iChannelid = 0;
    }

}s_searchParam;

typedef struct S_SEARCHRECORD
{
    s_connectParam  connectParam;

    s_searchParam   searchParam;

    fSearchRecordCallback searchRecordCallback;

    void            *parent;

    void            *hWnd;

    S_SEARCHRECORD()
    {
        memset(&connectParam,0,sizeof(s_connectParam));
        memset(&searchParam,0,sizeof(s_searchParam));
        searchRecordCallback = nullptr;
        parent = nullptr;
        hWnd = nullptr;
    }

}s_searchRecord;            // ¼

struct S_RECORD_FILE_SEARCH 
{
    unsigned int startTm;                // ʼʱ
    unsigned int EndTm;                  // ʱ
    unsigned int nChannelID;             // ͨ
    unsigned int nFileType;              // ļ  
    int     nReserver;                   // Ԥ
};

typedef struct S_MSG_HEAD
{
    DWORD dwLength;
    DWORD dwCMD;
    char  pData[];
    S_MSG_HEAD()
    {
        dwLength = 0;
        dwCMD = 0;
    }
}s_msg_head;

struct s_record_search_file
{
    unsigned short diskNo;   
    unsigned short recordNo; 
    unsigned short fileType;
    unsigned char  unused[2];
    unsigned int   startTime;
    unsigned int   endTime;
    unsigned int   startAddr;
    unsigned int   endAddr;
    unsigned int   dataStartAddr;
    unsigned int   dataEndAddr;

};

typedef struct S_PLAYBACK_PARAM
{
    //char PlaybackGuid[48];

    e_searchMode PlayBackMode;    // sush as platform,device,local

    s_recordType RecordType;      // record type, such as video, audio, alarm,etc

    char Speed[8];                // format: 1/8,1/4,1/2, 1/1, 2/1, 4/1, 8/1

    unsigned int StartTime;

    unsigned int StopTime;

    unsigned int ElementSize;     // search result of the filelist size.

    s_recordElementParam* pRecordList;  // record list

    int             iChannel;

    void            *hwnd;

    S_PLAYBACK_PARAM()
    {
        StartTime = 0;
        StopTime = 0;
        ElementSize = 0;
        iChannel = 0; 
        hwnd = nullptr;
    }

}s_playback_param;

typedef struct S_PLAYRECORDFILE
{
    s_connectParam  connectParam;
       
    s_playback_param playback_param;

    fPlaybackCallback playbackCallback;

    void *parent;

    S_PLAYRECORDFILE()
    {
        playbackCallback = nullptr;
        parent = nullptr;
    }

}s_playRecordFile;            // ط¼

typedef struct S_FILE_HEADER
{
	int fileType;		//ļ
	int fileSize;			//ļС
	int videoCoder;		//Ƶ
	int audioCoder;		//Ƶ
	int frameRate;		//֡
	int bitRate;			//
	int width;			//ͼ
	int height;			//ͼ
	unsigned int totalFrames;		//ܹ֡ NVRΪʱ䳤
	int res[8];			//
	/*_FILE_HEADER()
	{
		ZeroMemory(this, sizeof(_FILE_HEADER));
	}*/
}s_file_header;

typedef struct S_FRAME_HEADER
{
	int type;	// 0ʾƵ  1ʾƵ  2ʾļ
	int len;		//ݳ
	int isKeyFrame;	//ǷΪؼ֡	.ƵЧ
	int index;		//Ƶ֡,ƵЧ
	unsigned int timestamp;	//ʱ NVRʱ
	int res1;
	int res2;
	int res3;
	/*_FRAME_HEADER()
	{
		ZeroMemory(this, sizeof(_FRAME_HEADER));
	}*/
}s_frame_header;

typedef enum
{
    PT_PCMU          = 0,
    PT_1016          = 1,
    PT_G721          = 2,
    PT_GSM           = 3,
    PT_G723          = 4,
    PT_DVI4_8K       = 5,
    PT_DVI4_16K      = 6,
    PT_LPC           = 7,
    PT_PCMA          = 8,
    PT_G722          = 9,
    PT_S16BE_STEREO  = 10,
    PT_S16BE_MONO    = 11,
    PT_QCELP         = 12,
    PT_CN            = 13,
    PT_MPEGAUDIO     = 14,
    PT_G728          = 15,
    PT_DVI4_3        = 16,
    PT_DVI4_4        = 17,
    PT_G729          = 18,
    PT_G711A         = 19,
    PT_G711U         = 20,
    PT_G726          = 21,
    PT_G729A         = 22,
    PT_LPCM          = 23,
    PT_CelB          = 25,
    PT_JPEG          = 26,
    PT_CUSM          = 27,
    PT_NV            = 28,
    PT_PICW          = 29,
    PT_CPV           = 30,
    PT_H261          = 31,
    PT_MPEGVIDEO     = 32,
    PT_MPEG2TS       = 33,
    PT_H263          = 34,
    PT_SPEG          = 35,
    PT_MPEG2VIDEO    = 36,
    PT_AAC           = 37,
    PT_WMA9STD       = 38,
    PT_HEAAC         = 39,
    PT_PCM_VOICE     = 40,
    PT_PCM_AUDIO     = 41,
    PT_AACLC         = 42,
    PT_MP3           = 43,
    PT_ADPCMA        = 49,
    PT_AEC           = 50,
    PT_X_LD          = 95,
    PT_H264          = 96,
    PT_D_GSM_HR      = 200,
    PT_D_GSM_EFR     = 201,
    PT_D_L8          = 202,
    PT_D_RED         = 203,
    PT_D_VDVI        = 204,
    PT_D_BT656       = 220,
    PT_D_H263_1998   = 221,
    PT_D_MP1S        = 222,
    PT_D_MP2P        = 223,
    PT_D_BMPEG       = 224,
    PT_MP4VIDEO      = 230,
    PT_MP4AUDIO      = 237,
    PT_VC1           = 238,
    PT_JVC_ASF       = 255,
    PT_D_AVI         = 256,
    PT_DIVX3		= 257,
    PT_AVS		= 258,
    PT_REAL8		= 259,
    PT_REAL9		= 260,
    PT_VP6		= 261,
    PT_VP6F		= 262,
    PT_VP6A		= 263,
    PT_SORENSON	 =264,
    PT_MAX           = 265,
    /* add by hisilicon */
    PT_AMR           = 1001, 
    PT_MJPEG         = 1002,
    PT_AMRWB         = 1003,
    PT_BUTT
}e_playload_type;

typedef struct S_PLAY_INFO
{
	int lframe;	//󲥷ŵ֡
	int speed;	//ٶȿ
	int res2;
	int res3;
	/*_PLAY_INFO()
	{
		ZeroMemory(this, sizeof(_PLAY_INFO));
	}*/
}s_play_info;       // 

typedef struct S_DOWNLOADFILE
{
	int  nClientType;
	char szFileName[256];
	/*tagDOWNLOADFILE()
	{
		ZeroMemory(this, sizeof(tagDOWNLOADFILE));
	}*/
} s_downloadfile, *s_pdownloadfile;

typedef struct S_SEEK_INFO
{
	int lSecond;
	int res1;
	int res2;
	int res3;
	/*_SEEK_INFO()
	{
		ZeroMemory(this, sizeof(_SEEK_INFO));
	}*/
}s_seek_info;

typedef enum S_MESSAGE_TYPE
{
    unknown,
    alarm,
    reconnect,
    upgrade_ok,
    upgrade_per,
    upgrade_failed,
    playback_no_data
}s_messageType;

typedef enum S_PlayBackCommand
{
    hs_playback_unknown =0,
    hs_playback_pause,
    hs_playback_resume,
    hs_playback_speed,
    hs_playback_getposition,
    hs_playback_setposition,
    hs_playback_play_backward,
    hs_playback_play_forward,
    hs_playback_previous_frame,
    hs_playback_next_frame,
}s_playback_command;

typedef struct S_PositionParam
{
    char PlaybackGuid[48];
    int PositionType;
    unsigned int Position;
}s_positionParam;

typedef struct S_PlayBackCtrl
{
    char PlaybackGuid[48];

    s_playback_command Command;

    //format: 1/8,1/4,1/2, 1/1, 2/1, 4/1, 8/1
    char Speed[8];

    //Set Playback Position
    s_positionParam Position;
}s_playback_ctrl;

///////////////////////////////////////////////////////////////////////////////
// XVR

typedef struct S_XVR_SETPARAM
{
    int setsystemtimeyear;
    int setsystemtimemonth;
    int setsystemtimeday;
    int setsystemtimehour;
    int setsystemtimeminutes;
    int setsystemtimeseconds;

    unsigned char  ucModel;

    int setntpcontrol;
    char setntpserver[MAX_HOST_LEN];
    int setntptimezone;
    S_XVR_SETPARAM()
    {
        memset(this,0,sizeof(S_XVR_SETPARAM));
    }
}s_xvr_setparam;

typedef struct S_XVR_DEVICE_SET
{
    unsigned char netip[MAX_HOST_LEN];
    unsigned char netisin[MAX_LEN];//
    unsigned char netmask[MAX_LEN];
    unsigned char gateway[MAX_LEN];
    unsigned char dns1[MAX_LEN];
    unsigned char dns2[MAX_LEN];
    unsigned char mac[MAX_LEN];
    unsigned char dhcpenable[MAX_LEN];
    unsigned char p2penable[MAX_LEN]; //
    unsigned char httpport[MAX_LEN];//
    unsigned char rtspserverport[MAX_LEN];//
    unsigned char tcpport[MAX_LEN];//
    unsigned char multicast[MAX_LEN];
    unsigned char getlanguage[MAX_LEN];//
    unsigned char getrecyclerecord[MAX_LEN];//
    unsigned char getdrvid[MAX_LEN];//
    unsigned char getoutdevice[MAX_LEN];//
    unsigned char getvideomode[MAX_LEN];//
    unsigned char getresolution[MAX_LEN];//
    unsigned char getdevname[MAX_LEN];
    unsigned char getstandbytime[MAX_LEN];//
    unsigned char getsysdevtype[MAX_LEN];//

    unsigned char getsyschannum[MAX_HOST_LEN];//
    unsigned char getdeviceserial[MAX_HOST_LEN];
    unsigned char getdevicetype[MAX_HOST_LEN];
    unsigned char getsoftwareversion[MAX_HOST_LEN];
    unsigned char getsoftwaredate[MAX_HOST_LEN];
    unsigned char getcpumode[MAX_HOST_LEN];//
    unsigned char adhchnresolutionjoin[MAX_HOST_LEN];

    S_XVR_DEVICE_SET()
    {
        memset(this,0,sizeof(S_XVR_DEVICE_SET));
    }
}s_xvr_device_set;  // ȡ豸ini.htm  (ͬs_nvrMainStruct)

typedef struct S_XVR_DEVICE_SEARCH
{
    unsigned char ip[MAX_HOST_LEN];
    int port;
    int type;
    int manu;
    unsigned char name[MAX_USER_NAME_LEN];
    unsigned char pwd[MAX_PASSWORD_LEN];
    unsigned char mac[MAX_HOST_LEN];
    unsigned char devType[MAX_HOST_LEN];
    int pIndex;

    S_XVR_DEVICE_SEARCH()
    {
        memset(this,0,sizeof(S_XVR_DEVICE_SEARCH));
    }

}s_xvr_device_search;   // ȡ豸Ϣ

typedef struct S_XVR_SETAUTOREBOOT
{
    int iSetautomaintaintype;
    int iSetautomaintainday;
    int iSetautomaintainweek;
    int iSetautomaintainhour;
    int iSetautomaintainmin;
    
    S_XVR_SETAUTOREBOOT()
    {
        memset(this,0,sizeof(S_XVR_SETAUTOREBOOT));
    }

}s_xvr_setautoreboot;   // Զ

typedef struct S_XVR_LOADTIME
{  
    int igetsystemtimeyear;
    int igetsystemtimemonth;
    int igetsystemtimeday;
    int igetsystemtimehour;
    int igetsystemtimeminutes;
    int igetsystemtimeseconds;

    unsigned char cgetntpserver[MAX_LEN];
    int igetntpport;
    int igetntinterval;
    int igetntpdateformat;
    int igetntpdateseparator;
    int igetntptimeformat;
    int igetntptimezone;
    int igetntpcontrol;

    //-----------------
    unsigned char csetsyncenable[MAX_LEN];
    unsigned char csetsyncchn[MAX_LEN];

    S_XVR_LOADTIME()
    {
        memset(this,0,sizeof(S_XVR_LOADTIME));
    }
}s_xvr_loadtime;

typedef struct S_XVR_DDNSSET
{
    int igetddnstype;
    int igetddnsen;
    int igetddnsintertime;
    int igetddnsusertype;
    unsigned char cgetddnsdomainname[MAX_LEN];
    unsigned char cgetddnsusername[MAX_LEN];
    unsigned char cgetddnsuserpwd[MAX_LEN];

    S_XVR_DDNSSET()
    {
        memset(this,0,sizeof(S_XVR_DDNSSET));
    }
}s_xvr_ddnsset; // ddns

typedef struct S_XVR_SUMMERTIME
{

}s_xvr_summertime;      // ļʱ

typedef struct S_XVR_DSTSAVE
{
    int isEnableDST;

    int setsummertimetmisdst;
    int setsummertimetmtype;
    int setsummertimetmoffset;
    int setsummertimeoffsetflag;
    int setsummertimestartyear;
    int setsummertimestartmon;
    int setsummertimestartweektype;
    int setsummertimestartweekday;
    int setsummertimestartmday;
    int setsummertimestarthour;
    int setsummertimestartmin;
    int setsummertimeendyear;
    int setsummertimeendmon;
    int setsummertimeendweektype;
    int setsummertimeendweekday;
    int setsummertimeendmday;
    int setsummertimeendhour;
    int setsummertimeendmin;

    S_XVR_DSTSAVE()
    {
        memset(this,0,sizeof(S_XVR_DSTSAVE));
    }
}s_xvr_dstsave; // DST

typedef struct S_XVR_EXCEPTIONSET
{
    int igeteventtype;
    int igeteventenalbe;
    int igeteventdisplay;
    int igeteventemail;
    int igeteventbuzzer;

    S_XVR_EXCEPTIONSET()
    {
        memset(this,0,sizeof(S_XVR_EXCEPTIONSET));
    }
}s_xvr_exceptionset;    // ȡ/exception 


typedef struct S_XVR_AREADATE
{
    int getmotiondetchannel;
    std::vector<DWORD> v_motiondet_block;
    
    S_XVR_AREADATE()
    {
        getmotiondetchannel = 1;
    }
}s_xvr_areadate;       // ȡƶ

typedef struct S_XVR_GETP2PPARAM
{
    int getfreeipen; // p2p:1 :0
    int getdanaleen;
    int getp2psconnecttatus;

    unsigned char getfreeipandurl[MAX_LEN_PRO];
    unsigned char getfreeipiosurl[MAX_LEN_PRO];
    unsigned char getdanalandurl[MAX_LEN_PRO];
    unsigned char getdanaliosurl[MAX_LEN_PRO];
    S_XVR_GETP2PPARAM()
    {
        memset(this,0,sizeof(S_XVR_GETP2PPARAM));
    }

}s_xvr_getp2pparam; // p2p

typedef struct S_XVR_CHANNELCONFIG
{
    std::map<std::string,size_t> map_channelmodel;

}s_xvr_channelconfig;

typedef struct S_XVR_WIFIPARAM
{
    unsigned int  i_setwifissid;
    unsigned char c_setwifipwd[MAX_PASSWORD_LEN];
    bool          b_setwifipwddisplay;

    int i_Num;        //  1:; 
                      //   ֵ:Ҫ,ֵĬ wifiֵеgetwifibroadcastgetwifichannel
    //----------------------- 
    bool          b_setwifibroadcast;
    unsigned int  i_setwifichannel;
    //-----------------------

    S_XVR_WIFIPARAM()
    {
        memset(this,0,sizeof(S_XVR_WIFIPARAM));
    }

}s_xvr_wifiparam;  // wifi

typedef struct S_XVR_GETOSDPARAM
{
    std::string getoverlaychanno;

    std::string getoverlaycoverenable0;
    std::string getoverlaycoverx0;
    std::string getoverlaycovery0;
    std::string getoverlaycoverw0;
    std::string getoverlaycoverh0;

    std::string getoverlaytxtenable0;
    std::string getoverlaytxtx0;
    std::string getoverlaytxty0;
    std::string getoverlaytxtw0;
    std::string getoverlaytxth0;

    std::string getoverlaytimeenable;
    std::string getoverlaytimex;
    std::string getoverlaytimey;
    std::string getoverlaytimew;
    std::string getoverlaytimeh;

    S_XVR_GETOSDPARAM()
    {
        memset(this,0,sizeof(S_XVR_GETOSDPARAM));
    }
}s_xvr_getosdparam;  // ȡosd

typedef struct S_XVR_SETPPPOE   
{
    unsigned char c_setpppoeuser[MAX_USER_NAME_LEN];
    unsigned char c_setpppoepass[MAX_PASSWORD_LEN];
    bool b_setpppoeenable;

    S_XVR_SETPPPOE()
    {
        memset(this,0,sizeof(S_XVR_SETPPPOE));
    }
}s_xvr_setpppoe;        // pppoe

typedef struct S_XVR_PTZPARAM 
{
    unsigned int i_ptzserialchannel;
    std::string str_ptzserialnnprotocol;
    std::string str_ptzserialnaddr;
    std::string str_ptzserialnbaudrate;
    std::string str_ptzserialndatabit;
    std::string str_ptzserialnstopbit;
    std::string str_ptzserialnchecktype;

    S_XVR_PTZPARAM()
    {
        memset(this,0,sizeof(S_XVR_PTZPARAM));
    }
}s_xvr_ptzparam;        // ȡ/ptz

typedef struct S_XVR_VIDEOLOSSPARAM
{
    unsigned int i_vediolosschannel;

    //-------------------------------
    // ֵʱ { 1:  ;0:ر ;: ĬΪ0 }
    // ȡֵʱ { 1:  ;0:ر }

    unsigned int i_vediolossenalbe;
    unsigned int i_vediolossalarmout;
    unsigned int i_vediolossdisplay;
    unsigned int i_vediolossemail;
    unsigned int i_vediolossbuzzer;
    //-------------------------------

    S_XVR_VIDEOLOSSPARAM()
    {
        memset(this,0,sizeof(S_XVR_VIDEOLOSSPARAM));
    }
}s_xvr_videolossparam;      // ȡ/videoloss

typedef struct S_XVR_VOLUMEPARAM 
{
    unsigned int i_volumechannel;
    std::string str_volume;
    unsigned int i_enable; // 10

    S_XVR_VOLUMEPARAM()
    {
        i_volumechannel = 0;
        i_enable = 0;
    }
}s_xvr_volumeparam;        // ȡ/volume


///////////////////////////////////////////////////////////////////////////////
// HTTP Config

#define MAX_ID_LEN 16
#define MAX_GROUP_NAME_LEN 32
#define MAX_REMARKS_LEN 32
#define MAX_PASSWD_LEN 32

typedef struct S_LOGIN_CONFIG
{

    s_connectParam connectParam;

}s_login_config;

//ini.htm
typedef struct S_NVRMAINSTRUCT 
{
    std::string m_str_NetIp;
    std::string m_str_NetMask;
    std::string m_str_GateWay;
    std::string m_str_Dns1;
    std::string m_str_Dns2;
    std::string m_str_Mac;
    BOOL m_bDhcpEnable;
    BOOL m_p2penable;
    int m_nHttpPort;
    int m_nRtspServerPort;
    int m_nTcpPort;
    int m_nIsExtrenal; // 1 waiwang  0 neiwang
    std::string m_str_Multicast;
    int m_nLanguage;
    BOOL m_bRecycleRecord;
    int m_nDrvId;
    int m_nOutDevice;
    int m_nVideoMode;
    int m_nResolution;
    int m_nStandByTime;
    int m_nSysDevType;
    int m_nSysChannum;
    std::string m_str_SysDeviceType;
    std::string m_str_SoftWareVersion;
    std::string m_str_SofeWareDate;
    std::string m_str_deviceName;
    std::string m_str_DeviceSerial;
    int m_nCpuType;
    S_NVRMAINSTRUCT()
    {

        m_str_NetIp = "";
        m_str_NetMask = "";
        m_str_GateWay = "";
        m_str_Dns1 = "";
        m_str_Dns2 = "";
        m_str_Mac = "";
        m_bDhcpEnable = 0;
        m_p2penable = 0;
        m_nHttpPort = 0;
        m_nRtspServerPort = 0;
        m_nTcpPort = 0;
        m_nIsExtrenal = 0;
        m_str_Multicast = "";
        m_nLanguage = 0;
        m_bRecycleRecord = 0;
        m_nDrvId = 0;
        m_nOutDevice = 0;
        m_nVideoMode = 0;
        m_nResolution = 0;
        m_nStandByTime = 0;
        m_nSysDevType = 0;
        m_nSysChannum = 0;
        m_str_SysDeviceType = "";
        m_str_SoftWareVersion = "";
        m_str_SofeWareDate = "";
        m_str_DeviceSerial = "";
        m_nCpuType = 0;
    }
    ~S_NVRMAINSTRUCT()
    {
    
    }
}s_nvrMainStruct;

// ȡϵͳλ
typedef struct S_GETSYSTEMSETDATABIT{

    UINT64 lSysRight;
    UINT64 lPlaybackRight;
    UINT64 lLiveviewRight;
    S_GETSYSTEMSETDATABIT()
    {
        lSysRight = 0;
        lPlaybackRight = 0;
        lLiveviewRight = 0;
    }

}s_getSystemSetDataBit;

typedef struct S_SDKUSER
{
    char		user_id[MAX_ID_LEN];				//ûid

    char		user_name[MAX_USER_NAME_LEN];		//û
    char		password[MAX_PASSWD_LEN];			//
    char		user_remarks[MAX_REMARKS_LEN];		//ûעϢ

    UINT64	    system_set_data_bit;				//û̳ϵͳȨ
    UINT64	    playback_data_bit;					//û̳ƵطȨλ
    UINT64	    live_preview_data_bit;				//û̳ʵʱԤȨλ

    char		belong_to_group[MAX_USER_NAME_LEN];	//̳е
    char		group_remarks[MAX_REMARKS_LEN];		//̳ıעϢ

    char 	    recv[64];

    S_SDKUSER()
    {
        memset(this,0,sizeof(s_sdkUser));
    }

}s_sdkUser;

typedef struct S_SDKGROUP
{
    char group_id[MAX_ID_LEN];			        //id

    char group_name[MAX_GROUP_NAME_LEN];		//
    char group_remarks[MAX_REMARKS_LEN];		//鱸עϢ

    unsigned long long	system_set_data_bit;	//ϵͳȨλ
    unsigned long long	playback_data_bit;		//ƵطȨλ
    unsigned long long	live_preview_data_bit;	//ʵʱԤȨλ

    char recv[64];							    //

    S_SDKGROUP()
    {
        memset(this,0,sizeof(s_sdkGroup));
    }
}s_sdkGroup;

//-----------------------------------------------------------------------------
// NVR NET
typedef struct S_SETNETPARAM
{
    std::string ip;
    std::string mask;
    std::string gateway;
    int         tcpPort;
    int         rtspPort;
    int         httpPort;
    int         dhcp;       // 0: 1: 
    std::string dns;
    std::string dns2;
    std::string broadcast;
    std::string mac;

    S_SETNETPARAM()
    {
        memset(this,0,sizeof(s_setNetParam));
    }

}s_setNetParam;     // 

// NVR FTP
typedef struct S_SETFTPPARAM
{
    char        cFtpServer[31];
    char        cFtpUser[31];
    char        cFtpPwd[31];
    char        cFtpUpload[127];
    int         iFtpPort;
    int         iFtpEnable;     // 0: 1: 
    int         iFtpChannel;    // ͨ

    // nvr/xvr
    int         iFtpWeek;       
    bool        bCheckSchdule1; // 0:  1:  
    int         iStartHour1;
    int         iStartMin1;
    int         iStopHour1;
    int         iStopMin1;

    bool        bCheckSchdule2;
    int         iStartHour2;
    int         iStartMin2;
    int         iStopHour2;
    int         iStopMin2;

    char        cFolderName[127];

    S_SETFTPPARAM()
    {
        memset(this,0,sizeof(s_setFtpParam));
    }

}s_setFtpParam; // FTP

enum Language{
    Chinese = 0,
    English,
    Polish,         // 
    Czech,          // ݿ
    Russian,        // 
    Thai,           // ̩
    Hebrew,         // ϣ
    Arabic,         // 
    Bulgarian,      // 
    Farsi,          // ˹
    German,         // 
    French,         // 
    Portuguese,     // 
    Turkish,        // 
    Spanish,        // 
    Italian,        // 
    Hungarian,      // 
    Romania,        // 
    Korean,         // 
    Japanese,       // 
    Greek           // ϣ
};

typedef struct S_COMMONSETPARAM
{
    std::string strDevName;     // 豸  ( NVR )
    std::string strRecordMode;   // ¼ʽ (  )
    std::string strVideoStandard;   // Ƶģʽ ( NTSC , PAL )
    std::string strResolution;  // ֱ (1280*720,1280*1024,1920*1080,3840*2160 )
    int         iLanguage;      //   (enum Language )
    int         iDeivceId;    // 豸id
    int         iStandbyTime;   // ʱ䣨ӣ

    S_COMMONSETPARAM()
    {
        iStandbyTime = -1;
        iDeivceId = 0;
        iLanguage = English;
    }
}s_commonSetParam; // ͨ

enum EncryptionType
{
    NONE    = 0,
    SSL,
    TLS,
};

typedef struct S_SMTPSETPARAM
{
    std::string str_Email_SmtpServer;
    std::string str_Email_User;
    std::string str_Email_Password;
    std::string str_Email_Receiver;        // ռ
    std::string str_Email_Sender;          // 
    std::string str_Email_Theme;           // 
    int i_Email_Enclosure;                 //  ( 0: 1:  )
    int i_Email_Enable;
    int i_Email_Amity;
    int i_Email_Port;                      // ˿
    int i_Email_EncryptionType;            //  enum EncryptionType
    int i_Email_SendTime;                  // ʱ䣨s
    int i_Email_HealthInterval;            // min
    int i_Email_healthen;                   // ʱ
    int i_Email_Inhealth;

    // xvr
    int i_getsmtpanoen;
    int i_getsmtpenctype;
    int i_getsmtpfileen;
    int i_getsmtpinterval;
    int i_getsmtpen;

    S_SMTPSETPARAM()
    {
        i_Email_Enclosure= 0;
        i_Email_Enable = 0;
        i_Email_Amity = 0;
        i_Email_Port = 0;
        i_Email_EncryptionType = NONE;
        i_Email_SendTime = 1;
        i_Email_HealthInterval = 0;
        i_Email_healthen = 0;
        i_Email_Inhealth = 0;

        i_getsmtpanoen = 0;
        i_getsmtpenctype = 0;
        i_getsmtpfileen = 0;
        i_getsmtpinterval = 0;
        i_getsmtpen = 0;
    }
}s_smtpSetParam;        // SMTP

enum DdnsType
{
    ORAY = 0,
    No_IP,
    Dyn,
    ChangeIp,
    A_Press,
    Myqsee,
    Skddns,
    Smart_eyes
};

typedef struct S_DDNSSETPARAM
{
    int i_ddns_Enable;                  // ddnsʹ  ( 0: 1:  )
    int i_ddns_Type;                    // ddns  enum DdnsType
    int i_ddns_RefreshTime;             // ddnsˢʱ䣨s, 60
    std::string str_ddns_DomainName;    // ddns
    std::string str_ddns_UserName;      // ddnsû
    std::string str_ddns_Password;      // ddns
    
    S_DDNSSETPARAM()
    {
        i_ddns_Enable = 0;
        i_ddns_Type = ORAY;
        i_ddns_RefreshTime = 60;
    }

}s_ddnsSetParam;        // DDNS

//-----------------------------------------------------------

enum upnpProtocol
{
    TCP = 0,
    UDP,
};

typedef struct S_UPNPADD
{
    std::string str_upnp_Server;        // 
    int i_upnp_InternalPort;          // ڲ˿
    int i_upnp_ExternalPort;          // ⲿ˿
    int i_upnp_Protocol;              // upnpЭ
    int i_upnp_nEnable;               // ( 0: 1:  )
    S_UPNPADD()
    {
        i_upnp_InternalPort = 0;
        i_upnp_ExternalPort = 0;
        i_upnp_Protocol = TCP;
        i_upnp_nEnable = 0;
    }

}s_upnpAdd; // upnpӶ˿ӳ

typedef struct S_UPNPDelete
{
     std::string str_upnp_Server;        // 

}s_upnpDelete; // upnpɾ˿ӳ

typedef struct S_UPNPSETPARAM
{

}s_upnpSetParam; // upnpã

typedef struct S_CLOUDSTROAGESETPARAM
{
    bool i_Enable;                      // Ƿ   
        // ðͣDropbox = false ; Google = true

    // Dropbox
    bool b_BindDropbox;              // 󶨣true:жi_BindDropboxEnableֵ ;false:Ը 
    int  i_BindDropboxEnable;        // Ƿѡ0:ѡ 1:ѡ

    // Google
    bool b_BindGoogle;               // ͬ
    int  i_BindGoogleEnable;         

    bool b_Test;                     // Ƿ

    std::string str_CloudAddress;    // Ƶַ
    std::string str_IdentifyingCode; // ֤
    std::string str_CloudStorageDir; // ϴĿ¼

    S_CLOUDSTROAGESETPARAM()
    {
        i_Enable = false;
        b_BindDropbox = false;
        b_BindGoogle = false;
        b_Test = false;
        i_BindDropboxEnable = 0;
        i_BindGoogleEnable = 0;
    }

}s_cloudstroageSetParam; // ƴ


//-----------------------------------------------------------------------------
// û

typedef enum _SDK_PERMISSION {
    PERMISSION_USER_ACCOUNT = 0x00	
    , PERMISSION_SYSTEM_SET
    , /*PERMISSION_USER_BREAK*/PERMISSION_LOG_CLEAR
    , PERMISSION_DEFAULT_UPGRADE

    , PERMISSION_PTZ_CONTROL
    , PERMISSION_SYSTEM_INFO
    , /*PERMISSION_MANUAL_CONTROL*/PERMISSION_SHUTDOWN
    , PERMISSION_BACKUP

    , PERMISSION_STORAGE_MANAGE	
    , PERMISSION_EVENT_SET
    , PERMISSION_NETWORK_SETUP
    , PERMISSION_CAMERA

    , SDK_PERMISSION_BUIT
}SDK_PERMISSION_E; 

enum{
    ID_PLAYBACK_CH1 = 1,
    ID_PLAYBACK_CH2,
    ID_PLAYBACK_CH3,
    ID_PLAYBACK_CH4,
    ID_PLAYBACK_CH5,
    ID_PLAYBACK_CH6,
    ID_PLAYBACK_CH7,
    ID_PLAYBACK_CH8,
    ID_PLAYBACK_CH9,
    ID_PLAYBACK_CH10,
    ID_PLAYBACK_CH11,
    ID_PLAYBACK_CH12,
    ID_PLAYBACK_CH13,
    ID_PLAYBACK_CH14,
    ID_PLAYBACK_CH15,
    ID_PLAYBACK_CH16,
    ID_PLAYBACK_CH17,
    ID_PLAYBACK_CH18,
    ID_PLAYBACK_CH19,
    ID_PLAYBACK_CH20,
    ID_PLAYBACK_CH21,
    ID_PLAYBACK_CH22,
    ID_PLAYBACK_CH23,
    ID_PLAYBACK_CH24,
    ID_PLAYBACK_CH25,
    ID_PLAYBACK_CH26,
    ID_PLAYBACK_CH27,
    ID_PLAYBACK_CH28,
    ID_PLAYBACK_CH29,
    ID_PLAYBACK_CH30,
    ID_PLAYBACK_CH31,
    ID_PLAYBACK_CH32,
    ID_PLAYBACK_CH33,
    ID_PLAYBACK_CH34,
    ID_PLAYBACK_CH35,
    ID_PLAYBACK_CH36,
    ID_PLAYBACK_CH37,
    ID_PLAYBACK_CH38,
    ID_PLAYBACK_CH39,
    ID_PLAYBACK_CH40,
    ID_PLAYBACK_CH41,
    ID_PLAYBACK_CH42,
    ID_PLAYBACK_CH43,
    ID_PLAYBACK_CH44,
    ID_PLAYBACK_CH45,
    ID_PLAYBACK_CH46,
    ID_PLAYBACK_CH47,
    ID_PLAYBACK_CH48,
    ID_PLAYBACK_CH49,
    ID_PLAYBACK_CH50,
    ID_PLAYBACK_CH51,
    ID_PLAYBACK_CH52,
    ID_PLAYBACK_CH53,
    ID_PLAYBACK_CH54,
    ID_PLAYBACK_CH55,
    ID_PLAYBACK_CH56,
    ID_PLAYBACK_CH57,
    ID_PLAYBACK_CH58,
    ID_PLAYBACK_CH59,
    ID_PLAYBACK_CH60,
    ID_PLAYBACK_CH61,
    ID_PLAYBACK_CH62,
    ID_PLAYBACK_CH63,
    ID_PLAYBACK_CH64,
    ID_PLAYBACK_CHALLCOUNT,
};

enum{
    ID_LIVEVIEW_CH1 = 1,
    ID_LIVEVIEW_CH2,
    ID_LIVEVIEW_CH3,
    ID_LIVEVIEW_CH4,
    ID_LIVEVIEW_CH5,
    ID_LIVEVIEW_CH6,
    ID_LIVEVIEW_CH7,
    ID_LIVEVIEW_CH8,
    ID_LIVEVIEW_CH9,
    ID_LIVEVIEW_CH10,
    ID_LIVEVIEW_CH11,
    ID_LIVEVIEW_CH12,
    ID_LIVEVIEW_CH13,
    ID_LIVEVIEW_CH14,
    ID_LIVEVIEW_CH15,
    ID_LIVEVIEW_CH16,
    ID_LIVEVIEW_CH17,
    ID_LIVEVIEW_CH18,
    ID_LIVEVIEW_CH19,
    ID_LIVEVIEW_CH20,
    ID_LIVEVIEW_CH21,
    ID_LIVEVIEW_CH22,
    ID_LIVEVIEW_CH23,
    ID_LIVEVIEW_CH24,
    ID_LIVEVIEW_CH25,
    ID_LIVEVIEW_CH26,
    ID_LIVEVIEW_CH27,
    ID_LIVEVIEW_CH28,
    ID_LIVEVIEW_CH29,
    ID_LIVEVIEW_CH30,
    ID_LIVEVIEW_CH31,
    ID_LIVEVIEW_CH32,
    ID_LIVEVIEW_CH33,
    ID_LIVEVIEW_CH34,
    ID_LIVEVIEW_CH35,
    ID_LIVEVIEW_CH36,
    ID_LIVEVIEW_CH37,
    ID_LIVEVIEW_CH38,
    ID_LIVEVIEW_CH39,
    ID_LIVEVIEW_CH40,
    ID_LIVEVIEW_CH41,
    ID_LIVEVIEW_CH42,
    ID_LIVEVIEW_CH43,
    ID_LIVEVIEW_CH44,
    ID_LIVEVIEW_CH45,
    ID_LIVEVIEW_CH46,
    ID_LIVEVIEW_CH47,
    ID_LIVEVIEW_CH48,
    ID_LIVEVIEW_CH49,
    ID_LIVEVIEW_CH50,
    ID_LIVEVIEW_CH51,
    ID_LIVEVIEW_CH52,
    ID_LIVEVIEW_CH53,
    ID_LIVEVIEW_CH54,
    ID_LIVEVIEW_CH55,
    ID_LIVEVIEW_CH56,
    ID_LIVEVIEW_CH57,
    ID_LIVEVIEW_CH58,
    ID_LIVEVIEW_CH59,
    ID_LIVEVIEW_CH60,
    ID_LIVEVIEW_CH61,
    ID_LIVEVIEW_CH62,
    ID_LIVEVIEW_CH63,
    ID_LIVEVIEW_CH64,
    ID_LIVEVIEW_CHALLCOUNT,
};

typedef struct S_SYSTEMRIGHTS
{
    // 0:ѡ 1:ѡ
    //int iUseraccount;           
    //int iSystemSettings;        // ϵͳ
    //int iLogcleanup;            // ־
    //int iDefaultOrUpgrade;      // Ĭ/
    //int iPTZcontrol;            // ̨
    //int iSysteminformation;     // ϵͳϢ
    //int iClosesystem;           // رϵͳ
    //int iFilebackup;            // ļ

    
    // 0.û˺ 1.ϵͳ 2.־ 3.Ĭ/
    // 4.̨ 5.ϵͳϢ 6.رϵͳ 7.ļ 
    // 8.洢 9.¼ 10. 11.ͷ
    int iSystemRights[SDK_PERMISSION_BUIT];
    S_SYSTEMRIGHTS()
    {
        // 0:ѡ 1:ѡ
        for ( int i = 0 ; i < SDK_PERMISSION_BUIT ; i++ )
        {
        	iSystemRights[i] = 0;
        }
        /* iUseraccount = 0;
        iSystemSettings = 0;
        iLogcleanup = 0;
        iDefaultOrUpgrade = 0;
        iPTZcontrol = 0;
        iSysteminformation = 0;
        iClosesystem = 0;
        iFilebackup = 0;*/
    }

}s_systemRights;    // ûϵͳȨ

typedef struct S_PLAYRIGHTS
{
    int iChannelNo[ID_PLAYBACK_CHALLCOUNT];
    S_PLAYRIGHTS()
    {     
        // 0:ѡ 1:ѡ
        for ( int i = 0 ; i < ID_PLAYBACK_CHALLCOUNT ; i++ )
        {
            iChannelNo[i] = 0;
        }
    }

}s_playRights;    // ûȨ

typedef struct S_USERRIGHTS
{
    bool            bSelectSystemRights;  // true:ϵͳȨȫѡ,systemRights
    s_systemRights  systemRights;

    bool            bSelectPlayBackRights;      // ͬ
    s_playRights    s_playBackRights;

    bool            bSelectLiveRights;          // ͬ
    s_playRights    s_liveRights;

    S_USERRIGHTS()
    {
        bSelectSystemRights = false;
        bSelectPlayBackRights = false;
        bSelectLiveRights = false;
    }

}s_userRights; // ûȨ

typedef struct S_ADDUSER
{
    std::string strUsername;
    std::string strPassword;
    std::string strConfirmPasswd; // ȷ
    std::string strRemark;        // ע
    std::string strBelonggroup;   // 

    s_userRights    userRights;   // ûȨ

    S_ADDUSER()
    {
        memset(this,0,sizeof(s_addUser));
    }

}s_addUser; // û

typedef struct S_MONDIFYUSER
{
    std::string strOldUsername;
    

    bool bModifyUsername;           // true: ޸strNewUsername, false: ޸strNewUsername
    std::string strNewUsername;

    bool bModifyPassword;           // ͬ
    std::string strOldPassword;
    std::string strNewPassword;
    std::string strConfirmPasswd;   // ȷ

    bool bModifyRemark;             // ͬ
    std::string strNewRemark;        

    bool bModifyGroupName;          // ͬ
    std::string strNewGroupName; 

    bool bModifyGroupMark;          // ͬ
    std::string strNewGroupMark;

    s_userRights userRights;        // ûȨ

    S_MONDIFYUSER()
    {
        bModifyUsername = false;
        bModifyPassword = false;
        bModifyRemark = false;
        bModifyGroupName = false;
        bModifyGroupMark = false;
    }

}s_modifyUser; // ޸û

typedef struct S_DELETEUSER
{
    std::string strUsername;
    S_DELETEUSER()
    {
        memset(this,0,sizeof(s_deleteUser));
    }

}s_deleteUser; // ɾû

typedef struct S_GROUPSYSTEMRIGHTS
{
    // 0.û˺ 1.ϵͳ 2.־ 3.Ĭ/
    // 4.̨ 5.ϵͳϢ 6.رϵͳ 7.ļ 
    // 8.洢 9.¼ 10. 11.ͷ
    int iGroupSystemRights[SDK_PERMISSION_BUIT];
    S_GROUPSYSTEMRIGHTS()
    {
        // 0:ѡ 1:ѡ
        for ( int i = 0 ; i < SDK_PERMISSION_BUIT ; i++ )
        {
        	iGroupSystemRights[i] = 0;
        }
    }

}s_groupSystemRights;    // ϵͳȨ

typedef struct S_GROUPPLAYRIGHTS
{
    int iChannelNo[ID_PLAYBACK_CHALLCOUNT];
    S_GROUPPLAYRIGHTS()
    {
        // 0:ѡ 1:ѡ
        for ( int i = 0 ; i < ID_PLAYBACK_CHALLCOUNT ; i++ )
        {
            iChannelNo[i] = 0;
        }
    }

}s_groupPlayRights;    // طȨ

typedef struct S_GROUPLIVERIGHTS
{
    int iChannelNo[ID_LIVEVIEW_CHALLCOUNT];
    S_GROUPLIVERIGHTS()
    {
        // 0:ѡ 1:ѡ
        for ( int i = 0 ; i < ID_LIVEVIEW_CHALLCOUNT ; i++ )
        {
            iChannelNo[i] = 0;
        }
    }

}s_groupLiveRights;    // 鲥Ȩ

typedef struct S_GROUPRIGHTS
{
    s_groupSystemRights  groupSystemRights;

    s_groupPlayRights    groupPlayRights;
     
    s_groupLiveRights    groupliveRights;

}s_GroupRights; // Ȩ


typedef struct S_ADDGROUP
{
    std::string strGroupName;       // 
    std::string strGroupRemark;     // ע

    s_GroupRights    GroupRights;   // Ȩ

    S_ADDGROUP()
    {
        memset(this,0,sizeof(s_addGroup));
    }

}s_addGroup; // 

typedef struct S_MONDIFYGROUP
{
    std::string strOldGroupName;       // 
   
    std::string strNewGroupName;       // 
    std::string strNewGroupRemark;     // ±ע

    s_GroupRights    GroupRights;   // Ȩ

}s_modifyGroup; // ޸

typedef struct S_DELETEGROUP
{
    std::string strGroupname;

}s_deleteGroup; // ɾ

//-----------------------------------------------------------
// ͨ

typedef struct S_NvrUserRight
{
    BOOL bUserAccount;
    BOOL bSysSet;
    BOOL bLogClear;         // ж ־ { true:Ȩ𲻹; false:ִ־ }
    BOOL bDefaultUpgrade;
    BOOL bPtzCtrl;
    BOOL bSysInfo;
    BOOL bCloseSys;
    BOOL bFileBack;
    BOOL bStorageManamge;
    BOOL bEventSet;
    BOOL bNetworkSet;
    BOOL bCameraSet;
    S_NvrUserRight()
    {
        bUserAccount = FALSE;
        bSysSet = FALSE;
        bLogClear = FALSE;
        bDefaultUpgrade = FALSE;
        bPtzCtrl = FALSE;
        bSysInfo = FALSE;
        bCloseSys = FALSE;
        bFileBack = FALSE;
        bStorageManamge = FALSE;
        bEventSet = FALSE;
        bNetworkSet = FALSE;
        bCameraSet = FALSE;
    }
}s_nvrUserRight; // ͨ

typedef enum _MANUFACT_TYPE{
    MANUFACT_JXJ     = 0x00    /* JXJ豸 */
    ,MANUFACT_RTSP_CH = 0x01    /* ָͨ2RTSP URL ֱӴƵ */
    ,MANUFACT_ONVIF   = 0x02    /* ONVIF NVT */
    ,MANUFACT_RTSP    = 0x03    /* ׼RTSP URL, ʹͨò (豸) */
    ,MANUFACT_PRIVATE = 0x04
    ,MANUFACT_ONVIF_PRIVATE = 0x05
    ,MANUFACT_ONVIF_MULTISUBNET = 0x06  //
}MANUFACT_TYPE_E;

enum
{
    MAIN_STREAM,
    SUB_STREAM,
};
typedef struct S_ENCODINGPARAM
{
    int i_Stream;                   // 

    int i_Channel;                  // ͨ
    std::string str_StreamType;     //  (h264)
    std::string str_EncodMode;      // ģʽ
    std::string str_Resolution;     // ֱ(1280*720,1280*1024,1920*1080,3840*2160 )
    int i_FrameRate;                // ֡
    int i_BitRate;                  //  ( 64 ~ 12000 KB/S )
    S_ENCODINGPARAM()
    {
        i_Stream = MAIN_STREAM;
        i_Channel = 0;
        i_FrameRate = 0;
        i_BitRate = 64;
        str_StreamType = "h264";
        str_EncodMode = "Video";
    }

}s_encodingParam;   // 

typedef struct S_GETENCODINGPARAM{

    int     m_nEncodeMode;
    std::string m_sMainResolution;
    int     m_nMainResolution;
    int     m_nMainStreamType;
    std::string m_sMainType;
    int     m_nMainFramerate;
    int	    m_nMainStreamrate;
    int     m_nMainMaxFrameRate;
    int     m_nMainMinFrameRate;

    std::string m_sSubResolution;
    int     m_nSubResolution;
    int     m_nSubStreamType;
    std::string m_sSubType;
    int     m_nSubFramerate;
    int	    m_nSubStreamrate;
    int     m_nSubMaxFrameRate;
    int     m_nSubMinFrameRate;
    S_GETENCODINGPARAM()
    {
        memset(this,0,sizeof(S_GETENCODINGPARAM));
    }

}s_getEncodingparam; // ȡ

typedef struct S_MOTIONDETECTION
{
    int  i_Channel;                  // ͨ 

    int  i_Linkage;                 //       { 1: 0: }
    int  i_Buzzer;                  // 
    int  i_Videotape;               // ¼ͨ

    int  i_Sensitivity;             //  { 0 ~ 10 }
    int  i_BuzzerTime;              // ʱs
    int  i_VideotapeTime;           // ¼ʱs

    S_MOTIONDETECTION()
    {
        i_Channel = 0;

        i_Linkage = 0;
        i_Buzzer = 0;
        i_Videotape = 0;
        i_Sensitivity = 0;
        i_BuzzerTime = 0;
        i_VideotapeTime = 0;
    }

}s_motionDetection;   // ƶ

//-----------------------------------------------------------
typedef struct S_VIDEOSET
{
    int i_CHannel;  // ͨ{ 0 ~ 9 } 0:ȫ

    S_VIDEOSET()
    {
        i_CHannel = 0;
    }
}s_videoSet;    // ¼

//-----------------------------------------------------------
typedef struct S_GETDISKINFO
{
    std::string str_DiskNo;         // 
    std::string str_Status;         // ״̬
    std::string str_Capability;     // 
    std::string str_Freesapce;      // ʣ
    std::string str_Type;           // 豸

}s_getDiskInfo;             // ȡϢ

#define  RESTORE_CONFIG_COUNT  24
typedef enum _SDK_PARAM_MASK_ID 
{
    SDK_PARAM_MASK_ENCODE = 0x00	//bit.0: 
    ,SDK_PARAM_MASK_CHNNAME  		//ͨ ͨ
    ,SDK_PARAM_MASK_NET				//
    ,SDK_PARAM_MASK_DDNS			//ddns
    ,SDK_PARAM_MASK_EMAIL			//email
    ,SDK_PARAM_MASK_FTP				//FTP
    ,SDK_PARAM_MASK_UPNP			//upnp
    ,SDK_PARAM_MASK_PPPOE			//PPPOE
    ,SDK_PARAM_MASK_CLOUDSTORAGE	//ƴ
    ,SDK_PARAM_MASK_MOTION 			//ƶ
    ,SDK_PARAM_MASK_EVENT			//¼ Ӳ̴̴IPͻ 
    ,SDK_PARAM_MASK_RECORD 			//¼
    ,SDK_PARAM_MASK_COMM			// ϶ӦΪ豸ã
    ,SDK_PARAM_MASK_NTP 			//
    ,SDK_PARAM_MASK_DISPLAY			//ʾ	
    ,SDK_PARAM_MASK_DISCOLR 		//У	vga, hdmi
    ,SDK_PARAM_MASK_USER			//û 
    ,SDK_PARAM_MASK_AUTOMATIC		//Զά
    ,SDK_PARAM_MASK_CHANNEL			//ͨ	//hvr
    ,SDK_PARAM_MASK_PTZ				//PTZ, ahd
    ,SDK_PARAM_MASK_POLL 			//ͨԶѲ
    ,SDK_PARAM_MASK_TOUR			//ѲúõѲ 
    ,SDK_PARAM_MASK_IMAGE_ATTR 		//ͼɫ ɫʵ
    ,SDK_PARAM_MASK_PREVIEW			//Ԥ

    ,SDK_PARAM_MASK_ALARM_IN		//ⲿ	
    ,SDK_PARAM_MASK_SERIAL 			//XXXXXXڲ
    ,SDK_PARAM_MASK_OVERLAY			//XXXXXXڵ
    ,SDK_PARAM_MASK_OSD				//XXXXXXosd		
    ,SDK_PARAM_MASK_HIDE			//XXXXXXƵڵ
    ,SDK_PARAM_MASK_VIDEO_LOST		//XXXXXXƵʧ
    ,SDK_PARAM_MASK_TV 				//XXXXXX߾ڲ
    ,SDK_PARAM_MASK_BUIT

}SDK_PARAM_MASK_ID_E;

typedef struct S_RESTOREDEFAULT
{
    char Restore[RESTORE_CONFIG_COUNT];    

    bool b_RestoreFactory;   // true:ָ

    S_RESTOREDEFAULT()
    {
        // 0:ѡ 1:ѡ
        for ( int i = 0 ; i < RESTORE_CONFIG_COUNT ; i++ )
        {
        	Restore[i] = 0;
        }
        b_RestoreFactory = false;
    }

}s_restoreDefault; // ָĬ

enum LOG_TYPE
{
    FULLLOG  = 0,       // ȫ־
    SYSTEMMANAGE,       // ϵͳ
    USERMANAGE,         // û
    PARAMCONFIG,        // 
    FILEOPERATION,      // ļ
    STATUSHINT,         // ״̬ʾ
    ALARMEVENT          // 澯¼
};

typedef struct S_TIME
{
    int i_Year;
    int i_Month;
    int i_Day;
    int i_Hour;
    int i_Minuts;
    int i_Sec;
    S_TIME()
    {
       memset(this,0,sizeof(s_time));
    }

}s_time;

typedef struct S_LOGQUERY
{
    LOG_TYPE i_LogType;     // 
    s_time   StartTime;
    s_time   EndTime;

}s_logQuery;    // ־ѯ

typedef struct S_LOGQUERYRESULT
{
    std::string str_time;     // ʱ
    std::string str_event;
    std::string str_user;

}s_logQueryResult;    // ־ѯ״̬


#if 0
typedef struct S_DeviceUpgrade
{
    std::string str_UpgradeFilePath;    // ļ·
}s_deviceUpgrade; // 豸
#endif

///////////////////////////////////////////////////////////////////////////////
// 

//FRAME_INFO.avType
enum Stream_Type
{
	STREAM_VIDEO = 0,
	STREAM_AUDIO,
	STREAM_HEADER,
};


//FRAME_INFO.nalType
#define NAL_TYPE_SLICE      1
#define NAL_TYPE_IDR        5
#define NAL_TYPE_SEI        6
#define NAL_TYPE_SPS        7
#define NAL_TYPE_PPS        8
//#define NAL_TYPE_SEQ_END    9
//#define NAL_TYPE_STREAM_END 10

//FRAME_INFO.videoCoder
#ifndef VIDEO_CODER_H264
#define VIDEO_CODER_H264				96
#define VIDEO_CODER_MJPEG				26
#define VIDEO_CODER_MPEG4				99
#endif

//FRAME_INFO.audioCoder
#define AUDIO_CODER_G711_A				0x01  /* 64kbps G.711 A, see RFC3551.txt  4.5.14 PCMA */
#define AUDIO_CODER_G711_U				0x02  /* 64kbps G.711 U, see RFC3551.txt  4.5.14 PCMU */
#define AUDIO_CODER_G726_16KBPS			0x04  /* 16kbps G.726, see RFC3551.txt  4.5.4 G726-16 */
#define AUDIO_CODER_G726_24KBPS			0x05  /* 24kbps G.726, see RFC3551.txt  4.5.4 G726-24 */
#define AUDIO_CODER_G726_32KBPS			0x06  /* 32kbps G.726, see RFC3551.txt  4.5.4 G726-32 */
#define AUDIO_CODER_G726_40KBPS			0x07  /* 40kbps G.726, see RFC3551.txt  4.5.4 G726-40 */


/******ƶ*****/
#define MAX_MOTION_REGION		16
typedef struct
{
	DWORD	dwMotionMask;	
	SHORT	cbSensitive[MAX_MOTION_REGION];
	RECT	rcRegion[MAX_MOTION_REGION];
	DWORD	dwMotionTick[MAX_MOTION_REGION];
}MOTION_DETECT_INFO;
/***************/

typedef struct
{
	unsigned short	videoWidth;
	unsigned short	videoHeight;
	unsigned short	frameRate;
	unsigned char	videoCoder;
	unsigned char	audioCoder;
	unsigned long	bitRate;
	unsigned long	reserved1;
	unsigned long	reserved2;
	unsigned long	reserved3;
	unsigned long	reserved4;
}CLIENT_PARAM;

enum CaptureType
{
	CAPTURE_JPEG = 0,//Ĭ
	CAPTURE_BMP
};


/*************************** Ϣ ********************************/
//״̬Ϣ
enum MSG_TYPE
{
	//״̬ void*lpStruct = NULL
	MSG_LINK_OK = 0,			//ɹ
	MSG_LINK_CONNECTING,		//(м״̬)
	MSG_LINK_RECONNECT,			//
	MSG_LINK_FAILED,			//ʧ,,ҪϿͷԴ
	MSG_LINK_UNAUTHORIZED,		//û

	//תʹ
	MSG_TRANS_SVR_GETID_FAILED,		//ȡת豸ʱʧ
	MSG_TRANS_SVR_NOTFIND_DEST ,	//תӳɹ,Ҳת豸

	//¼״̬void*lpStruct = char*filename
	MSG_RECORD_BEGIN = 0x100,		//һ֡дʱصϢ
	MSG_RECORD_WRITE_ERROR,			//¼쳣,дļʧ
	MSG_RECORD_FORMAT_CHANGED,		//Ƶʽ,ֱ,֡ʷı,ڲѾֹͣ¼,Ҫ¼Ҫµÿʼ¼, һϢƵ
	MSG_RECORD_PACKET_FINISH,		//¼,ڲѾֹͣ¼,ⲿֱٵÿʼ¼񼴿

	//һ¼ļ,ר¼Ʊ¼void*lpStruct = char*filename
	MSG_RECORD_BEGIN_ANOTHER,			//ͬ
	MSG_RECORD_WRITE_ERROR_ANOTHER,		//ͬ
	MSG_RECORD_FORMAT_CHANGED_ANOTHER,	//ͬ
	MSG_RECORD_PACKET_FINISH_ANOTHER,	//ͬ

	//,Ϣ
	MSG_MOTION_DETECT = 0x200,		//Ƶƶ void*lpStruct = MOTION_DETECT_INFO*pMDInfo
	MSG_MOTION_DETECT_END,			//ƶʱϢ,Ĭ5,5޴ʹϢ
	MSG_VIDEO_LOST,					//Ƶʧ
	MSG_ALARM_IN,					//̽ͷ void *lpstruct = int* index

	

	//ץʹ	void *lpstruct = (char*)filename
	MSG_SHOT_FINISHED = 0X300,		//ץ,
	MSG_SHOT_FAILED,				//ץļ, ļʧ,ϵͳڴ治

	//ʹ
	MSG_REPLAY_FINISHED = 0X400,	//ļطŽ

	MSG_LIVEVIEW_FAILED = 0X410,

	MSG_SOUND_FAILED = 0X420,

	//豸صϢ
	MSG_UPGRADE_POS = 0X500,		// void *lpstruct = int* pos,Χ0-100, 
	 
};

typedef struct TalkHead_s{
	unsigned long 		len:10;
	unsigned long		reserved:22;
	unsigned long		timestamp;
}TalkHead_t;


/*wParam*/




#endif




