#ifndef __COMMON_DEFINE_HEADER_COMMONDEF_H__
#define __COMMON_DEFINE_HEADER_COMMONDEF_H__

#include "CommonDefExport.h"

#ifdef __cplusplus
extern "C"{
#endif

#if 0
// relate with register type on database
typedef enum __enumHwConfigType
{
	cfg_static = 0,
	cfg_register_pg,
	cfg_register_ab
}HW_CONFIG_TYPE;

typedef enum __enumHwChannelType {
    channel_unknown = 0,
    channel_video = 200,
	channel_video_ip_camera = 201,
	channel_video_ip_dome = 202,
	channel_video_ip_hemisphere = 203,
	channel_video_camera = 204,
	channel_video_dome = 205,
	channel_video_hemisphere = 206,
    channel_audio,
    channel_io = 300,
	channel_io_input = 301,
	channel_io_output = 302,
	channel_io_inAndOut = 303,
    channel_environment = 400,
	channel_environment_temperature = 401,
	channel_environment_humidity = 402,
	channel_environment_windspeed = 403
}HW_CHANNEL_TYPE,HS_CHANNEL_TYPE;

typedef enum __enumHwDataType
{
    data_unknown = 0,
    data_filename,
    data_video_mp4,
    data_video_h264,
    data_video_yuv,
    data_video_priv,
    data_audio_g711,
    data_audio_g722,
    data_audio_g726,
    data_audio_pcm,
    data_alarm_env,
	data_video_mp4_es,
	data_video_h264_es,
	data_video_h264_ps,
	data_video_mp4_ps,
	data_video_h264_ps_pg,
}HW_DATA_TYPE,HS_DATA_TYPE;

typedef enum __enumHwRawDataType{
	raw_data_unknown = 0,
	raw_data_yuv420p,
	raw_data_rgb,
	raw_data_rgba,
}HW_RAW_DATA_TYPE;


typedef struct __tagHwRawDataParam
{
	HW_RAW_DATA_TYPE RawDataType;

	unsigned int Width;

	unsigned int Height;

	unsigned int SrcWidth;

	unsigned int SrcHeight;

	unsigned int TimeStamp;

	unsigned int FrameNumber;

	unsigned char* DataBuffer[4];

	int DataSize[4];
}HW_RAW_DATA_PARAM;

typedef enum __enumHwCodecType
{
    codec_unknown = 0,
    codec_file,
    codec_stream,
	codec_audio,
    codec_yuv420
}HS_CODEC_TYPE;

typedef enum __enumHwRecordType
{
    record_unknown = 0,
    record_video,
    record_audio,
    record_alarm,
	record_environment,
	record_io,
    record_picture,
    record_doc,
    record_pdf
}HW_RECORD_TYPE;

typedef enum __enumHwRecordMode
{
	record_mode_unknown =0,
	record_mode_normal,
	record_mode_alarm
}HW_RECORD_MODE;

typedef enum __enumHwMapItemType
{
    mapitem_node = 0,
    mapitem_ip_device,
    mapitem_camera,
	mapitem_io_device,
	mapitem_env_device,
	mapitem_primary_device
}HW_MAPITEM_TYPE;

typedef enum __enumHwSearchMode
{
	search_unknown =0,
	search_device,
	search_platform,
	search_local
}HW_SEARCH_MODE;

typedef enum __enumHwFrameType
{
	frame_I =0,
	frame_P,
	frame_B
}HW_FRAME_TYPE;

typedef enum __enumHwPlayBackCommand
{
	playback_unknown =0,
	playback_pause,
	playback_resume,
	playback_speed,
	playback_getposition,
	playback_setposition
}HW_PLAYBACK_COMMAND;


typedef enum __enumHwDeviceReqType
{
	dev_data_unknown =0,
	dev_data_sustree,
	dev_data_suslist,
	dev_data_vaclist,
	dev_data_status,
	dev_data_frontstatus,
	dev_data_streamconfig,
	dev_get_addr,
	dev_get_user_info,
	dev_get_osd,
	dev_get_sys_info,
	dev_get_time_param,
	dev_get_log_info,
	dev_get_manage_info,
	dev_get_hide_area,
	dev_get_perform,
	dev_get_alarm_deploy,
	dev_get_alarm_subscribe,
	dev_get_alarm_cfg,
	dev_get_envdata_cfg,
    dev_get_external_status,
	dev_get_preset,
	dev_get_alarm_link_to_client,
    dev_get_rpu_info,
}HW_DEVICE_REQ_TYPE;


typedef enum __enumHwDeviceSetType
{
	dev_set_unknown =0,
	dev_set_streamconfig,
	dev_set_addr,
	dev_add_user_info,
	dev_del_user_info,
	dev_set_osd,
	dev_set_sys_info,
	dev_set_time_param,
	dev_set_manage_info,
	dev_set_hide_area,
	dev_set_alarm_deploy,
	dev_set_alarm_subscribe,
	dev_set_alarm_cfg,
	dev_set_envdata_cfg,
	dev_external_ctrl,
	dev_threeD_ctl,
	dev_switch_stream,
	dev_reboot,
	dev_ptz_ctrl,
	dev_set_osd_new
}HW_DEVICE_SET_TYPE;


typedef enum __enumHwDeviceRegisterType
{
	dev_register_unknown =0,
	dev_register_vac,
	dev_register_sus,
	dev_register_cmc,
	dev_register_gas
}HW_DEVICE_REGISTER_TYPE;

typedef enum __enumHwConnectionStatusType
{
	connection_unknown =0,
	connection_closed,
}HW_CONNECTION_STATUS;

typedef enum __enumHwOperateType
{
	operate_unknown=0,
	operate_add,
	operate_modify,
	operate_delete
}HW_OPERATE_TYPE;

typedef struct __tagHwConnectionStatusParam
{
	HW_CONNECTION_STATUS ConnectionStatus;
}HW_CONNECTION_STAUS_PARAM;

typedef struct __tagHwCodecParam
{
    HS_VENDER_TYPE VenderType;
    HS_CODEC_TYPE CodecType;
}HS_CODEC_PARAM;

typedef struct __tagHwWindowParam
{
    unsigned int WindowHandle;
	// 1 draw pix,2 texture,3 pixbuf
	unsigned int DisplayFlag;
}HS_WINDOW_PARAM;

typedef struct __tagHwDataHeader
{
	HW_FRAME_TYPE FrameType;	//frame type, such as I,P,B
	unsigned int FrameId;	 	//current frame id, first value 0
	unsigned int FrameLength;	//current frame data length
	unsigned int PacketCounter;	//current frame data packet counter
	unsigned int SequenceNum;	//current frame data packet sequence counter
	int TimeStamp;		//from 1970-01-01 seconds
	int TimeStampExt;	//microseconds
}HW_DATA_HEADER;


typedef struct __tagHwStreamParam
{
	int StreamType;	// 1=main stream, 2=sub stream
}HW_STREAM_PARAM;

typedef struct __tagHwDataParam
{
    // vender type, such as hikon,dahua, etc.
    HS_VENDER_TYPE VenderType;

    // Data type, such as mp4 video,264 video, G.731 audio, YUV420, etc.
    HW_DATA_TYPE DataType;

	HW_DATA_HEADER DataHeader;

    // Data Param depend on Datatype and VenderType
    // if(DataType == data_video_mp4 || DataType == data_video_h264){
    //   DataParam[0] = width;
    //   DataParam[1] = height;
    //   DataBuffer[0] =  video_data;
    //   DataSize[0] =  video_data size;
    //   rest reserve
    // }
    // if(DataType == data_video_yuv){
    //   DataParam[0] = width;
    //   DataParam[1] = height;
    //   DataBuffer[0] =  video_data_Y;
    //   DataBuffer[1] =  video_data_U;
    //   DataBuffer[2] =  video_data_V;
    //   DataSize[0] =  video_data_Y size;
    //   DataSize[1] =  video_data_U size;
    //   DataSize[2] =  video_data_V size;
    //   rest reserve
    // }
    // if(DataType == data_video_priv && VenderType == hikon){
    //   DataParam[0] = StreamType;	//such as 1 is SYSTEMHEAD, 2 is STREAMDATA
    //   DataParam[1] = height;
    //   DataBuffer[0] =  video_data_Y;
    //   DataBuffer[1] =  video_data_U;
    //   DataBuffer[2] =  video_data_V;
    //   DataSize[0] =  video_data_Y size;
    //   DataSize[1] =  video_data_U size;
    //   DataSize[2] =  video_data_V size;
    //   rest reserve
    // }
    unsigned int DataParam[8];
    unsigned char* DataBuffer[4];
    int DataSize[4];
}HW_DATA_PARAM;


typedef struct __tagHwDeviceStatusParam
{
	unsigned int CurrentStatus;
	unsigned int MemorySize;
	unsigned int MemoryUsed;
	unsigned int CPUUsed;
	unsigned int ConnectionCount;
}HW_DEVICE_STATUS_PARAM;


typedef struct __tagHwNode
{
    int NodeID;

    int NodeParentID;

    char NodeName[64];

	// Use for Business
    // BusinessParam[0] Use for polling interval
    // BusinessParam[3] Use for group interval
	int BusinessParam[8];
}HW_NODE_PARAM;

//typedef struct __tagHwDeviceParam
//{
//    HS_VENDER_TYPE VenderType;
//
//    HS_DEVICE_TYPE DeviceType;
//
//	// relate with register type on database
//	HW_CONFIG_TYPE ConfigType;
//
//    // device address, may be ip, hostname, url , etc.
//    char DeviceAddress[256];
//
//    // device port
//    int  DevicePort;
//
//    // device user name
//    char DeviceUser[32];
//
//    // device password
//    char DevicePwd[32];
//
//    // Device Name, show on screen
//    char DeviceName[64];
//
//    int DeviceID;
//    // Device Code,identify unique device
//    char DeviceCode[32];
//
//    // Device Parent Code
//    char DeviceParentCode[32];
//
//    // Node ID,denote which Node that Device belong to
//    int NodeID;
//
//	// Use for Business
//	// BusinessParam[0] Use for polling interval    
//    // BusinessParam[1] Use for polling Node Id
//    // BusinessParam[2] Use for getting device status
//    // BusinessParam[3] Use for group interval
//	int BusinessParam[8];
//}HS_DEVICE_PARAM;

typedef struct __tagHwDeviceRegisterParam
{
	// device register type
	HW_DEVICE_REGISTER_TYPE RegisterType;

	// device param
//	HS_DEVICE_PARAM DeviceParam;

	// device current status
	HW_DEVICE_STATUS_PARAM DeviceStatus;
}HW_DEVICE_REGISTER_PARAM;


//typedef struct __tagHwChannelParam
//{
//    // channel type, such as video channel, audeo channel, environment channel, etc.
//    HW_CHANNEL_TYPE ChannelType;
//
//	// relate with register type on database
//	HW_CONFIG_TYPE ConfigType;
//
//    // Channel Name, show on screen
//    char ChannelName[64];
//
//    int ChannelID;
//
//    // Channel Code,identify unique channel
//    char ChannelCode[32];
//
//    // Device ID,denote which device that chanel belong to
//    int DeviceID;
//
//    // Device Code,denote which device that chanel belong to
//    char DeviceCode[32];
//
//    // Channel Number
//    int ChannelNum;
//
//	//current stream type. as type: mainstream(0) or substream(1)
//	char StreamType;
//
//	// Use for Business
//	// BusinessParam[0] Use for polling interval
//    // BusinessParam[1] Use for describing device type this channel belongs to
//    // BusinessParam[2] Use for channel status: 1:online 0:offline
//	int BusinessParam[8];
//
//}HS_CHANNEL_PARAM;

typedef struct __tagHwDeviceTreeParam
{
    // result of the node count.
    unsigned int NodeCount;

    // node list
    HW_NODE_PARAM* NodeList;

    // result of the device count.
    unsigned int DeviceCount;

    // device list
//    HS_DEVICE_PARAM* DeviceList;

    // result of the channel count.
    unsigned int ChannelCount;

    // channel list
//    HS_CHANNEL_PARAM* ChannelList;

}HW_DEVICE_TREE_PARAM;




typedef struct __tagHwRecordInfo
{

    //unsigned int RecordType;
	HW_RECORD_TYPE RecordType;

	//RecordMode,such as nomal,alarm
    HW_RECORD_MODE RecordMode;

    // format: YYYYMMDDHHmmSS(14 char)
    char StartTime [16];

    // format: YYYYMMDDHHmmSS(14 char)
    char StopTime [16];

	// record size.
	unsigned int RecordSize;

	// record neme.
	char RecordName[128];

}HW_RECORD_INFO;

typedef struct __tagHwEnvironmentData
{
	char ChannelCode[20];

    char ChannelName[32];

	char DataValue[128];

    //DataValueͣͣ7 ޷ͣ4 ͣ9
	int  EnvirType;
	//¶ȣ,ʪȣ%rh,٣m/s
	char DataUnit[16];
    // format: YYYYMMDDHHmmSS(14 char)
	char AcquisTime[16];
}HW_ENVIR_DATA;

typedef enum __tag_enum_HwAlarmFlag{
	alarm_flag_general = 0,
	alarm_flag_lower_limit_1,
	alarm_flag_upper_limit_1,
	alarm_flag_lower_limit_2,
	alarm_flag_upper_limit_2
}HW_ALARM_FLAG;

typedef enum __tag_enum_HwAlarmType{
	alarm_type_unknown = 0,
	alarm_type_device_fail,
	alarm_type_hide_detect,
	alarm_type_loss_detect,
	alarm_type_motion_detect,
	alarm_type_disk_full,
	alarm_type_disk_error,
	alarm_type_temperature,
	alarm_type_humidity,
	alarm_type_windspeed,
	alarm_type_infrared,
	alarm_type_water_detect,
	alarm_type_door_guard,
	alarm_type_gas,
	alarm_type_fire_detect,
	alarm_type_theft_detect,
	alarm_type_electric,
	alarm_type_communication_fail,
	alarm_type_common_event,
	alarm_type_other=99
}HW_ALARM_TYPE;

typedef enum __tag_enum_HwAlarmLevel{
	alarm_level_grade_zero = 0,
	alarm_level_grade_one,
	alarm_level_grade_two,
	alarm_level_grade_three,
	alarm_level_grade_four
}HW_ALARM_LEVEL;

typedef struct __tagHwAlarmData
{
	unsigned long AlarmNo;		//ˮ
	unsigned long AlarmId;
	char ChannelCode[20];		//"" when it is not a channel
	char DeviceCode[20];
	int NodeID;
	HW_ALARM_FLAG AlarmFlag;
	HW_ALARM_TYPE AlarmType;
	HW_ALARM_LEVEL AlarmLevel;	//1:LEVEL1, 2:LEVEL2, 3:LEVEL3, 4:LEVEL4
	char AlarmSubTypeCode[16];	//if no use,set '\0'
	int AlarmState;				//1:alarm begin, 0:alarm end
	char OccurTime[16];			// format: YYYYMMDDHHmmSS(14 char)
	char EndTime[16];			// format: YYYYMMDDHHmmSS(14 char)
	char AlarmContent[128];		//some description of alarm
	char AlarmSource[128];		//where alarm occur
	char ConfirmMessage[128];
	char Confirmer[32];
	char ConfirmTime[16];		// format: YYYYMMDDHHmmSS(14 char)
}HW_ALARM_DATA;

typedef enum __tag_enum_HwAlarmSearchRange
{
	alarm_search_all = 0,	//
	alarm_search_node,		//ҵǸ澯
	alarm_search_device,	//ҵǸ澯豸
	alarm_search_channel,	//ҵǸ澯
}HW_ALARM_SEARCH_RANGE;

typedef struct __tagHwSearchParam
{
	// search start time
	// Format: YYYYMMDDHHmmSS(14 char)
	char StartTime [16];

	// search start time
	// Format: YYYYMMDDHHmmSS(14 char)
	char StopTime [16];

	//SearchMode:platform or device or local
	HW_SEARCH_MODE SearchMode;

	// Record type, such as video, audio, alarm,etc
	// 1=video 2=Audio 3=Alarm 4=Environment
	//unsigned int RecordType;
	HW_RECORD_TYPE RecordType;

	// Record param, depend on the RecordType
	// if RecordType==1, RecordParam[0] value: 1=normal 2=alarm 3=allrecord
	unsigned int RecordParam[8];

	HW_ALARM_SEARCH_RANGE searchAlarmRange;//ҵĸ澯豸Χ
	int nodeID;						//ҽڵID
	char searchDeviceCode[32];		//豸code
	char searchChannelCode[32];		//ͨcode
	HW_ALARM_TYPE searchAlarmType;	//澯
	HW_ALARM_LEVEL searchAlarmLevel;//澯ȼ
	int alarmState;					//澯״̬ȷϹΪ1δȷΪ0
	HW_ALARM_FLAG AlarmFlag;		//澯
}HW_SEARCH_PARAM;

typedef struct __tagHwEnvirAlarmLimit
{
	int ChannelID;
	char ChannelCode[32];
	int ChannelNum;
	HW_ALARM_TYPE AlarmType;
	HW_ALARM_FLAG AlarmFlag;
	float AlarmLimitValue;
}HW_ENVIR_ALARM_LIMIT;

typedef struct __tagHwAlarmLinkClient
{
    char devcode[20];            
    HW_ALARM_TYPE alarmtype;     
    HW_ALARM_FLAG alarmflag;     
    char linkdevcode[20];        
}HW_ALARM_LINKCLIENT;

typedef struct __tagHwAlarmLinkClientParam
{    
    int iLinkNum;           //
    HW_ALARM_LINKCLIENT* alarmlinkclient;
}HW_ALARM_LINKCLIENT_PARAM;

typedef struct __tagHwRecordParam
{
    //sush as platform,device,local
	HW_SEARCH_MODE SearchMode;

	//search result of the filelist size.
	unsigned int ElementSize;

	//record list
	HW_RECORD_INFO* pRecordList;

}HW_RECORD_PARAM;

typedef struct __tagHwPlayBackParam
{

    //sush as platform,device,local
	HW_SEARCH_MODE PlayBackMode;

    // record type, such as video, audio, alarm,etc
	HW_RECORD_TYPE RecordType;

    // format: YYYYMMDDHHmmSS(14 char)
    char StartTime [16];

    // format: YYYYMMDDHHmmSS(14 char)
    char StopTime [16];

	//search result of the filelist size.
	unsigned int ElementSize;

	//record list
	HW_RECORD_INFO* pRecordList;

}HW_PLAYBACK_PARAM;

typedef struct __tagHwPlayBackCtrl
{
	HW_PLAYBACK_COMMAND Command;

	//format: 1/2, 1/1, 2/1, 4/1, 8/1
    char Speed[8];

	//Set Playback Position
	int Position;
}HW_PLAYBACK_CTRL;

typedef struct __tagHwRecordSplitData
{
	//split media counter (like:10)
	int MediaCounter;

	//split media current number(like:0...9)
	int MediaNum;

	//1picture, 2text, now is picture
	int MediaType;

	//media name
	char MediaName[128];

    // format: YYYYMMDDHHmmSS(14 char)
    char StartTime [16];

    // format: YYYYMMDDHHmmSS(14 char)
    char StopTime [16];

    int MediaSize;

    unsigned char* MediaBuffer;

}HW_RECORDSPLIT_DATA;

typedef enum __tag_enum_HwPtzCommand
{
    ptz_unknown,
    ptz_light,          //
    ptz_wiper,          //
    ptz_fan,            //
    ptz_heater,         //
    ptz_aux1,           //
    ptz_aux2,           //
    ptz_zoom_in,        //
    ptz_zoom_out,       //
    ptz_focus_near,     //
    ptz_focus_far,      //
    ptz_iris_open,      //
    ptz_iris_close,     //
    ptz_up,             //
    ptz_down,           //
    ptz_left,           //
    ptz_right,          //
    ptz_up_left,        //
    ptz_up_right,       //
    ptz_down_left,      //
    ptz_down_right,     //
    ptz_auto            //
}HW_PTZ_COMMAND;

typedef struct __tagHwPtzParam
{
	//ptz control 1 start,2 stop
	unsigned int PtzControl;

    //ptz command
    HW_PTZ_COMMAND PtzCommand;

    //speed of ptz move (1-7)
	unsigned int PtzSpeed;
}HW_PTZ_PARAM;

typedef struct __tagHwIoCtrlParam
{
    //ioStatus0:close 1:open
    int ioStatus;
}HW_IOCTRL_PARAM;

typedef enum __tag_enum_HwPresetCommand
{
    preset_set,      //set preset pos
    preset_cleanup,  //clean preset
    preset_goto      //goto preset pos
}HW_PRESET_COMMAND;

typedef struct __tagHwPresetInfo
{
    //index of preset (1-255)
	int DeviceID;
	// Device Code,identify unique device
	char DeviceCode[32];

	int ChannelID;
	// Channel Code,identify unique channel
	char ChannelCode[32];

	unsigned int PresetIndex;

    char PresetName[64];

    char PresetComment[256];

    // Use for Business
    // BusinessParam[0] Use for polling interval
    int BusinessParam[8];
}HW_PRESET_INFO;

typedef struct __tagHwPresetParam
{
    //preset command
    HW_PRESET_COMMAND PresetCommand;

    HW_PRESET_INFO PresetInfo;

}HW_PRESET_PARAM;

typedef struct __tagHwPresetPollingParam
{
	int GroupId;

	char GroupName[64];

	char GroupDescription[256];

	unsigned int ElementSize;

	HW_PRESET_INFO* pPresetList;
}HW_PRESETPOLLING_PARAM;

typedef struct __tagHwMapItemParam
{
    //item id:NodeID,DeviceID,ChannelID
    int ItemID;
    //item type: 1 = node, 2 = device,3 = channel
    int ItemType;
    //item position
    char X[32];
    char Y[32];
}HW_EMAP_ITEM;

typedef struct __tagHwGisMapParam
{
    char centerCityName[256];
    char x[32];	
    char y[32];	
    short zoom;	
}HW_GISMAP;

typedef struct __tagHwMapInfoParam
{
    //map item count;
    int MapItemCount;
    //map item list
    HW_EMAP_ITEM* MapItemList;
}HW_EMAP_ITEMLIST;

typedef struct __tagHwMapPicture
{
    // map image data
    unsigned char* ImageData;
    // image data size
    unsigned int DataSize;
}HW_EMAP_PICTURE;

typedef struct __tagHwEmapInfo
{
    int NodeID;
    HW_EMAP_PICTURE MapPic;
    HW_EMAP_ITEMLIST ItemList;
    HW_EMAP_ITEMLIST GisItemList;
    HW_GISMAP GisMap;
}HW_EMAP_INFO;

typedef struct __tagHwEmapParam
{
    // cmd: 1 = upload, 2 = download, 3 = delete, 4 = upload GISMAP, 5 = download GISMAP, 6 = delete GISMAP
    int MapCmd;

    HW_EMAP_INFO MapInfo;
}HW_EMAP_PARAM;

typedef struct __tagHwListenParam
{
    HS_VENDER_TYPE VenderType;

    HS_DEVICE_TYPE DeviceType;

    char LocalAddress[32];

    int LocalPort;

    unsigned int ListenParam[8];
}HW_LISTEN_PARAM;

typedef enum __tagHwVideoAnalyseType
{
	video_analyse_acrossLine = 0,
	video_analyse_objectCount,
	video_analyse_invadeArea,
	video_analyse_hoverArea,
	video_analyse_disappear,
	video_analyse_remnant,
	video_analyse_wire_detect
}HW_VIDEO_ANALYSE_TYPE;

typedef struct __tagHwPoint
{
	// ֱϵһͼƬ
	// ֱ꣬ȡֵ 0-10000ԭͼƬϽ
	// ͼƬĵǣ5000,5000
	int x;
	int y;
}HW_POINT;

typedef struct __tagHwColor
{
	unsigned char red;
	unsigned char green;
	unsigned char blue;
	unsigned char alpha;
}HW_COLOR;

typedef struct __tagHwPaintParam
{
	int paintId;

	HW_POINT point[4];

	HW_COLOR color;

	int lineWidth;
	// 1=line, 2=rectangle
	int shapeType;

	// 0=no twinkle, 1=twinkle
	int twinkleType;

	// 0=infinite, unit milli second
	int showTime;
}HW_PAINT_PARAM;

typedef struct __tagHwVideoAnalyseShapeParam
{
	//1=line,2=rectangle,3=polygon
	int ShapeType;

	//when line or rectangle the shape is,the first two point in use
	HW_POINT *Point;

	int PointCount;

	//use for line,0=duble direction,1=right,2=left
	int LineDirect;

	//minWidth of the quarry
	int MinWidth; 

	//minHeight of the quarry
	int MinHeight; 

	//maxWidth of the quarry
	int MaxWidth; 

	//maxheight of the quarry
	int MaxHeight; 

	int DelayTime; 

	int WarningTime;
}HW_VIDEO_ANALYSE_SHAPE_PARAM;

typedef struct __tagHwVideoAnalyseTaskAuxParam
{
	int Sensitivity; 

	int AnalyseFrameRate;

	int CameraFrameRate;

	int AntiShake;
}HW_VIDEO_ANALYSE_TASK_AUX_PARAM;

typedef struct __tagHwVideoAnalyseTask
{
	char TaskName[64];

	HW_VIDEO_ANALYSE_TYPE VideoAnalyseType;

	HW_OPERATE_TYPE OperateType;

	HW_VIDEO_ANALYSE_SHAPE_PARAM *Shape;

	int ShapeCount;

	HW_VIDEO_ANALYSE_TASK_AUX_PARAM AuxParam;

	HW_RAW_DATA_PARAM ImageBase;
}HW_VIDEO_ANALYSE_TASK;

typedef struct __tagHwWireDetectEvent
{
	//lines that make the wire
	HW_POINT *LineStart;

	HW_POINT *LineEnd;

	int LinesCount;

	//whether the wire bent or not. 1=bent,0=straight
	int Bent;

	//1=cover,0=no cover
	int WireCover;

	//the part that was cover
	HW_POINT WireCoverStart;

	HW_POINT WireCoverEnd;

}HW_WIRE_DETECT_EVENT;

typedef struct __tagHwVideoAnalyseEvent
{
	int EventID;

	HW_WIRE_DETECT_EVENT WireEvent;

    //Center point of the quarry who activate the rule
	HW_POINT *QuarryPt;

	//Width of the quarry
	int *QuarryWidth;

    //Height of the quarry
	int *QuarryHeight;

	//whether quarry alarm or not
	int *QuarryAlarm;

	int QuarryCount;

	//the count of current active quarry of every shape
	int *ActivateCount;

	//activated total of every shape
	int *ActivatedTotal;

	int ShapeCount;

	//screenshot when event occur
	HW_RAW_DATA_PARAM ImageScreenshot;

	char EventTime[16];

	char EventDescription[256];
}HW_VIDEO_ANALYSE_EVENT;


typedef enum __emunHwBitRateType {
	bitrate_unknown_type = 0,
	bitrate_cbr_type,
	bitrate_vbr_type,
} HW_BITRATE_TYPE;

typedef enum __emunHwStreamType {
	stream_unknown_type = 0,
	stream_videostream_type,
	stream_composite_type,
} HW_STREAM_TYPE;



typedef enum __emumHwResolutionType {
	resolution_unknown = 0,
	resolution_360_160,
	resolution_640_360,
	resolution_640_480,
	resolution_1280_720,
	resolution_1280_960,
	resolution_1600_1200,
	resolution_1920_1080,
	resolution_QCIF, // 176 * 144
	resolution_CIF, // 352 * 288
	resolution_4CIF, // 704 * 576
} HW_Resolution_TYPE;

// أַ֧-1
typedef struct __tagHwStreamConfigParam {
	 // ֡(1-30)
	long FrameRate;
	// 
	long BitRate;
	// (VBR CBR)
	HW_BITRATE_TYPE BitRateType;
	// ֱ
	HW_Resolution_TYPE ResolutionType;
	 // ͼ(1-10)
	int Quality;
	 // ֡ʱ䣬λΪ(1-3)
	long FrameInterval;
	// ID1ʼ
	int StreamId;
	HW_STREAM_TYPE StreamType;

} HW_STREAM_CONFIG_PARAM;


typedef struct __tagHwConfigParam {
	HW_STREAM_CONFIG_PARAM Stream_Param; // 
} HW_CONFIG_PARAM;


typedef enum __tagHwDeviceStatus
{
	device_status_of_ban = 0,
	device_status_of_normal = 1,
	device_status_of_fault = 2
}HW_DEVICE_STATUS;

typedef struct __tagHwSusStatus
{
	int susId;
	char susCode[32];
	char susName[64];
	char ipAddress[256];
	int port;
	int susLevel;
	int susType;
	//char description[256];

	int status;
	int cpuUsed;
	int memorySize;
	int memoryUsed;
	int connectionCount;

	long lastTime;
}HW_SUS_STATUS;


typedef struct __tagHwSusStatusList
{

	//search result of the sus size.
	unsigned int ElementSize;

	//sus list
	HW_SUS_STATUS* psusStatusList;

}HW_SUS_STATUS_LIST;

typedef struct __tagHwCmsLoginUser
{
	char userName[64];
	//char userPwd[64];
	char roleName[256];
	char hostName[64];
	char ipAddress[256];
	int port;
	int userLevel;
	int userType;
	char description[256];

	int status;
	int cpuUsed;
	int memorySize;
	int memoryUsed;

	long loginTime;
	long lastTime;

}HW_CMS_LOGIN_USER;

typedef struct __tagHwCmsLoginUserList
{

	//search result of the user size.
	unsigned int ElementSize;

	//user list
	HW_CMS_LOGIN_USER* pcmsLoginUserList;

}HW_CMS_LOGIN_USER_LIST;

typedef struct __tagHwIpDeviceStatus
{
	int deviceId;
	char deviceCode[64];
	char ipAddress[256];
	int port;

	int status;

	long lastTime;

}HW_IP_DEVICE_STATUS;

typedef struct __tagHwIpDeviceStatusList
{

	//search result of the ipDevStatus size.
	unsigned int ElementSize;

	//ipDevStatus list
	HW_IP_DEVICE_STATUS* pipDeviceStatusList;

}HW_IP_DEVICE_STATUS_LIST;

typedef enum __tagHwProtocolType
{
	protocol_type_of_unknown = 0,
	protocol_type_of_pg = 1,
	protocol_type_of_ab = 2
}HW_PROTOCOL_TYPE;

typedef struct __tagHwProtocolNodeCode
{
	int nodeId;
	int protocolType;
	char nodeCode[64];

}HW_PROTOCOL_NODE_CODE;

typedef struct __tagHwProtocolNodeCodeList
{

	//search result of the ipDevStatus size.
	unsigned int ElementSize;

	//ipDevStatus list
	HW_PROTOCOL_NODE_CODE* protocolNodeCodeList;

}HW_PROTOCOL_NODE_CODE_LIST;

typedef enum __tagHwEmapCoorType
{
	emap_coordinate_type_of_unknown = 0,
	emap_coordinate_type_of_node = 1,
	emap_coordinate_type_of_ip_device = 2,
	emap_coordinate_type_of_front_device = 3
}HW_EMAP_COOR_TYPE;

typedef enum __tagHwRolePermission
{
	device_manager = 0x1,
	user_manager = 0x2,
	record_manager = 0x4,
	alarm_manager = 0x8,
	round_manager = 0x10,
	video_control = 0x20,
	record_control = 0x40,
	alaram_control = 0x80,
	env_control = 0x100,
	emap_control = 0x200,
	videoAnalysis_control = 0x400,
	monitor_manager = 0x800,
	map_manager = 0x1000,
	config_manager = 0x2000,
	maintain_control = 0x4000,
	monitor_control = 0x8000
}HW_ROLE_PERMISSION;

typedef enum __tagHwCmsCommand
{
	command_unknown = 0,
	command_login = 11,
	command_login_resp,
	command_restart_rpu = 21,
	command_restart_rpu_resp,
	command_update_rpu_info,
	command_update_rpu_info_resp,
	command_update_rpu_date_and_time,
	command_update_rpu_date_and_time_resp,
	command_get_rpu_info = 35,
	command_get_rpu_info_resp,
	command_add_log = 51,
	command_add_log_resp,
	command_get_log_info_by_id = 61,
	command_get_log_info_by_id_resp,
	command_query_log_list_by_log_condition,
	command_query_log_list_by_log_condition_resp,
	command_add_node = 101,
	command_add_node_resp,
	command_update_node,
	command_update_node_resp,
	command_delete_node,
	command_delete_node_resp,
	command_get_node_by_operator_id = 121,
	command_get_node_by_operator_id_resp,
	command_get_node_by_node_id,
	command_get_node_by_node_id_resp,
	command_query_node_list_by_parent_node_id,
	command_query_node_list_by_parent_node_id_resp,
	command_update_node_emap_coordinate_list = 151,
	command_update_node_emap_coordinate_list_resp,
	command_upload_emap,
	command_upload_emap_resp,
	command_delete_emap,
	command_delete_emap_resp,
	command_query_emap_coordinate_list_by_emap_id = 171,
	command_query_emap_coordinate_list_by_emap_id_resp,
	command_download_emap,
	command_download_emap_resp,
	command_add_ip_device = 201,
	command_add_ip_device_resp,
	command_update_ip_device,
	command_update_ip_device_resp,
	command_delete_ip_device,
	command_delete_ip_device_resp,
	command_get_ip_device_by_device_id = 221,
	command_get_ip_device_by_device_id_resp,
	command_query_ip_device_list_by_node_id,
	command_query_ip_device_list_by_node_id_resp,
	command_query_all_ip_device_list_by_node_id_and_ip_device_name,
	command_query_all_ip_device_list_by_node_id_and_ip_device_name_resp,
	command_dispatch_ip_device_to_streamer_by_list = 251,
	command_dispatch_ip_device_to_streamer_by_list_resp,
	command_delete_ip_device_streamer_list_by_list,
	command_delete_ip_device_streamer_list_by_list_resp,
	command_delete_ip_device_streamer_list_by_streamer_id,
	command_delete_ip_device_streamer_list_by_streamer_id_resp,
	command_get_ip_device_streamer_by_ip_device_id = 271,
	command_get_ip_device_streamer_by_ip_device_id_resp,
	command_query_ip_device_streamer_list_by_streamer_id,
	command_query_ip_device_streamer_list_by_streamer_id_resp,
	command_add_front_device = 301,
	command_add_front_device_resp,
	command_update_front_device,
	command_update_front_device_resp,
	command_delete_front_device,
	command_delete_front_device_resp,
	command_get_front_device_by_device_id = 321,
	command_get_front_device_by_device_id_resp,
	command_query_front_device_list_by_condition,
	command_query_front_device_list_by_condition_resp,
	command_query_all_front_device_list_by_node_id_and_device_name_and_type,
	command_query_all_front_device_list_by_node_id_and_device_name_and_type_resp,
	command_query_node_device_list_by_operator_id,
	command_query_node_device_list_by_operator_id_resp,
	command_add_camera_preset = 351,
	command_add_camera_preset_resp,
	command_update_camera_preset,
	command_update_camera_preset_resp,
	command_delete_camera_preset_by_preset_id,
	command_delete_camera_preset_by_preset_id_resp,
	command_delete_camera_preset_by_device_id_and_preset_index,
	command_delete_camera_preset_by_device_id_and_preset_index_resp,
	command_add_camera_preset_group,
	command_add_camera_preset_group_resp,
	command_update_camera_preset_group,
	command_update_camera_preset_group_resp,
	command_delete_camera_preset_group,
	command_delete_camera_preset_group_resp,
	command_get_camera_preset_by_preset_id = 371,
	command_get_camera_preset_by_preset_id_resp,
	command_query_camera_preset_list_by_device_id,
	command_query_camera_preset_list_by_device_id_resp,
	command_query_camera_preset_list_by_logic_node_id,
	command_query_camera_preset_list_by_logic_node_id_resp,
	command_get_preset_group_and_preset_list_by_group_id,
	command_get_preset_group_and_preset_list_by_group_id_resp,
	command_query_camera_preset_group_list_by_operator_id,
	command_query_camera_preset_group_list_by_operator_id_resp,
	command_add_operator = 401,
	command_add_operator_resp,
	command_update_operator,
	command_update_operator_resp,
	command_update_operator_password,
	command_update_operator_password_resp,
	command_reset_ohter_operator_password,
	command_reset_ohter_operator_password_resp,
	command_delete_operator,
	command_delete_operator_resp,
	command_get_operator_by_operator_id = 421,
	command_get_operator_by_operator_id_resp,
	command_get_operator_and_permission_by_operator_id,
	command_get_operator_and_permission_by_operator_id_resp,
	command_query_operator_list_by_node_id,
	command_query_operator_list_by_node_id_resp,
	command_query_all_operator_list_by_node_id,
	command_query_all_operator_list_by_node_id_resp,
	command_add_role = 451,
	command_add_role_resp,
	command_update_role,
	command_update_role_resp,
	command_delete_role,
	command_delete_role_resp,
	command_get_role_by_role_id = 471,
	command_get_role_by_role_id_resp,
	command_get_role_by_role_name,
	command_get_role_by_role_name_resp,
	command_query_role_list_by_role_name,
	command_query_role_list_by_role_name_resp,
	command_add_streamer = 501,
	command_add_streamer_resp,
	command_update_streamer,
	command_update_streamer_resp,
	command_delete_streamer,
	command_delete_streamer_resp,
	command_get_streamer_by_streamer_id = 521,
	command_get_streamer_by_streamer_id_resp,
	command_query_streamer_list_by_streamer_name,
	command_query_streamer_list_by_streamer_name_resp,
	command_add_and_update_record_task_list = 551,
	command_add_and_update_record_task_list_resp,
	command_add_record_task_form,
	command_add_record_task_form_resp,
	command_update_record_task_form,
	command_update_record_task_form_resp,
	command_delete_record_task_form,
	command_delete_record_task_form_resp,
	command_query_record_task_list_by_device_id = 571,
	command_query_record_task_list_by_device_id_resp,
	command_get_record_task_form_by_form_id,
	command_get_record_task_form_by_form_id_resp,
	command_get_record_task_form_by_form_name,
	command_get_record_task_form_by_form_name_resp,
	command_query_record_task_form_list_by_form_name,
	command_query_record_task_form_list_by_form_name_resp,
	command_add_view_group = 601,
	command_add_view_group_resp,
	command_update_view_group,
	command_update_view_group_resp,
	command_delete_view_group,
	command_delete_view_group_resp,
	command_get_view_group_by_group_id = 621,
	command_get_view_group_by_group_id_resp,
	command_get_group_and_device_list_by_group_id,
	command_get_group_and_device_list_by_group_id_resp,
	command_query_view_group_list_by_operator_id,
	command_query_view_group_list_by_operator_id_resp,
	command_add_round_scheme = 651,
	command_add_round_scheme_resp,
	command_update_round_scheme,
	command_update_round_scheme_resp,
	command_delete_round_scheme,
	command_delete_round_scheme_resp,
	command_get_round_scheme_by_scheme_id = 671,
	command_get_round_scheme_by_scheme_id_resp,
	command_get_scheme_and_group_list_by_scheme_id,
	command_get_scheme_and_group_list_by_scheme_id_resp,
	command_query_round_scheme_list_by_operator_id,
	command_query_round_scheme_list_by_operator_id_resp,
	command_update_alarm_source_alarm_level_and_defence_status = 701,
	command_update_alarm_source_alarm_level_and_defence_status_resp,
	command_query_alarm_source_list_by_condition = 711,
	command_query_alarm_source_list_by_condition_resp,
	command_add_and_update_alarm_action_list = 726,
	command_add_and_update_alarm_action_list_resp,
	command_query_alarm_action_list_by_alarm_action_condition = 736,
	command_query_alarm_action_list_by_alarm_action_condition_resp,
	command_add_primary_device = 751,
	command_add_primary_device_resp,
	command_update_primary_device,
	command_update_primary_device_resp,
	command_delete_primary_device,
	command_delete_primary_device_resp,
	command_get_primary_device_by_device_id = 771,
	command_get_primary_device_by_device_id_resp,
	command_get_primary_device_and_front_device_list_by_primary_device_id,
	command_get_primary_device_and_front_device_list_by_primary_device_id_resp,
	command_query_primary_device_list_by_device_name,
	command_query_primary_device_list_by_device_name_resp,
	command_add_logic_node = 801,
	command_add_logic_node_resp,
	command_update_logic_node,
	command_update_logic_node_resp,
	command_update_logic_node_camera_preset_list,
	command_update_logic_node_camera_preset_list_resp,
	command_delete_logic_node,
	command_delete_logic_node_resp,
	command_get_logic_node_by_operator_id = 821,
	command_get_logic_node_by_operator_id_resp,
	command_get_logic_node_by_logic_node_id,
	command_get_logic_node_by_logic_node_id_resp,
	command_query_logic_node_list_by_parenet_node_id,
	command_query_logic_node_list_by_parenet_node_id_resp,
	command_query_logic_node_list_and_camera_preset_rel_list_by_operator_id,
	command_query_logic_node_list_and_camera_preset_rel_list_by_operator_id_resp
}HW_CMS_COMMAND;

typedef enum __tagHwCmsMessageCode
{
	message_unknown,
	message_response_timeout,
	message_login_successful = 11,
	message_login_failed,
	message_user_name_error,
	message_user_password_error,
	message_user_has_longined_error,
	message_restart_rpu_successful = 21,
	message_restart_rpu_failed,
	message_update_rpu_info_successful,
	message_update_rpu_info_failed,
	message_update_rpu_info_for_ip_formate_error,
	message_update_rpu_date_and_time_successful,
	message_update_rpu_date_and_time_failed,
	message_get_rpu_info_successful = 35,
	message_get_rpu_info_failed,
	message_add_log_successful = 51,
	message_add_log_failed,
	message_get_log_info_successful = 61,
	message_get_log_info_failed,
	message_query_log_list_successful,
	message_query_log_list_failed,
	message_add_node_successful = 101,
	message_add_node_failed,
	message_update_node_successful,
	message_update_node_failed,
	message_delete_node_successful,
	message_delete_node_failed,
	message_node_name_null_error,
	message_node_name_char_error,
	message_node_name_duplicate_error,
	message_abbreviation_char_error,
	message_delete_node_failed_for_child_node_error,
	message_get_node_info_successful = 121,
	message_get_node_info_failed,
	message_query_node_list_successful,
	message_query_node_list_failed,
	message_get_node_info_by_node_id_for_no_node_error,
	message_update_node_emap_coordinate_list_successful = 151,
	message_update_node_emap_coordinate_list_failed,
	message_upload_emap_successful,
	message_upload_emap_failed,
	message_delete_emap_successful,
	message_delete_emap_failed,
	message_delete_emap_failed_for_no_node_error,
	message_query_emap_coordinate_list_successful = 171,
	message_query_emap_coordinate_list_failed,
	message_download_emap_successful,
	message_download_emap_failed,
	message_download_emap_for_no_emap_error,
	message_add_ip_device_successful = 201,
	message_add_ip_device_failed,
	message_update_ip_device_successful,
	message_update_ip_device_failed,
	message_delete_ip_device_successful,
	message_delete_ip_device_failed,
	message_ip_device_code_duplicate,
	message_ip_device_name_duplicate,
	message_ip_device_ip_duplicate,
	message_get_ip_device_info_successful = 221,
	message_get_ip_device_info_failed,
	message_query_ip_device_list_successful,
	message_query_ip_device_list_failed,
	message_get_ip_device_info_by_ip_device_id_for_no_ip_device_error,
	message_dispatch_ip_device_to_streamer_by_list_successful = 251,
	message_dispatch_ip_device_to_streamer_by_list_failed,
	message_delete_ip_device_streamer_list_successful,
	message_delete_ip_device_streamer_list_failed,
	message_get_ip_device_streamer_info_successful = 271,
	message_get_ip_device_streamer_info_failed,
	message_query_ip_device_streamer_list_successful,
	message_query_ip_device_streamer_list_failed,
	message_get_ip_device_streamer_by_id_for_no_info_error,
	message_add_front_device_successful = 301,
	message_add_front_device_failed,
	message_update_front_device_successful,
	message_update_front_device_failed,
	message_delete_front_device_successful,
	message_delete_front_device_failed,
	message_front_device_code_duplicate,
	message_front_device_name_duplicate,
	message_front_device_index_duplicate,
	message_get_front_device_info_successful = 321,
	message_get_front_device_info_failed,
	message_query_front_device_list_successful,
	message_query_front_device_list_failed,
	message_query_node_device_list_successful,
	message_query_node_device_list_failed,
	message_query_front_device_list_for_condition_error,
	message_get_front_device_info_by_device_id_for_no_device_error,
	message_add_camera_preset_successful = 351,
	message_add_camera_preset_failed,
	message_update_camera_preset_successful,
	message_update_camera_preset_failed,
	message_delete_camera_preset_successful,
	message_delete_camera_preset_failed,
	message_camera_preset_name_duplicate_error,
	message_camera_preset_index_duplicate_error,
	message_camera_preset_group_name_duplicate_error,
	message_add_camera_preset_group_successful,
	message_add_camera_preset_group_failed,
	message_update_camera_preset_group_successful,
	message_update_camera_preset_group_failed,
	message_delete_camera_preset_group_successful,
	message_delete_camera_preset_group_failed,
	message_get_camera_preset_successful = 371,
	message_get_camera_preset_failed,
	message_query_camera_preset_list_successful,
	message_query_camera_preset_list_failed,
	message_get_preset_group_and_preset_list_successful,
	message_get_preset_group_and_preset_list_failed,
	message_query_camera_preset_group_list_successful,
	message_query_camera_preset_group_list_failed,
	message_get_camera_preset_by_preset_id_for_no_preset_error,
	message_get_preset_group_and_preset_list_by_group_id_for_no_group_error,
	message_add_operator_successful = 401,
	message_add_operator_failed,
	message_update_operator_successful,
	message_update_operator_failed,
	message_update_operator_password_successful,
	message_update_operator_password_failed,
	message_reset_ohter_operator_password_successful,
	message_reset_ohter_operator_password_failed,
	message_delete_operator_successful,
	message_delete_operator_failed,
	message_operator_name_duplicate,
	message_operator_old_password_error,
	message_reset_ohter_operator_password_for_not_root_user_error,
	message_delete_operator_for_delete_self_error,
	message_delete_operator_for_lower_priority_level_error,
	message_get_operator_successful = 421,
	message_get_operator_failed,
	message_get_operator_and_permission_successful,
	message_get_operator_and_permission_failed,
	message_query_operator_list_successful,
	message_query_operator_list_failed,
	message_query_all_operator_list_successful,
	message_query_all_operator_list_failed,
	message_get_operator_by_operator_id_for_no_operator_error,
	message_get_operator_and_permission_by_operator_id_for_no_operator_error,
	message_add_role_successful = 451,
	message_add_role_failed,
	message_update_role_successful,
	message_update_role_failed,
	message_delete_role_successful,
	message_delete_role_failed,
	message_role_name_duplicate,
	message_get_role_successful = 471,
	message_get_role_failed,
	message_query_role_list_successful,
	message_query_role_list_failed,
	message_get_role_by_role_id_for_no_role_error,
	message_add_streamer_successful = 501,
	message_add_streamer_failed,
	message_update_streamer_successful,
	message_update_streamer_failed,
	message_delete_streamer_successful,
	message_delete_streamer_failed,
	message_streamer_code_duplicate,
	message_streamer_name_duplicate,
	message_get_streamer_info_successful = 521,
	message_get_streamer_info_failed,
	message_query_streamer_list_successful,
	message_query_streamer_list_failed,
	message_get_streamer_info_by_streamer_id_for_no_streamer_error,
	message_add_and_update_record_task_list_successful = 551,
	message_add_and_update_record_task_list_failed,
	message_add_record_task_form_successful,
	message_add_record_task_form_failed,
	message_update_record_task_form_successful,
	message_update_record_task_form_failed,
	message_delete_record_task_form_successful,
	message_delete_record_task_form_failed,
	message_record_task_form_name_duplicate,
	message_query_record_task_list_by_device_id_successful= 571,
	message_query_record_task_list_by_device_id_failed,
	message_get_record_task_form_successful,
	message_get_record_task_form_failed,
	message_query_record_task_form_list_successful,
	message_query_record_task_form_list_failed,
	message_get_record_task_by_device_id_for_info_error,
	message_get_record_task_form_by_form_id_for_info_error,
	message_get_record_task_form_by_form_name_for_info_error,
	message_add_view_group_successful = 601,
	message_add_view_group_failed,
	message_update_view_group_successful,
	message_update_view_group_failed,
	message_delete_view_group_successful,
	message_delete_view_group_failed,
	message_view_group_name_duplicate_error,
	message_get_view_group_successful = 621,
	message_get_view_group_failed,
	message_get_group_and_device_list_successful,
	message_get_group_and_device_list_failed,
	message_query_view_group_list_successful,
	message_query_view_group_list_failed,
	message_get_view_group_by_group_id_for_no_group_error,
	message_get_group_and_device_list_by_group_id_for_no_group_error,
	message_add_round_scheme_successful = 651,
	message_add_round_scheme_failed,
	message_update_round_scheme_successful,
	message_update_round_scheme_failed,
	message_delete_round_scheme_successful,
	message_delete_round_scheme_failed,
	message_round_scheme_name_duplicate_error,
	message_get_round_scheme_successful = 671,
	message_get_round_scheme_failed,
	message_get_scheme_and_group_list_successful,
	message_get_scheme_and_group_list_failed,
	message_query_round_scheme_list_successful,
	message_query_round_scheme_list_failed,
	message_get_round_scheme_by_scheme_id_for_no_scheme_error,
	message_get_scheme_and_group_list_by_scheme_id_for_no_scheme_error,
	message_update_alarm_source_alarm_level_and_defence_successful = 701,
	message_update_alarm_source_alarm_level_and_defence_failed,
	message_query_alarm_source_list_successful = 711,
	message_query_alarm_source_list_failed,
	message_query_alarm_source_list_for_condition_error,
	message_add_and_update_alarm_action_list_successful = 726,
	message_add_and_update_alarm_action_list_failed,
	message_query_alarm_action_list_successful = 736,
	message_query_alarm_action_list_failed,
	message_query_alarm_action_list_for_condition_error,
	message_add_primary_device_successful = 751,
	message_add_primary_device_failed,
	message_update_primary_device_successful,
	message_update_primary_device_failed,
	message_delete_primary_device_successful,
	message_delete_primary_device_failed,
	message_primary_device_name_duplicate_error,
	message_get_primary_device_successful = 771,
	message_get_primary_device_failed,
	message_get_primary_device_and_front_device_list_successful,
	message_get_primary_device_and_front_device_list_failed,
	message_query_primary_device_list_successful,
	message_query_primary_device_list_failed,
	message_get_primary_device_and_front_device_list_by_device_id_for_no_primary_device_error,
	message_add_logic_node_successful = 801,
	message_add_logic_node_failed,
	message_update_logic_node_successful,
	message_update_logic_node_failed,
	message_update_logic_node_camera_preset_list_successful,
	message_update_logic_node_camera_preset_list_failed,
	message_delete_logic_node_successful,
	message_delete_logic_node_failed,
	message_logic_node_name_duplicate_error,
	message_get_logic_node_successful = 821,
	message_get_logic_node_failed,
	message_query_logic_node_list_successful,
	message_query_logic_node_list_failed,
	message_query_logic_node_list_and_camera_preset_rel_list_successful,
	message_query_logic_node_list_and_camera_preset_rel_list_failed,
	message_get_logic_node_by_logic_node_id_for_no_logic_node_error
}HW_CMS_MESSAGE_CODE;

typedef struct __tagHwRpuInfo
{
    char rpuCode[32];
    char rpuName[64];
    char rpuIp[32];
    int rpuPort;
    char regesterPlatformIp[32];
    int regesterPlatformPort;
    char regesterPlatformUserName[32];
    char regesterPlatformPassword[32];
    int isRegester;
    int rpuHeartbeatTime;
    int rpuEnvCollectRate;
    int rpuEnvSaveRate;
}HW_RPU_INFO;

typedef struct __tagHwOperResult
{
	int result;
	int messageCode;
	char message[512];

}HW_OPER_RESULT;

typedef struct __tagHwConfigCommand
{
	int command;
	HW_OPER_RESULT operResult;

}HW_CONFIG_COMMAND;

typedef struct __tagHwBigIapCommand
{
	int iapLength;
	int iapCommand;
	char message[512];

}HW_BIG_IAP_COMMAND;

typedef struct __tagHw3DPtzCtl
{    
	unsigned int usChanid;
	unsigned short usConmmand;
	unsigned short param[7];
	unsigned int res;
}HW_3D_PTZ_CTL;

typedef struct __tagHwOsdInfo
{
	int iOsdindex;  //osd
	int iOsd_x;     //osdX
	int iOsd_y;     //osdY		
	int iBgcolor;   //osdɫ
	int iAlpha;     //osd͸,ĬֵΪ128
	char szOsd_text[128]; //osd
}HW_OSD_INFO;

typedef struct __tagHwOsd
{
	int iVideoId;    //Ƶchannelı

	int iSubNum;     //osd,4osd,Ϊ0ʱûosdϢ

	HW_OSD_INFO iOsdItem[4];   //osdϢ
}HW_OSD;

typedef struct __tagHWMimeData
{
//	HS_DEVICE_PARAM device[3];
	int devNum;
//	HS_CHANNEL_PARAM channel;
	int itemType;    //1:channel 2:device 3:node 
	HW_NODE_PARAM node;
}HWMimeData;


typedef struct __tagHwSystemLogSearch
{
	int flag;
	int page;
}HW_SYSTEM_LOG_SEARCH;

typedef struct __tagHwSystemLog
{
	char user[32];
	char message[256];
	int currentIndex;
	int currentPage;
	int totalPage;
}HW_SYSTEM_LOG;
#endif
//////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////

typedef enum __enumHsVenderType
{
	vender_unknown = 0,
	vender_huwei,
	vender_hikon,
	vender_dahua,
	vender_panasonic,
	vender_jingyang,
	vender_cnb,
	vender_cnbdome,
	vender_cnbonvif,
	vender_zhongyu,
	vender_nfdl,
	vender_bosch,
	vender_beseen,
	vender_longse,
	vender_onvif,
	vender_longsenvr1,
	vender_simulate,
}/*HS_VENDER_TYPE,*/HS_VENDER_TYPE;

typedef enum __enumHsDeviceType
{
	device_unknown = 0,
	device_database = 50,
	device_dvr = 101,
	device_nvr = 102,
	device_rpu = 103,
	device_environment=104,
	device_alarmhost=105,
	device_idvr = 106,
	device_xvr = 107,
	device_p2p_ipc = 108,
	device_p2p_nvr = 110,
	device_ip_camera = 201,
	device_ip_dome = 202,
	device_ip_hemisphere = 203,
	device_camera = 204,
	device_dome = 205,
	device_hemisphere = 206,
	device_input = 301,
	device_output = 302,
	device_inAndOut = 303,
	device_temperature = 401,
	device_humidity = 402,
	device_windspeed = 403,
	device_webservices = 901,
	device_stream_server = 902,
	device_cms = 903,
	device_cmc = 904,
	device_vac = 905,
	device_ans = 906,
	device_gas=907,//sipgw
	device_gac=908,//sipgw
	device_anc = 909
}/*HS_DEVICE_TYPE,*/HS_DEVICE_TYPE;

typedef enum __enumHwConfigType
{
	cfg_static = 0,
	cfg_register_pg,
	cfg_register_ab
}HW_CONFIG_TYPE;

typedef enum __enumHwChannelType {
	channel_unknown = 0,
	channel_video = 200,
	channel_video_ip_camera = 201,
	channel_video_ip_dome = 202,
	channel_video_ip_hemisphere = 203,
	channel_video_camera = 204,
	channel_video_dome = 205,
	channel_video_hemisphere = 206,
	channel_audio,
	channel_io = 300,
	channel_io_input = 301,
	channel_io_output = 302,
	channel_io_inAndOut = 303,
	channel_environment = 400,
	channel_environment_temperature = 401,
	channel_environment_humidity = 402,
	channel_environment_windspeed = 403
}HS_CHANNEL_TYPE;

typedef enum __enumHwDataType
{
	data_unknown = 0,
	data_filename,
	data_video_mp4,
	data_video_h264,
	data_video_yuv,
	data_video_priv,
	data_audio_g711,
	data_audio_g722,
	data_audio_g726,
	data_audio_pcm,
	data_alarm_env,
	data_video_mp4_es,
	data_video_h264_es,
	data_video_h264_ps,
	data_video_mp4_ps,
	data_video_h264_ps_pg,
}HS_DATA_TYPE;

typedef enum __enumHsRawDataType{
	raw_data_unknown = 0,
	raw_data_yuv420p,
	raw_data_rgb,
	raw_data_rgba,
}HS_RAW_DATA_TYPE;

typedef struct __tagHsRawDataParam
{
	HS_RAW_DATA_TYPE RawDataType;

	unsigned int Width;

	unsigned int Height;

	unsigned int SrcWidth;

	unsigned int SrcHeight;

	unsigned int TimeStamp;

	unsigned int FrameNumber;

	unsigned char* DataBuffer[4];

	int DataSize[4];
}HS_RAW_DATA_PARAM;

typedef struct __tagHwWindowParam
{
	void* WindowHandle;
	// 1 draw pix,2 texture,3 pixbuf
	unsigned int DisplayFlag;
}HS_WINDOW_PARAM;

typedef enum __enumHsDeviceReqType
{
	dev_req_unknown =0,

	dev_req_add_device_info = 1,
	dev_req_update_device_info,
	dev_req_delete_device_info,
	dev_req_get_device_info,
	dev_req_get_user_device_info,
	dev_req_get_all_device_info,
	dev_req_search_device,
	dev_req_search_device_end,

	dev_req_add_storage_info = 101,
	dev_req_update_storage_info,
	dev_req_delete_storage_info,
	dev_req_get_storage_info,
	dev_req_get_all_storage_info,

	dev_req_add_channelSchedule_info = 201,
	dev_req_update_channelSchedule_info,
	dev_req_delete_channelSchedule_info,
	dev_req_get_channelSchedule_info,
	dev_req_get_all_channelSchedule_info,

	dev_req_add_online_schedules_info = 301,
	dev_req_update_online_schedules_info,
	dev_req_delete_online_schedules_info,
	dev_req_get_online_schedules_info,
	dev_req_get_online_all_schedules_info,

	dev_req_add_speedup_schedules_info = 351,
	dev_req_update_speedup_schedules_info,
	dev_req_delete_speedup_schedules_info,
	dev_req_get_speedup_schedules_info,
	dev_req_get_speedup_all_schedules_info,

	dev_req_add_record_schedules_info = 381,
	dev_req_update_record_schedules_info,
	dev_req_delete_record_schedules_info,
	dev_req_get_record_schedules_info,
	dev_req_get_record_all_schedules_info,

	dev_req_add_user_info = 401,
	dev_req_update_user_info,
	dev_req_delete_user_info,
	dev_req_get_user_info,
	dev_req_get_all_user_info,

	dev_req_add_channelRights_info = 501,
	dev_req_update_channelRights_info,
	dev_req_delete_channelRights_info,
	dev_req_get_channelRights_info,
	dev_req_get_all_channelRights_info,

	dev_req_set_view_group_info = 601,
	dev_req_get_view_group_info,
	dev_req_set_view_group_data,
	dev_req_get_view_group_data,
	dev_req_get_all_view_group_data,
	dev_req_get_all_view_group_info,
	dev_req_delete_view_group,

	dev_req_get_system_rights_info = 701,

	dev_req_add_server_info = 801,
	dev_req_update_server_info,
	dev_req_delete_server_info,
	dev_req_get_server_info,
	dev_req_get_all_server_info,

	dev_req_set_net_param = 901,
	dev_req_get_net_param,

	dev_req_add_archive_info = 1001,
	dev_req_update_archive_info,
	dev_req_delete_archive_info,
	dev_req_get_archive_info,
	dev_req_get_all_archive_info,

	dev_req_add_alarm_info = 1101,
	dev_req_update_alarm_info,
	dev_req_delete_alarm_info,
	dev_req_get_alarm_info,
	dev_req_get_all_alarm_info,
}HS_DEVICE_REQ_TYPE;

typedef struct __tagHsDeviceOperResult
{
	int result;
	HS_DEVICE_REQ_TYPE command;
}HS_DEVICE_OPER_RESULT;

typedef struct __tagHsCallbackData
{
	void* data1;
	int len1;
	void* data2;
	int len2;
}HS_CALLBACK_DATA;

typedef enum __enumHsConnectionStatusType
{
	hs_connection_unknown =0,
	hs_connection_closed,
}HS_CONNECTION_STATUS;

typedef enum __enumHsMessageType
{
	hs_msg_unknown =0,
	hs_msg_connection_ok,
	hs_msg_connection_failed,
	hs_msg_connection_closed,
	hs_msg_connection_stream_closed,
	hs_msg_reconnecting,
	hs_msg_reconnecting_failed,
	hs_msg_login_ok,
	hs_msg_login_failed,
	hs_msg_stream_ok,
	hs_msg_stream_failed,
	hs_msg_stream_no_data,
	hs_msg_no_video,
	hs_msg_ptz_ok,
	hs_msg_ptz_failed,
	hs_msg_download_picture_ok,
	hs_msg_download_picture_failed,
	hs_msg_playbackctrl_ok,
	hs_msg_playbackctrl_failed,
	hs_msg_alarm_ok,
	hs_msg_alarm_failed,
	hs_msg_heartbeat_ok,
	hs_msg_max_clients,
	hs_msg_channel_disabled,
	hs_msg_channel_delete,
	hs_msg_record_begin,			//һ֡дʱصϢ
	hs_msg_record_write_error,			//¼쳣,дļʧ
	hs_msg_record_format_changed,	//Ƶʽ,ֱ,֡ʷı,ڲѾֹͣ¼,Ҫ¼Ҫµÿʼ¼, һϢƵ
	hs_msg_record_packet_finish	,		//¼,ڲѾֹͣ¼,ⲿֱٵÿʼ¼񼴿

	hs_msg_client_initializeing = 200,
	hs_msg_client_initialize_finish,
	hs_msg_client_initialize_failed,
	hs_msg_get_user_info_finish,
	hs_msg_get_user_info_failed,
	hs_msg_get_server_info_finish,
	hs_msg_get_server_info_failed,
	hs_msg_get_device_info_finish,
	hs_msg_get_device_info_failed,
	hs_msg_get_channelRights_info_finish,
	hs_msg_get_channelRights_info_failed,
	hs_msg_get_view_group_info_finish,
	hs_msg_get_view_group_info_failed,
	hs_msg_get_view_group_finish,
	hs_msg_set_view_group_finish,
	hs_msg_set_view_group_failed,

	hs_msg_upgrade_ok		= 280,
	hs_msg_upgrade_failed,
	hs_msg_upgrade_per,

	hs_event_type_alarm = 300,			//HS_ALARM_DATA
	hs_event_type_recording,		//HS_RECORDING_STATUS
	hs_event_type_onlinestatus,	//HS_MESSAGE_PARAM
	hs_event_type_msg_content,					//ͨϢͣϢһṹ
	hs_event_type_upgrade,
}HS_MESSAGE_TYPE;

typedef struct __tagHsConnectionStatusParam
{
	HS_CONNECTION_STATUS ConnectionStatus;
}HS_CONNECTION_STAUS_PARAM;

typedef struct __tagHsUpgradeMessageParam
{
	HS_MESSAGE_TYPE messageType;
	int upgradePos;
	int res[2];
}HS_UPGRADE_MESSAGE_PARAM;

typedef struct __tagHsMessageParam
{
	HS_MESSAGE_TYPE messageType;
	char deviceGuid[48];
	char channelGuid[48];
}HS_MESSAGE_PARAM;

typedef enum __tag_enum_HsPtzCommand
{
	hs_ptz_unknown,
	hs_ptz_light,          //
	hs_ptz_wiper,          //
	hs_ptz_fan,            //
	hs_ptz_heater,         //
	hs_ptz_aux1,           //
	hs_ptz_aux2,           //
	hs_ptz_zoom_in,        //
	hs_ptz_zoom_out,       //
	hs_ptz_focus_near,     //
	hs_ptz_focus_far,      //
	hs_ptz_iris_open,      //
	hs_ptz_iris_close,     //
	hs_ptz_up,             //
	hs_ptz_down,           //
	hs_ptz_left,           //
	hs_ptz_right,          //
	hs_ptz_up_left,        //
	hs_ptz_up_right,       //
	hs_ptz_down_left,      //
	hs_ptz_down_right,     //
	hs_ptz_auto            //
}HS_PTZ_COMMAND;

typedef struct __tagHsPtzParam
{
	//ptz control 1 start,2 stop
	unsigned int PtzControl;

	//ptz command
	HS_PTZ_COMMAND PtzCommand;

	//speed of ptz move (1-7)
	unsigned int PtzSpeed;
}HS_PTZ_PARAM;

typedef enum __tag_enum_HsAlarmFlag{
	alarm_flag_general = 0,
	alarm_flag_lower_limit_1,
	alarm_flag_upper_limit_1,
	alarm_flag_lower_limit_2,
	alarm_flag_upper_limit_2
}HS_ALARM_FLAG;

typedef enum __tag_enum_HsAlarmType{
	alarm_type_unknown = 0,
	alarm_type_device_fail,
	alarm_type_hide_detect,
	alarm_type_loss_detect,
	alarm_type_motion_detect,
	alarm_type_disk_full,
	alarm_type_disk_error,
	alarm_type_temperature,
	alarm_type_humidity,
	alarm_type_windspeed,
	alarm_type_infrared,
	alarm_type_water_detect,
	alarm_type_door_guard,
	alarm_type_gas,
	alarm_type_fire_detect,
	alarm_type_theft_detect,
	alarm_type_electric,
	alarm_type_communication_fail,
	alarm_type_common_event,
	alarm_type_other=99
}HS_ALARM_TYPE;

typedef enum __tag_enum_HsAlarmLevel{
	alarm_level_grade_zero = 0,
	alarm_level_grade_one,
	alarm_level_grade_two,
	alarm_level_grade_three,
	alarm_level_grade_four
}HS_ALARM_LEVEL;

typedef struct __tagHsAlarmData
{
	char AlarmGuid[48];
	unsigned long AlarmNo;		//ˮ
	char ChannelGuid[48];		//"" when it is not a channel
	char DeviceGuid[48];
	int NodeID;
	HS_ALARM_FLAG AlarmFlag;
	HS_ALARM_TYPE AlarmType;
	HS_ALARM_LEVEL AlarmLevel;	//1:LEVEL1, 2:LEVEL2, 3:LEVEL3, 4:LEVEL4
	char AlarmSubTypeCode[16];	//if no use,set '\0'
	int AlarmState;				//1:alarm begin, 0:alarm end
	char BeginTime[16];			// format: YYYYMMDDHHmmSS(14 char)
	char EndTime[16];			// format: YYYYMMDDHHmmSS(14 char)
	char AlarmContent[128];		//some description of alarm
	char AlarmSource[128];		//where alarm occur
	char ConfirmMessage[128];
	char Confirmer[32];
	char ConfirmTime[16];		// format: YYYYMMDDHHmmSS(14 char)
}HS_ALARM_DATA;

typedef struct __tagHsEventInfo
{
	HS_MESSAGE_TYPE EventType;
	void *EventContent;
}HS_EVENT_INFO;

typedef struct __tagHsEventInfoList
{
	HS_EVENT_INFO *EventInfoList;
	int nCount;
}HS_EVENT_INFO_LIST;

typedef enum __tag_enum_HsRecordErrorCode
{
	rd_error_noerror = 0,	//û
	rd_error_recording,		//¼
	rd_error_disk,				//̴
	rd_error_diskfull,		//̿ռ䲻
	rd_error_io,					//io
	rd_error_file,				//ʣļʧ
	rd_error_dir,					//ʣļʧ
	rd_error_camera,			//Ŀ
}HS_RECORD_ERROR_CODE;

typedef enum __tag_enum_HsAlarmSearchRange
{
	alarm_search_all = 0,	//
	alarm_search_node,		//ҵǸ澯
	alarm_search_device,	//ҵǸ澯豸
	alarm_search_channel,	//ҵǸ澯
}HS_ALARM_SEARCH_RANGE;

typedef enum __enumHsPlayBackCommand
{
	hs_playback_unknown =0,
	hs_playback_pause,
	hs_playback_resume,
	hs_playback_speed,
	hs_playback_getposition,
	hs_playback_setposition,
	hs_playback_play_backward,
	hs_playback_play_forward,
	hs_playback_previous_frame,
	hs_playback_next_frame,
}HS_PLAYBACK_COMMAND;

typedef enum __enumHsRecordType
{
	hs_record_unknown = 0,
	hs_record_video,
	hs_record_audio,
	hs_record_alarm,
	hs_record_environment,
	hs_record_io,
	hs_record_picture,
	hs_record_doc,
	hs_record_pdf
}HS_RECORD_TYPE;

typedef enum __enumHsRecordMode
{
	hs_record_mode_unknown =0,
	hs_record_mode_normal,
	hs_record_mode_alarm,
	hs_record_mode_all
}HS_RECORD_MODE;

typedef enum __enumHsSearchMode
{
	hs_search_unknown =0,
	hs_search_device,
	hs_search_platform,
	hs_search_local
}HS_SEARCH_MODE;

typedef struct __tagHsRecordingStatus
{
	char StatusGuid[48];
	char ChannelGuid[48];				//
	char DeviceGuid[48];
	HS_RECORD_TYPE RecordType;
	char OccurredTime[16];			// format: YYYYMMDDHHmmSS(14 char)
	char MessageDesc[128];							//the description of message.
	int ErrorCode;			
	int Status;						//1:record start, 0:record stop
}HS_RECORDING_STATUS;

typedef struct __tagHsSearchParam
{
	// search start time
	// Format: YYYYMMDDHHmmSS(14 char)
	char StartTime [16];

	// search start time
	// Format: YYYYMMDDHHmmSS(14 char)
	char StopTime [16];

	//SearchMode:platform or device or local
	HS_SEARCH_MODE SearchMode;

	// Record type, such as video, audio, alarm,etc
	// 1=video 2=Audio 3=Alarm 4=Environment
	//unsigned int RecordType;
	HS_RECORD_TYPE RecordType;

	// Record param, depend on the RecordType
	// if RecordType==1, RecordParam[0] value: 1=normal 2=alarm 3=allrecord
	unsigned int RecordParam[8];

	HS_ALARM_SEARCH_RANGE searchAlarmRange;//ҵĸ澯豸Χ
	int nodeID;						//ҽڵID
	char searchDeviceCode[32];		//豸code
	char searchChannelCode[32];		//ͨcode
	HS_ALARM_TYPE searchAlarmType;	//澯
	HS_ALARM_LEVEL searchAlarmLevel;//澯ȼ
	int alarmState;					//澯״̬ȷϹΪ1δȷΪ0
	HS_ALARM_FLAG AlarmFlag;		//澯
}HS_SEARCH_PARAM;

typedef struct __tagHsSearchRecordParam
{
	// search start time
	// Format: YYYYMMDDHHmmSS(14 char)
	unsigned int StartTime;

	// search start time
	// Format: YYYYMMDDHHmmSS(14 char)
	unsigned int StopTime;

	//SearchMode:platform or device or local
	HS_SEARCH_MODE SearchMode;

	// Record type, such as video, audio, alarm,etc
	// 1=video 2=Audio 3=Alarm 4=Environment
	//unsigned int RecordType;
	HS_RECORD_TYPE RecordType;

	//RecordMode,such as nomal,alarm
	HS_RECORD_MODE RecordMode;

	// Record param
	unsigned int RecordParam[8];
}HS_SEARCH_RECORD_PARAM;

typedef struct __tagHsRecordInfo
{
	char Guid[48];
	//unsigned int RecordType;
	HS_RECORD_TYPE RecordType;

	//RecordMode,such as nomal,alarm
	HS_RECORD_MODE RecordMode;

	// format: YYYYMMDDHHmmSS(14 char)
	unsigned int StartTime;

	// format: YYYYMMDDHHmmSS(14 char)
	unsigned int StopTime;

	// record size.
	unsigned int RecordSize;

	// record neme.
	char RecordName[256];

}HS_RECORD_INFO;

typedef struct __tagPictureInfo
{
	char Guid[48];
	char PictureUrl[1024];
	char *PictureBuffer;
	int PictureSize;
}HS_PICTURE_INFO;

typedef struct __tagHsRecordElementParam
{
	char ChannelGuid[48];
	HS_RECORD_INFO RecordInfo;
	HS_PICTURE_INFO PictureInfo;
	int Index;
}HS_RECORD_ELEMENT_PARAM;

typedef struct __tagHsRecordParam
{
	char ChannelGuid[48];
	//sush as platform,device,local
	HS_SEARCH_MODE SearchMode;

	//search result of the filelist size.
	unsigned int ElementSize;

	//record list
	HS_RECORD_ELEMENT_PARAM* pRecordList;

}HS_RECORD_PARAM;

typedef struct __tagHsPlayBackParam
{
	char PlaybackGuid[48];
	//sush as platform,device,local
	HS_SEARCH_MODE PlayBackMode;

	// record type, such as video, audio, alarm,etc
	HS_RECORD_TYPE RecordType;
	
	//format: 1/8,1/4,1/2, 1/1, 2/1, 4/1, 8/1
	char Speed[8];

	// format: YYYYMMDDHHmmSS(14 char)
	unsigned int StartTime;

	// format: YYYYMMDDHHmmSS(14 char)
	unsigned int StopTime;

	//search result of the filelist size.
	unsigned int ElementSize;

	//record list
	HS_RECORD_ELEMENT_PARAM* pRecordList;

}HS_PLAYBACK_PARAM;

typedef struct __tagHsPositionParam
{
	char PlaybackGuid[48];
	int PositionType;
	unsigned int Position;
}HS_POSITION_PARAM;

typedef struct __tagHsPlayBackCtrl
{
	char PlaybackGuid[48];

	HS_PLAYBACK_COMMAND Command;

	//format: 1/8,1/4,1/2, 1/1, 2/1, 4/1, 8/1
	char Speed[8];

	//Set Playback Position
	HS_POSITION_PARAM Position;
}HS_PLAYBACK_CTRL;

typedef enum __enumHsMediaType
{
	HS_MEDIA_TYPE_UNKNOWN,
	HS_MEDIA_TYPE_ES,
	HS_MEDIA_TYPE_PS,
	HS_MEDIA_TYPE_AVI,
	HS_MEDIA_TYPE_MOV,
}HS_MEDIA_TYPE;

typedef enum __enumHsStreamType
{
	HS_STREAM_TYPE_MAIN,
	HS_STREAM_TYPE_SUB,
}HS_STREAM_TYPE;

typedef struct __tagHsExportRecordParam
{
	char FileName[1024];
	HS_MEDIA_TYPE MediaType;
	int RecordTime;
	int res;
}HS_EXPORT_RECORD_PARAM;

typedef struct __tagHsStreamParam
{
	int StreamType;	// 1=main stream, 2=sub stream
}HS_STREAM_PARAM;

typedef struct __tagHsStreamHeader{
	unsigned short  ulFlag;            //  00 01

	unsigned char   ucState;           //  ״̬
	unsigned char   ucRes[1];          //  
	unsigned int   bMediaType:2;      //  0:Ƶ   1:Ƶ   2:ͷϢ   3:ͼƬ
	unsigned int   bFrameType:5;      //  ֡
	unsigned int   bSize:22;          //  ֡
	unsigned int   bSubStream:2;      //  
	unsigned int   bRes:1;            //  

	unsigned char   usCH;              //  ͨ 0 1 2 3
	unsigned char   usVideoEncodeType;      //  Ƶ 
	unsigned char   usAudioEncodeType;      //  Ƶ 
	unsigned char   usRes[1];          //   ֽڶ

	unsigned int   ucSerialNum;       //  ֡
	unsigned int   ulTimeStamp;       //  ʱ

	unsigned short  usWidth;           //  
	unsigned short  usHeight;          //  ߶
	unsigned short  ucFrameRate;       //  ֡
	unsigned short  ucBitRate;         //  

	unsigned int   ulTimeStampExt;	//ʱ벿
}HS_STREAM_HEADER;

typedef struct __tagHsDataParam
{
	// vender type, such as hikon,dahua, etc.
	HS_VENDER_TYPE VenderType;

	// Data type, such as mp4 video,264 video, G.731 audio, YUV420, etc.
	HS_DATA_TYPE DataType;

	HS_STREAM_HEADER DataHeader;
	unsigned int DataParam[8];
	unsigned char* DataBuffer[4];
	int DataSize[4];
}HS_DATA_PARAM;

typedef enum __enumHwCodecType
{
	codec_unknown = 0,
	codec_file,
	codec_stream,
	codec_audio,
	codec_yuv420
}HS_CODEC_TYPE;
typedef struct __tagHwCodecParam
{
	HS_VENDER_TYPE VenderType;
	HS_CODEC_TYPE CodecType;
	union{
		HS_STREAM_HEADER DataHeader;
		char FileName[512];
	}CodecHeader;
}HS_CODEC_PARAM;
/////////////û//////////////////
typedef enum __enumHsUserRoleType
{
	HS_USER_TYPE_SUPER_ADMIN = 1,
	HS_USER_TYPE_ADMIN = 2,
	HS_USER_TYPE_BASIC = 5,
}HS_USER_ROLE_TYPE;

typedef struct __tagHsServerInfo
{
	char Guid[48];
	char DisplayName[64];
	char PrivateAddress[32];
	int PrivatePort;
	bool EnabledPublic;
	char PublicAddress[32];
	int PublicPort;
	int MaxClient;
}HS_SERVER_INFO;

typedef struct __tagHsServerInfoList
{
	int Count;
	HS_SERVER_INFO *ServerInfoList;
}HS_SERVER_INFO_LIST;
/////////////豸///////////////
typedef enum __enumHsDeviceDriverType
{
	
}HS_DEVICE_DRIVER_TYPE;

////////////豸Ϣ////////////////////
typedef struct __tagHsDeviceParam
{
	char DeviceGuid[48];
	char ServerGuid[48];
	HS_VENDER_TYPE VenderType;
	HS_DEVICE_TYPE DeviceType;
	HS_DEVICE_DRIVER_TYPE DeviceDriverType;
	char Mac[24];					//p2pʹøֶαsn
	char DisplayName[64];
	char DeviceAddress[1024];
	int DevicePort;
	int HttpPort;
	int RtspPort;
	char UserName[64];
	char Password[64];
	int State;
	char Token[48];   
	int ChannelCount;
	int nIndex;
	int PlaybackPort;
	int res[2];
}HS_DEVICE_PARAM;

typedef struct __tagHsDeviceParamList
{
	int Count;
	HS_DEVICE_PARAM *DeviceParams;
}HS_DEVICE_PARAM_LIST;

////////////豸////////////////////
typedef struct __tagHsDeviceNetParam
{
	HS_VENDER_TYPE VenderType;
	HS_DEVICE_TYPE DeviceType;
	char Mac[24];
	char NetmaskAddr[16];
	char GatewayAddr[16];
	char DisplayName[64];
	char DeviceAddress[1024];
	int  DevicePort;
	int  RtspPort;
	char ucDnsAddr1[16];
	char ucDnsAddr2[16];
	int  ChannelCount;
	char Dhcp;
	int nIndex;
	char BroadcastAddr[16];
	int PlaybackPort;
	int res;
	unsigned int   ucPlatformType;                       /*ƽ̨: */
	unsigned char   ucDevType[32];                        /*豸: */
	unsigned char   ucSoftwareVersion[64];                /*汾*/
	unsigned char   ucFirmwareVersion[64];                /*̼汾*/
}HS_DEVICE_NET_PARAM;

////////////ӲϢ///////////
typedef struct __tagHsUpgradeParam
{
	char FialeName[2048];
}HS_UPGRADE_PARAM;

////////////ͨ////////////////////
typedef struct __tagHsChannelProperty
{
	char ChannelGuid[48];
	int Hidden;
	int Disabled;
	bool Preview;
	bool HalfSize;
	int DeviceIndex;
	int DBRepairStrateqy;
	HS_STREAM_TYPE LiveStreamIndex;
	int LiveStreamSettings;
}HS_CHANNEL_PROPERTY;

////////////ͨϢ////////////////////
typedef struct __tagHsChannelParam
{
	char ChannelGuid[48];
	char DeviceGuid[48];
	char DisplayName[64];
	int ChannelNum;
	HS_CHANNEL_TYPE ChannelType;
	HS_CHANNEL_PROPERTY ChannelProperty;
	int BusinessParam[8];
}HS_CHANNEL_PARAM;

typedef struct __tagHsChannelParamList
{
	int Count;
	HS_CHANNEL_PARAM *ChannelParams;
}HS_CHANNEL_PARAM_LIST;

typedef struct __tagHsDeviceTreeParam
{
	// result of the server count.
	unsigned int ServerCount;

	// server list
	HS_SERVER_INFO* ServerList;

	// result of the device count.
	unsigned int DeviceCount;

	// device list
	HS_DEVICE_PARAM* DeviceList;

	// result of the channel count.
	unsigned int ChannelCount;

	// channel list
	HS_CHANNEL_PARAM* ChannelList;

}HS_DEVICE_TREE_PARAM;

typedef struct __tagHsDeviceInfo
{
	HS_DEVICE_PARAM deviceParam[4];
	int deviceCount;
	HS_CHANNEL_PARAM channelParam;
}HS_DEVICE_INFO;

//////////////ʱ/////////////////
typedef enum __enumHsSchedulesType
{
	HS_SCHEDULES_TYPE_UNKNOWN,
	HS_SCHEDULES_TYPE_ALWAYS,
	HS_SCHEDULES_TYPE_NEVER,
	HS_SCHEDULES_TYPE_USER,
}HS_SCHEDULES_TYPE;

//////////////ʱϢ/////////////////
typedef struct __tagHsSchedulesInfo
{
	char Guid[48];
	char Name[64];
	//(0,288);(289,576);ÿһʱ,һжʱ,0~288һ,288~576ڶ,576~864,864~1152,1152~1440,1440~1728,1728~2016
	char Schedules[2048];
	HS_SCHEDULES_TYPE SchedulesType;
}HS_SCHEDULES_INFO;

typedef struct __tagHsSchedulesInfoList
{
	int Count;
	HS_SCHEDULES_INFO *SchedulesInfos;
}HS_SCHEDULES_INFO_LIST;

typedef enum __enumHsStorageSaveType
{
	HS_STORAGE_TYPE_ALWAYS,
	HS_STORAGE_TYPE_NEVER,
	HS_STORAGE_TYPE_MOTION,
	HS_STORAGE_TYPE_SCHEDULES,
}HS_STORAGE_SAVE_TYPE;

////////////ͨ洢Ϣ////////////////
typedef struct __tagHsStorageInfo
{
	//ͨGuid
	char ChannelGuid[48];
	//¼Ϣļ·
	char DatabasePath[256];
	char DatabasePathNonUNC [256];
	//¼ýļ·
	char ArchivePath[256];
	char archivePathNonUNC[256];
	int DBRepairStrateqy;
	int ArchiveDb;
	int ArchiveWhenDBFull;
	//¼ıʱ,ԷΪλ
	int ArchiveMagAge;         
	//¼񴥷
	HS_STORAGE_SAVE_TYPE DbSaveMode;      
	//Ԥ¼
	bool EnableDbPreSecs;
	//ú¼
	bool EnableDbPostSecs;
	//Ԥ¼ʱ
	int DbPreSecs;
	//¼ʱ
	int DbPostSecs;
	
	int AdminDbPreSecs;

	int AdminDbPostSecs;

	int DbLimitType;
	
	int DbLimitCount;
	//¼¼
	bool SaveOnEvent;
	//ƶ֡¼
	bool SaveOnMotion;
	//¼¼ʼ¼
	char SaveStartEventGuid[48];
	//¼¼ֹͣ¼
	char SaveStopEventGuid[48];
	//ʱϢ
	HS_SCHEDULES_INFO SchedulesInfo;
	//ֶ¼ʱ
	int ManualRecordSecs;
	//Ƶ
	HS_STREAM_TYPE VideoStreamType;
	int res[4];
}HS_STORAGE_INFO;

typedef struct __tagHsStorageInfoList
{
	int Count;
	HS_STORAGE_INFO *StorageInfos;
}HS_STORAGE_INFO_LIST;

typedef struct __tagHsManualRecordInfo
{
	//ֶ¼GUID
	char Guid[48];
	//ֶ¼ʱ
	int ManualRecordSecs;
}HS_MANUAL_RECORD_INFO;

typedef struct __tagHsArchiveinfo
{
	char Guid[48];
	char ArchiveTime[16];  //ÿ浵ʱ HHmmSS
}HS_ARCHIVE_INFO;

typedef struct __tagHsArchiveInfoList
{
	int Count;
	HS_ARCHIVE_INFO *ArchiveInfos;
}HS_ARCHIVE_INFO_LIST;

//////////////ͨƻϢ////////////
typedef struct __tagHsChannelScheduleInfo
{
	char Guid[48];

	char ChannelGuid[48];
	//ʱ
	HS_SCHEDULES_TYPE OnlineScheduingType;
	//ʱ
	HS_SCHEDULES_INFO OnlineSchedules;
	//ʱ
	HS_SCHEDULES_TYPE SpeedupSchedulingType;
	//ʱ
	HS_SCHEDULES_INFO SpeedupSchedules;
}HS_CHANNEL_SCHEDULE_INFO;

//////////////ûȨ////////////////
typedef struct __tagHsUserRights
{
	char UserGuid[48];
	//ͼ
	bool SharedViews;
	//˽ͼ
	bool PrivateViews;
	//ͼֱ
	bool ViewLive;
	//ͼط
	bool ViewBrowse;
	//ͼ
	bool ViewSetup;
	bool ManagementAccess;
}HS_USER_RIGHTS;

//////////////ûϢ///////////////////
typedef struct __tagHsUserInfo
{
	char UserGuid[48];
	char Id[48];
	char AdsPath[48];
	char Username[80];
	char Password[80];
	HS_USER_ROLE_TYPE UserType;
	char SId[48];
	char SamacCountName[48];
	HS_USER_RIGHTS UserRights;
}HS_USER_INFO;

typedef struct __tagHsUserInfoList
{
	int Count;
	HS_USER_INFO *UserInfoList;
}HS_USER_INFO_LIST;

/////////////ûͨȨ///////////////
typedef struct __tagHsUserChannelRights
{
	char Guid[48];
	char ChannelGuid[48];
	char UserGuid[48];
	bool Access;				//Ȩ
	bool AviExport;				//aviȨ			
	bool JpegExport;			//jpegȨ
	bool DatabaseExport;		//
	bool ViewLive;				//ʵʱԤȨ
	bool ViewBrowse;			//طȨ					
	bool Ptz;					//ptzȨ
	bool ManagePresets;			//Ԥõ
	bool Outputs;				
	bool Presets;				//Ԥ
	bool Events;
	bool SmartSearch;			//
	bool Sequences;
	bool StartRecording;		//ֶ¼
	bool AudioLive;				//ʵʱԤƵ
	bool AudioBrowse;			//طƵ
	bool SpeakerLive;			//ʵʱԤԽ
	bool SpeakerSpeak;
	bool SubscriptionAlarm;		//ı
}HS_USER_CHANNEL_RIGHTS;

typedef struct __tagHsUserChannelRightsList
{
	int Count;
	HS_USER_CHANNEL_RIGHTS *UserChannelRightsList;
}HS_USER_CHANNEL_RIGHTS_LIST;

///////////ϵͳȨϢ///////////////
typedef struct __tagHsSystemRightsInfo
{
	//ûϢ
	HS_USER_INFO UserInfo;
	//ûµͨȨϢ
	HS_USER_CHANNEL_RIGHTS *ChannelRightsList;
	int Count;
}HS_SYSTEM_RIGHTS_INFO;
///////////ͼ/////////////
typedef enum __enumHsViewItemType
{
	HS_UNKONWN_VIEW_ITEM,
	HS_CAMERA_VIEW_ITEM,
	HS_HTML_VIEW_ITEM,
	HS_IMAGE_VIEW_ITEM,
	HS_MAP_VIEW_ITEM,
	HS_CAROUSEL_VIEW_ITEM,
	HS_HOTSPOT_VIEW_ITEM,
}HS_VIEW_ITEM_TYPE;
////////////ͼѲϢ///////////////////
typedef struct __tagHsCarouselItem
{
	char Guid[48];
	char ItemInfoGuid[48];
	char ChannelGuid[48];
	int ShowTime;
	int Index;
	char DisplayName[64];
	HS_STREAM_TYPE VideoStreamType;
	int res;
}HS_CAROUSEL_ITEM;
///////////ͼϢ//////////////
typedef struct __tagHsViewItemInfo
{
	char Guid[48];
	char ViewItemGuid[48];
	char ChannelGuid[48];
	char Url[1024];
	char DisplayName[64];
	HS_CAROUSEL_ITEM *Carousels;
	int CarouselCount;
	HS_STREAM_TYPE VideoStreamType;
	int res;
}HS_VIEW_ITEM_INFO;
///////////ͼ///////////////////
typedef struct __tagHsViewItem
{
	char ViewItemGuid[48];
	char ViewGuid[48];
	char DisplayName[64];
	int ItemNumber;
	HS_VIEW_ITEM_TYPE ViewItemType; 
	HS_VIEW_ITEM_INFO ViewItemInfo;
	int res;
}HS_VIEW_ITEM;
///////////ͼ/////////////////
typedef enum __enumHsViewLayoutType
{
	HS_VIEW_LAYOUT_1x1,
	HS_VIEW_LAYOUT_2x2,
	HS_VIEW_LAYOUT_1and5,
	HS_VIEW_LAYOUT_2x3,
	HS_VIEW_LAYOUT_3x2,
	HS_VIEW_LAYOUT_1and7,
	HS_VIEW_LAYOUT_3x3,
	HS_VIEW_LAYOUT_1and12,
	HS_VIEW_LAYOUT_4x4,
	HS_VIEW_LAYOUT_2and18,
	HS_VIEW_LAYOUT_5x5,
	HS_VIEW_LAYOUT_6x6,
	HS_VIEW_LAYOUT_7x7,
	HS_VIEW_LAYOUT_8x8,
	HS_VIEW_LAYOUT_9x9,
	HS_VIEW_LAYOUT_10x10,

}HS_VIEW_LAYOUT_TYPE;

///////////͵ԣPĴ(Portrait)W(Widescreen)/////////////////
typedef enum __enumHsViewLayoutTypeProperty
{
	HS_VIEW_LAYOUT_PROPERTY_4_3,
	HS_VIEW_LAYOUT_PROPERTY_4_3_P,
	HS_VIEW_LAYOUT_PROPERTY_16_9,
	HS_VIEW_LAYOUT_PROPERTY_16_9_P,
	HS_VIEW_LAYOUT_PROPERTY_1_1,

}HS_VIEW_LAYOUT_TYPE_PROPERTY;

///////////ͼϢ//////////////////
typedef struct __tagHsViewInfo
{
	char ViewGuid[48];
	char GroupGuid[48];
	char DisplayName[64];
	HS_VIEW_LAYOUT_TYPE ViewLayoutType;
	//ԣ4:3  16:9
	HS_VIEW_LAYOUT_TYPE_PROPERTY ViewLayoutTypeProperty;
	//ͼͼ
	HS_VIEW_ITEM *ViewItems;
	int ViewItemCount;
	int ShowTime;       //Ѳʾʱ
	int EnableCarousel; //0:Ѳ,1:Ѳ
	int Res[2];
}HS_VIEW_INFO;
///////////Ϣ/////////////////
typedef struct __tagHsGroupInfo
{
	char GroupGuid[48];
	char ViewGroupGuid[48];
	char DisplayName[64];
	char ParentGroupGuid[48];
	//ͼ
	HS_VIEW_INFO *Views;
	int ViewCount;
}HS_GROUP_INFO;
///////////ͼ//////////////
typedef enum __enumHsViewGroupType
{
	HS_VIEW_GROUP_TYPE_UNKNOWN,
	HS_VIEW_GROUP_TYPE_SHARED = 1,
	HS_VIEW_GROUP_TYPE_PRIVATE = 3,
}HS_VIEW_GROUP_TYPE;

////////////ͼ/////////////////
typedef struct __tagHsViewGroupData
{
	HS_GROUP_INFO *Groups;
	int GroupCount;
}HS_VIEW_GROUP_DATA;
////////////ͼϢ/////////////////
typedef struct __tagHsViewGroupInfo
{
	char ViewGroupGuid[48];
	char UserGuid[48];
	bool ReadOnly;
	char DisplayName[64];
	HS_VIEW_GROUP_TYPE ViewGroupType;
	unsigned int LastModifiedTime;
	char LastModifiedUser[48];
}HS_VIEW_GROUP_INFO;

typedef struct __tagHsViewGroupInfoList
{
	int Count;
	HS_VIEW_GROUP_INFO *ViewGroupInfoList;
}HS_VIEW_GROUP_INFO_LIST;
////////////ͼ/////////////////
typedef struct __tagHsViewGroup
{
	//ͼϢ
	HS_VIEW_GROUP_INFO ViewGroupInfo;
	//ͼ
	HS_VIEW_GROUP_DATA ViewGroupData;
}HS_VIEW_GROUP;

typedef struct __tagHsViewGroupList
{
	int Count;
	HS_VIEW_GROUP *ViewGroupList;
}HS_VIEW_GROUP_LIST;

typedef enum __enumHsPictureType
{
	HS_PICTURE_JPEG = 0,//Ĭ
	HS_PICTURE_BMP,
	HS_PICTURE_PNG,
	HS_PICTURE_GIF,
}HS_PICTURE_TYPE;

typedef enum __enumHsVideoType
{
	HS_VIDEO_UNKNOWN = 0,//Ĭ
	HS_VIDEO_YUV,
	HS_VIDEO_RGB,
	HS_VIDEO_H264 = 96,
	HS_VIDEO_H265 = 150,
}HS_VIDEO_TYPE;

////////////ƬϢ////////////////////////
typedef struct __tagHsSliceInfo
{
	char VideoFileName[1024];//ӸƵļץ
	char PictureFileName[1024];//ͼƬı·
	int Quality;//ͼƬ0 - 100
	int Seek;//Ӹλýץ
	HS_PICTURE_TYPE PictureType;//ͼƬ
	HS_VIDEO_TYPE VideoType;

}HS_SLICE_INFO;

typedef struct __tagHsRect
{
	int    left;
	int    top;
	int    right;
	int    bottom;
}HS_RECT;
/******************************************************/
// Common Context
/******************************************************/ 
typedef struct __tagHsCommonContext
{
	unsigned int ContextID;

	unsigned int RegisterID;

	// private data, managered by implement
	void* PrivateData;

	// it will be called when free the struct
	void (*FreeProc)(void* context);
}HS_COMMON_CONTEXT;


/******************************************************/
// Codec Context
/******************************************************/ 
typedef struct __tagHsCodecContext
{
	HS_COMMON_CONTEXT Context;
	HS_CODEC_PARAM CodecParam;
}HS_CODEC_CONTEXT;
/******************************************************/
// Display Window Context
/******************************************************/ 

typedef struct __tagHsWindowContext
{
	HS_COMMON_CONTEXT Context;
	HS_WINDOW_PARAM WinParam;
}HS_WINDOW_CONTEXT;
/******************************************************/
// Device Context
/******************************************************/ 
typedef struct __tagHsDeviceContext
{
	HS_COMMON_CONTEXT Context;
	int  DeviceCount;
	HS_DEVICE_PARAM* DeviceParam;
}HS_DEVICE_CONTEXT;
/******************************************************/
// Channel Context
/******************************************************/ 
typedef struct __tagHsChannelContext
{
	HS_COMMON_CONTEXT Context;
	unsigned int DeviceContextID;
	int ChannelCount;
	HS_CHANNEL_PARAM* ChannelParam;
}HS_CHANNEL_CONTEXT;

#ifdef __cplusplus
}
#endif
#endif

