#ifndef  _MACRO_DEFINE
#define  _MACRO_DEFINE

#if defined __BUILD_DLL		/* build dll */
#define DLLAPI	 __declspec(dllexport)
#elif defined __BUILD_LIB	/* static library */
#define DLLAPI
#else						/* use dll */
#define DLLAPI	__declspec(dllimport)
#endif

#ifdef __cplusplus
extern "C"
{
#endif

typedef  enum LogLevel {
	LL_ERROR = 1,
	LL_DEBUG,
	LL_INFO,
	LL_CLOSE
}LogLevel;

/**
 * LogLevel ־
 * p_modulename ģ mysql
 * p_logdir  ־Ŀ¼
 * */
DLLAPI bool __stdcall HS_Log_Init(LogLevel l, const char* p_modulename, const char* p_logdir);

DLLAPI bool __stdcall HS_LOG_Write(LogLevel lev, char* logformat, ...);

DLLAPI void __stdcall HS_LOG_SetMaxLogFileSize(size_t size);


#ifdef __cplusplus
}
#endif


#define log_error(log_fmt, ...) \
    do{ \
        HS_LOG_Write(LL_ERROR,   "[%s:%d]"log_fmt, \
                     __FUNCTION__, __LINE__, ##__VA_ARGS__); \
    } while (0) 

#define log_info(log_fmt, ...) \
    do{ \
        HS_LOG_Write(LL_INFO,   "[%s:%d]"log_fmt, \
                     __FUNCTION__, __LINE__, ##__VA_ARGS__); \
    } while (0) 

#define log_debug(log_fmt, ...) \
    do{ \
        HS_LOG_Write(LL_DEBUG, "[%s:%d]"log_fmt, \
                     __FUNCTION__, __LINE__, ##__VA_ARGS__); \
    } while (0) 


#endif
